<?php
/** 
Plugin Name: Amazomatic Amazon Automatic Post Generator
Plugin URI: //1.envato.market/coderevolution
Description: This plugin will generate content for you, even in your sleep using Amazon feeds.
Author: CodeRevolution
Version: 2.0.0.6
Author URI: //coderevolution.ro
License: Commercial. For personal use only. Not to give away or resell.
Text Domain: amazomatic-amazon-post-generator
*/
/*  
Copyright 2016 - 2020 CodeRevolution
*/
defined('ABSPATH') or die();

function amazomatic_load_textdomain() {
    load_plugin_textdomain( 'amazomatic-amazon-post-generator', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
}
add_action( 'init', 'amazomatic_load_textdomain' );


function amazomatic_assign_var(&$target, $var) {
	static $cnt = 0;
    $key = key($var);
    if(is_array($var[$key])) 
        amazomatic_assign_var($target[$key], $var[$key]);
    else {
        if($key==0)
		{
			if($cnt == 0)
			{
				$target['_amazomaticr_nonce'] = $var[$key];
				$cnt++;
			}
			elseif($cnt == 1)
			{
				$target['_wp_http_referer'] = $var[$key];
				$cnt++;
			}
			else
			{
				$target[] = $var[$key];
			}
		}
        else
		{
            $target[$key] = $var[$key];
		}
    }   
}

$plugin = plugin_basename(__FILE__);
if(is_admin())
{
    if($_SERVER["REQUEST_METHOD"]==="POST" && !empty($_POST["coderevolution_max_input_var_data"])) {
    $vars = explode("&", $_POST["coderevolution_max_input_var_data"]);
    $coderevolution_max_input_var_data = array();
    foreach($vars as $var) {
        parse_str($var, $variable);
        amazomatic_assign_var($_POST, $variable);
    }
	unset($_POST["coderevolution_max_input_var_data"]);
}
    $plugin_slug = explode('/', $plugin);
    $plugin_slug = $plugin_slug[0];
    if(isset($_POST[$plugin_slug . '_register']) && isset($_POST[$plugin_slug. '_register_code']) && trim($_POST[$plugin_slug . '_register_code']) != '')
    {
        update_option('coderevolution_settings_changed', 1);
        if(strlen(trim($_POST[$plugin_slug . '_register_code'])) != 36 || strstr($_POST[$plugin_slug . '_register_code'], '-') == false)
        {
            amazomatic_log_to_file('Invalid registration code submitted: ' . $_POST[$plugin_slug . '_register_code']);
        }
        else
        {
            $ch = curl_init('https://wpinitiate.com/verify-purchase/purchase.php');
            if($ch !== false)
            {
                $data           = array();
                $data['code']   = trim($_POST[$plugin_slug . '_register_code']);
                $data['siteURL']   = get_bloginfo('url');
                $data['siteName']   = get_bloginfo('name');
                $data['siteEmail']   = get_bloginfo('admin_email');
                $fdata = "";
                foreach ($data as $key => $val) {
                    $fdata .= "$key=" . urlencode(trim($val)) . "&";
                }
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
                curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
                curl_setopt($ch, CURLOPT_TIMEOUT, 60);
                $result = curl_exec($ch);
                
                if($result === false)
                {
                    amazomatic_log_to_file('Failed to get verification response: ' . curl_error($ch));
                    curl_close($ch);
                }
                else
                {
                    curl_close($ch);
                    if($result == 'error1' || $result == 'error2' || $result == 'error3' || $result == 'error4')
                    {
                        amazomatic_log_to_file('Failed to validate plugin info: ' . $result);
                    }
                    else
                    {
                        $rj = json_decode($result, true);
                        if(isset($rj['item_name']))
                        {
                            $rj['code'] = $_POST[$plugin_slug . '_register_code'];
                            if($rj['item_id'] == '19763851' || $rj['item_id'] == '13371337' || $rj['item_id'] == '20390115' || $rj['item_id'] == '19200046')
                            {
                                update_option($plugin_slug . '_registration', $rj);
                                update_option('coderevolution_settings_changed', 2);
                            }
                            else
                            {
                                amazomatic_log_to_file('Invalid response from purchase code verification (are you sure you inputed the right purchase code?): ' . print_r($rj, true));
                            }
                        }
                        else
                        {
                            amazomatic_log_to_file('Invalid json from purchase code verification: ' . print_r($result, true));
                        }
                    }
                }
            }
            else
            {
                amazomatic_log_to_file('Failed to init curl when trying to make purchase verification.');
            }
        }
    }
    $uoptions = get_option($plugin_slug . '_registration', array());
    if(isset($uoptions['item_id']) && isset($uoptions['item_name']) && isset($uoptions['created_at']) && isset($uoptions['buyer']) && isset($uoptions['licence']) && isset($uoptions['supported_until']))
    {
        require "update-checker/plugin-update-checker.php";
        $fwdu3dcarPUC = Puc_v4_Factory::buildUpdateChecker("https://wpinitiate.com/auto-update/?action=get_metadata&slug=amazomatic-amazon-post-generator", __FILE__, "amazomatic-amazon-post-generator");
    }
    else
    {
        add_action("after_plugin_row_{$plugin}", function( $plugin_file, $plugin_data, $status ) {
            $plugin_url = 'https://codecanyon.net/item/amazomatic-amazon-affiliate-post-importing-money-generator-plugin-for-wordpress/19763851';
            echo '<tr class="active"><td>&nbsp;</td><td colspan="2"><p class="cr_auto_update">';
          echo sprintf( wp_kses( __( 'The plugin is not registered. Automatic updating is disabled. Please purchase a license for it from <a href="%s" target="_blank">here</a> and register  the plugin from the \'Main Settings\' menu using your purchase code. <a href="%s" target="_blank">How I find my purchase code?', 'amazomatic-amazon-post-generator'), array(  'a' => array( 'href' => array(), 'target' => array() ) ) ), esc_url( 'https://1.envato.market/c/1264868/275988/4415?u=' . urlencode($plugin_url)), esc_url('//www.youtube.com/watch?v=NElJ5t_Wd48') );     
          echo '</a></p> </td></tr>';
        }, 10, 3 );
        add_action('admin_enqueue_scripts', 'amazomatic_admin_enqueue_all');
        add_filter("plugin_action_links_$plugin", 'amazomatic_add_activation_link');
    }
}
function amazomatic_admin_enqueue_all()
{
    $reg_css_code = '.cr_auto_update{background-color:#fff8e5;margin:5px 20px 15px 20px;border-left:4px solid #fff;padding:12px 12px 12px 12px !important;border-left-color:#ffb900;}';
    wp_register_style( 'amazomatic-plugin-reg-style', false );
    wp_enqueue_style( 'amazomatic-plugin-reg-style' );
    wp_add_inline_style( 'amazomatic-plugin-reg-style', $reg_css_code );
}
function amazomatic_add_activation_link($links)
{
    $settings_link = '<a href="admin.php?page=amazomatic_admin_settings">' . esc_html__('Activate Plugin License', 'amazomatic-amazon-post-generator') . '</a>';
    array_push($links, $settings_link);
    return $links;
}

use \Eventviva\ImageResize;

add_action('admin_menu', 'amazomatic_register_my_custom_menu_page');
add_action('network_admin_menu', 'amazomatic_register_my_custom_menu_page');
function amazomatic_register_my_custom_menu_page()
{
    add_menu_page('Amazomatic Post Generator', 'Amazomatic Post Generator', 'manage_options', 'amazomatic_admin_settings', 'amazomatic_admin_settings', plugins_url('images/icon.png', __FILE__));
    $main_page = add_submenu_page('amazomatic_admin_settings', esc_html__("Main Settings", 'amazomatic-amazon-post-generator'), esc_html__("Main Settings", 'amazomatic-amazon-post-generator'), 'manage_options', 'amazomatic_admin_settings');
    add_action( 'load-' . $main_page, 'amazomatic_load_main_admin_js' );
    add_action( 'load-' . $main_page, 'amazomatic_load_all_admin_js' );
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if (isset($amazomatic_Main_Settings['amazomatic_enabled']) && $amazomatic_Main_Settings['amazomatic_enabled'] == 'on') {
        $search = add_submenu_page('amazomatic_admin_settings',esc_html__( 'Search to Posts', 'amazomatic-amazon-post-generator'), esc_html__('Search to Posts', 'amazomatic-amazon-post-generator'), 'manage_options', 'amazomatic_items_panel', 'amazomatic_items_panel');
        //$similar = add_submenu_page('amazomatic_admin_settings', esc_html__('Similar Items to Posts', 'amazomatic-amazon-post-generator'), esc_html__('Similar Items to Posts', 'amazomatic-amazon-post-generator'), 'manage_options', 'amazomatic_item_id_panel', 'amazomatic_item_id_panel');
        $asin = add_submenu_page('amazomatic_admin_settings', esc_html__('ASIN Lookup to Posts', 'amazomatic-amazon-post-generator'), esc_html__('ASIN Lookup to Posts', 'amazomatic-amazon-post-generator'), 'manage_options', 'amazomatic_lookup_panel', 'amazomatic_lookup_panel');
        $activity = add_submenu_page('amazomatic_admin_settings', esc_html__("Activity & Logging", 'amazomatic-amazon-post-generator'), esc_html__("Activity & Logging", 'amazomatic-amazon-post-generator'), 'manage_options', 'amazomatic_logs', 'amazomatic_logs');
        $help = add_submenu_page('amazomatic_admin_settings', esc_html__('Amazomatic Help', 'amazomatic-amazon-post-generator'), esc_html__('Amazomatic Help', 'amazomatic-amazon-post-generator'), 'manage_options', 'amazomatic_help_panel', 'amazomatic_help_panel');
        add_action( 'load-' . $search, 'amazomatic_load_all_admin_js' );
        add_action( 'load-' . $search, 'amazomatic_load_rules_admin_css' );
        add_action( 'load-' . $search, 'amazomatic_load_admin_js' );
        add_action( 'load-' . $asin, 'amazomatic_load_all_admin_js' );
        add_action( 'load-' . $asin, 'amazomatic_load_rules_admin_css' );
        add_action( 'load-' . $asin, 'amazomatic_load_admin_js' );
        //add_action( 'load-' . $similar, 'amazomatic_load_all_admin_js' );
        //add_action( 'load-' . $similar, 'amazomatic_load_rules_admin_css' );
        //add_action( 'load-' . $similar, 'amazomatic_load_admin_js' );
        add_action( 'load-' . $activity, 'amazomatic_load_all_admin_js' );
        add_action( 'load-' . $help, 'amazomatic_load_all_admin_js' );
    }
}

function amazomatic_load_admin_js(){
    add_action('admin_enqueue_scripts', 'amazomatic_enqueue_admin_js');
}

function amazomatic_enqueue_admin_js(){
    wp_enqueue_script('amazomatic-footer-script', plugins_url('scripts/footer.js', __FILE__), array('jquery'), false, true);
    $cr_miv = ini_get('max_input_vars');
	if($cr_miv === null || $cr_miv === false || !is_numeric($cr_miv))
	{
        $cr_miv = '9999999';
    }
    $footer_conf_settings = array(
        'max_input_vars' => $cr_miv,
        'plugin_dir_url' => plugin_dir_url(__FILE__),
        'ajaxurl' => admin_url('admin-ajax.php')
    );
    wp_localize_script('amazomatic-footer-script', 'mycustomsettings', $footer_conf_settings);
}
function amazomatic_load_rules_admin_css(){
    add_action('admin_enqueue_scripts', 'amazomatic_rules_load_css');
}
function amazomatic_rules_load_css()
{
    wp_register_style('amazomatic-rules-style', plugins_url('styles/amazomatic-rules.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('amazomatic-rules-style');
}
function amazomatic_load_all_admin_js(){
    add_action('admin_enqueue_scripts', 'amazomatic_admin_load_files');
}
function amazomatic_load_main_admin_js(){
    add_action('admin_enqueue_scripts', 'amazomatic_enqueue_main_admin_js');
}

function amazomatic_enqueue_main_admin_js(){
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    wp_enqueue_script('amazomatic-main-script', plugins_url('scripts/main.js', __FILE__), array('jquery'));
    if(!isset($amazomatic_Main_Settings['best_user']))
    {
        $best_user = '';
    }
    else
    {
        $best_user = $amazomatic_Main_Settings['best_user'];
    }
    if(!isset($amazomatic_Main_Settings['best_password']))
    {
        $best_password = '';
    }
    else
    {
        $best_password = $amazomatic_Main_Settings['best_password'];
    }
    $header_main_settings = array(
        'best_user' => $best_user,
        'best_password' => $best_password
    );
    wp_localize_script('amazomatic-main-script', 'mycustommainsettings', $header_main_settings);
}
function amazomatic_add_rating_link($links)
{
    $settings_link = '<a href="//codecanyon.net/downloads" target="_blank" title="Rate">
            <i class="wdi-rate-stars"><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg></i></a>';
    array_push($links, $settings_link);
    return $links;
}
add_filter("plugin_action_links_$plugin", 'amazomatic_add_support_link');
function amazomatic_add_support_link($links)
{
    $settings_link = '<a href="//coderevolution.ro/knowledge-base/" target="_blank">' . esc_html__('Support', 'amazomatic-amazon-post-generator') . '</a>';
    array_push($links, $settings_link);
    return $links;
}
add_filter("plugin_action_links_$plugin", 'amazomatic_add_settings_link');
add_filter("plugin_action_links_$plugin", 'amazomatic_add_rating_link');
function amazomatic_add_settings_link($links)
{
    $settings_link = '<a href="admin.php?page=amazomatic_admin_settings">' . esc_html__('Settings', 'amazomatic-amazon-post-generator') . '</a>';
    array_push($links, $settings_link);
    return $links;
}
add_action('add_meta_boxes', 'amazomatic_add_meta_box');
function amazomatic_add_meta_box()
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if (isset($amazomatic_Main_Settings['amazomatic_enabled']) && $amazomatic_Main_Settings['amazomatic_enabled'] === 'on') {
        if (isset($amazomatic_Main_Settings['enable_metabox']) && $amazomatic_Main_Settings['enable_metabox'] == 'on') {
            foreach ( get_post_types( '', 'names' ) as $post_type ) {
               add_meta_box('amazomatic_meta_box_function_add', esc_html__('Amazomatic Automatic Post Generator Information', 'amazomatic-amazon-post-generator'), 'amazomatic_meta_box_function', $post_type, 'advanced', 'default', array('__back_compat_meta_box' => true));
            }
            
        }
    }
}

add_filter('cron_schedules', 'amazomatic_add_cron_schedule');
function amazomatic_add_cron_schedule($schedules)
{
    $schedules['amazomatic_cron'] = array(
        'interval' => 3600,
        'display' => esc_html__('Amazomatic Cron', 'amazomatic-amazon-post-generator')
    );
    $schedules['minutely'] = array(
        'interval' => 60,
        'display' => esc_html__('Once A Minute', 'amazomatic-amazon-post-generator')
    );
    $schedules['weekly']        = array(
        'interval' => 604800,
        'display' => esc_html__('Once Weekly', 'amazomatic-amazon-post-generator')
    );
    $schedules['monthly']       = array(
        'interval' => 2592000,
        'display' => esc_html__('Once Monthly', 'amazomatic-amazon-post-generator')
    );
    return $schedules;
}
function amazomatic_auto_clear_log()
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
       wp_filesystem($creds);
    }
    if ($wp_filesystem->exists(WP_CONTENT_DIR . '/amazomatic_info.log')) {
        $wp_filesystem->delete(WP_CONTENT_DIR . '/amazomatic_info.log');
    }
}

register_deactivation_hook(__FILE__, 'amazomatic_my_deactivation');
function amazomatic_my_deactivation()
{
    wp_clear_scheduled_hook('amazomaticaction');
    wp_clear_scheduled_hook('amazomaticactionclear');
    $running = array();
    update_option('amazomatic_running_list', $running, false);
}
add_action('amazomaticaction', 'amazomatic_cron');
add_action('amazomaticactionclear', 'amazomatic_auto_clear_log');

function amazomatic_builtin_spin_text($title, $content)
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    $titleSeparator         = '[19459000]';
    $text                   = $title . $titleSeparator . $content;
    $text                   = html_entity_decode($text);
    preg_match_all("/<[^<>]+>/is", $text, $matches, PREG_PATTERN_ORDER);
    $htmlfounds         = array_filter(array_unique($matches[0]));
    $htmlfounds[]       = '&quot;';
    $imgFoundsSeparated = array();
    foreach ($htmlfounds as $key => $currentFound) {
        if (stristr($currentFound, '<img') && stristr($currentFound, 'alt')) {
            $altSeparator   = '';
            $colonSeparator = '';
            if (stristr($currentFound, 'alt="')) {
                $altSeparator   = 'alt="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt = "')) {
                $altSeparator   = 'alt = "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt ="')) {
                $altSeparator   = 'alt ="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt= "')) {
                $altSeparator   = 'alt= "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt=\'')) {
                $altSeparator   = 'alt=\'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt = \'')) {
                $altSeparator   = 'alt = \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt= \'')) {
                $altSeparator   = 'alt= \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt =\'')) {
                $altSeparator   = 'alt =\'';
                $colonSeparator = '\'';
            }
            if (trim($altSeparator) != '') {
                $currentFoundParts = explode($altSeparator, $currentFound);
                $preAlt            = $currentFoundParts[1];
                $preAltParts       = explode($colonSeparator, $preAlt);
                $altText           = $preAltParts[0];
                if (trim($altText) != '') {
                    unset($preAltParts[0]);
                    $imgFoundsSeparated[] = $currentFoundParts[0] . $altSeparator;
                    $imgFoundsSeparated[] = $colonSeparator . implode('', $preAltParts);
                    $htmlfounds[$key]     = '';
                }
            }
        }
    }
    if (count($imgFoundsSeparated) != 0) {
        $htmlfounds = array_merge($htmlfounds, $imgFoundsSeparated);
    }
    preg_match_all("/<\!--.*?-->/is", $text, $matches2, PREG_PATTERN_ORDER);
    $newhtmlfounds = $matches2[0];
    preg_match_all("/\[.*?\]/is", $text, $matches3, PREG_PATTERN_ORDER);
    $shortcodesfounds = $matches3[0];
    $htmlfounds       = array_merge($htmlfounds, $newhtmlfounds, $shortcodesfounds);
    $in               = 0;
    $cleanHtmlFounds  = array();
    foreach ($htmlfounds as $htmlfound) {
        if ($htmlfound == '[19459000]') {
        } elseif (trim($htmlfound) == '') {
        } else {
            $cleanHtmlFounds[] = $htmlfound;
        }
    }
    $htmlfounds = $cleanHtmlFounds;
    $start      = 19459001;
    foreach ($htmlfounds as $htmlfound) {
        $text = str_replace($htmlfound, '[' . $start . ']', $text);
        $start++;
    }
    try {
        $file=file(dirname(__FILE__)  .'/res/synonyms.dat');
		foreach($file as $line){
			$synonyms=explode('|',$line);
			foreach($synonyms as $word){
				if(trim($word) != ''){
                    $word=str_replace('/','\/',$word);
					if(preg_match('/\b'. $word .'\b/u', $text)) {
						$rand = array_rand($synonyms, 1);
						$text = preg_replace('/\b'.$word.'\b/u', trim($synonyms[$rand]), $text);
					}
                    $uword=ucfirst($word);
					if(preg_match('/\b'. $uword .'\b/u', $text)) {
						$rand = array_rand($synonyms, 1);
						$text = preg_replace('/\b'.$uword.'\b/u', ucfirst(trim($synonyms[$rand])), $text);
					}
				}
			}
		}
        $translated = $text;
    }
    catch (Exception $e) {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('Exception thrown in spinText ' . $e);
        }
        return false;
    }
    preg_match_all('{\[.*?\]}', $translated, $brackets);
    $brackets = $brackets[0];
    $brackets = array_unique($brackets);
    foreach ($brackets as $bracket) {
        if (stristr($bracket, '19')) {
            $corrrect_bracket = str_replace(' ', '', $bracket);
            $corrrect_bracket = str_replace('.', '', $corrrect_bracket);
            $corrrect_bracket = str_replace(',', '', $corrrect_bracket);
            $translated       = str_replace($bracket, $corrrect_bracket, $translated);
        }
    }
    if (stristr($translated, $titleSeparator)) {
        $start = 19459001;
        foreach ($htmlfounds as $htmlfound) {
            $translated = str_replace('[' . $start . ']', $htmlfound, $translated);
            $start++;
        }
        $contents = explode($titleSeparator, $translated);
        $title    = $contents[0];
        $content  = $contents[1];
    } else {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('Failed to parse spinned content, separator not found');
        }
        return false;
    }
    return array(
        $title,
        $content
    );
}

function amazomatic_cron_schedule()
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if (isset($amazomatic_Main_Settings['amazomatic_enabled']) && $amazomatic_Main_Settings['amazomatic_enabled'] === 'on') {
        if (!wp_next_scheduled('amazomaticaction')) {
            $rez = wp_schedule_event(time(), 'hourly', 'amazomaticaction');
            if ($rez === FALSE) {
                amazomatic_log_to_file('[Scheduler] Failed to schedule amazomaticaction to amazomatic_cron!');
            }
        }
        
        if (isset($amazomatic_Main_Settings['enable_logging']) && $amazomatic_Main_Settings['enable_logging'] === 'on' && isset($amazomatic_Main_Settings['auto_clear_logs']) && $amazomatic_Main_Settings['auto_clear_logs'] !== 'No') {
            if (!wp_next_scheduled('amazomaticactionclear')) {
                $rez = wp_schedule_event(time(), $amazomatic_Main_Settings['auto_clear_logs'], 'amazomaticactionclear');
                if ($rez === FALSE) {
                    amazomatic_log_to_file('[Scheduler] Failed to schedule amazomaticactionclear to ' . $amazomatic_Main_Settings['auto_clear_logs'] . '!');
                }
                add_option('amazomatic_schedule_time', $amazomatic_Main_Settings['auto_clear_logs']);
            } else {
                if (!get_option('amazomatic_schedule_time')) {
                    wp_clear_scheduled_hook('amazomaticactionclear');
                    $rez = wp_schedule_event(time(), $amazomatic_Main_Settings['auto_clear_logs'], 'amazomaticactionclear');
                    add_option('amazomatic_schedule_time', $amazomatic_Main_Settings['auto_clear_logs']);
                    if ($rez === FALSE) {
                        amazomatic_log_to_file('[Scheduler] Failed to schedule amazomaticactionclear to ' . $amazomatic_Main_Settings['auto_clear_logs'] . '!');
                    }
                } else {
                    $the_time = get_option('amazomatic_schedule_time');
                    if ($the_time != $amazomatic_Main_Settings['auto_clear_logs']) {
                        wp_clear_scheduled_hook('amazomaticactionclear');
                        delete_option('amazomatic_schedule_time');
                        $rez = wp_schedule_event(time(), $amazomatic_Main_Settings['auto_clear_logs'], 'amazomaticactionclear');
                        add_option('amazomatic_schedule_time', $amazomatic_Main_Settings['auto_clear_logs']);
                        if ($rez === FALSE) {
                            amazomatic_log_to_file('[Scheduler] Failed to schedule amazomaticactionclear to ' . $amazomatic_Main_Settings['auto_clear_logs'] . '!');
                        }
                    }
                }
            }
        } else {
            if (!wp_next_scheduled('amazomaticactionclear')) {
                delete_option('amazomatic_schedule_time');
            } else {
                wp_clear_scheduled_hook('amazomaticactionclear');
                delete_option('amazomatic_schedule_time');
            }
        }
        if(isset($amazomatic_Main_Settings['auto_update_posts']) && $amazomatic_Main_Settings['auto_update_posts'] !== 'No')
        {
            if (!wp_next_scheduled( 'amazomaticactionupdate')) 
            {
                $rez = wp_schedule_event(time(), $amazomatic_Main_Settings['auto_update_posts'], 'amazomaticactionupdate' );
                add_option('amazomatic_schedule_update_time', $amazomatic_Main_Settings['auto_update_posts']);
                if($rez === FALSE)
                {
                    amazomatic_log_to_file ('[Scheduler] Failed to schedule amazomaticactionupdate to ' . $amazomatic_Main_Settings['auto_update_posts'] . '!', '0', 8, '1');
                }
            }
            else
            {
                if (!get_option('amazomatic_schedule_update_time')) {
                    wp_clear_scheduled_hook( 'amazomaticactionupdate' );
                    $rez = wp_schedule_event(time(), $amazomatic_Main_Settings['auto_update_posts'], 'amazomaticactionupdate' );
                    add_option('amazomatic_schedule_update_time', $amazomatic_Main_Settings['auto_update_posts']);
                    if($rez === FALSE)
                    {
                       amazomatic_log_to_file ('[Scheduler] Failed to schedule amazomaticactionupdate to ' . $amazomatic_Main_Settings['auto_update_posts'] . '!', '0', 8, '1');
                    }
                }
                else
                {
                    $the_time = get_option('amazomatic_schedule_update_time');
                    if($the_time != $amazomatic_Main_Settings['auto_update_posts'])
                    {
                        wp_clear_scheduled_hook( 'amazomaticactionupdate' );
                        delete_option('amazomatic_schedule_update_time');
                        $rez = wp_schedule_event(time(), $amazomatic_Main_Settings['auto_update_posts'], 'amazomaticactionupdate' );
                        add_option('amazomatic_schedule_update_time', $amazomatic_Main_Settings['auto_update_posts']);
                        if($rez === FALSE)
                        {
                            amazomatic_log_to_file ('[Scheduler] Failed to schedule amazomaticactionupdate to ' . $amazomatic_Main_Settings['auto_update_posts'] . '!', '0', 8, '1');
                        }
                    }
                }
            }
        }
        else
        {
            if (!wp_next_scheduled( 'amazomaticactionupdate' )) 
            {
                delete_option('amazomatic_schedule_update_time');
            }
            else
            {
                wp_clear_scheduled_hook( 'amazomaticactionupdate' );
                delete_option('amazomatic_schedule_update_time');
            }
        }
    } else {
        if (wp_next_scheduled('amazomaticaction')) {
            wp_clear_scheduled_hook('amazomaticaction');
        }
        
        if (!wp_next_scheduled('amazomaticactionclear')) {
            delete_option('amazomatic_schedule_time');
        } else {
            wp_clear_scheduled_hook('amazomaticactionclear');
            delete_option('amazomatic_schedule_time');
        }
        if (!wp_next_scheduled( 'amazomaticactionupdate' )) 
        {
            delete_option('amazomatic_schedule_update_time');
        }
        else
        {
            wp_clear_scheduled_hook( 'amazomaticactionupdate' );
            delete_option('amazomatic_schedule_update_time');
        }
    }
}
function amazomatic_cron()
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    $GLOBALS['wp_object_cache']->delete('amazomatic_rules_list', 'options');
    if (!get_option('amazomatic_rules_list')) {
        $rules = array();
    } else {
        $rules = get_option('amazomatic_rules_list');
    }
    $rule_run = false;
    if (!empty($rules)) {
        $cont = 0;
        foreach ($rules as $request => $bundle[]) {
            $bundle_values   = array_values($bundle);
            $myValues        = $bundle_values[$cont];
            $array_my_values = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}}
            $schedule        = isset($array_my_values[1]) ? $array_my_values[1] : '24';
            $active          = isset($array_my_values[2]) ? $array_my_values[2] : '0';
            $last_run        = isset($array_my_values[3]) ? $array_my_values[3] : amazomatic_get_date_now();
            if ($active == '1') {
                $now                = amazomatic_get_date_now();
                $nextrun            = amazomatic_add_hour($last_run, $schedule);
                $amazomatic_hour_diff = (int) amazomatic_hour_diff($now, $nextrun);
                if ($amazomatic_hour_diff >= 0) {
                    if($rule_run === false)
                    {
                        $rule_run = true;
                    }
                    else
                    {
                        if (isset($amazomatic_Main_Settings['rule_delay']) && $amazomatic_Main_Settings['rule_delay'] !== '')
                        {
                            sleep($amazomatic_Main_Settings['rule_delay']);
                        }
                    }
                    amazomatic_run_rule($cont, 0);
                }
            }
            $cont = $cont + 1;
        }
    }
    $rule_run = false;
    if (!get_option('amazomatic_item_list')) {
        $rules2 = array();
    } else {
        $rules2 = get_option('amazomatic_item_list');
    }
    if (!empty($rules2)) {
        $cont = 0;
        foreach ($rules2 as $request2 => $bundle2[]) {
            $bundle_values2   = array_values($bundle2);
            $myValues2        = $bundle_values2[$cont];
            $array_my_values2 = array_values($myValues2);for($iji=0;$iji<count($array_my_values2);++$iji){if(is_string($array_my_values2[$iji])){$array_my_values2[$iji]=stripslashes($array_my_values2[$iji]);}}
            $schedule2        = isset($array_my_values2[1]) ? $array_my_values2[1] : '24';
            $active2          = isset($array_my_values2[2]) ? $array_my_values2[2] : '0';
            $last_run2        = isset($array_my_values2[3]) ? $array_my_values2[3] : amazomatic_get_date_now();
            if ($active2 == '1') {
                $now2                = amazomatic_get_date_now();
                $nextrun2            = amazomatic_add_hour($last_run2, $schedule2);
                $amazomatic_hour_diff2 = (int) amazomatic_hour_diff($now2, $nextrun2);
                if ($amazomatic_hour_diff2 >= 0) {
                    if($rule_run === false)
                    {
                        $rule_run = true;
                    }
                    else
                    {
                        if (isset($amazomatic_Main_Settings['rule_delay']) && $amazomatic_Main_Settings['rule_delay'] !== '')
                        {
                            sleep($amazomatic_Main_Settings['rule_delay']);
                        }
                    }
                    amazomatic_run_rule($cont, 1);
                }
            }
            $cont = $cont + 1;
        }
    }
    $rule_run = false;
    $GLOBALS['wp_object_cache']->delete('amazomatic_lookup_list', 'options');
    if (!get_option('amazomatic_lookup_list')) {
        $rules3 = array();
    } else {
        $rules3 = get_option('amazomatic_lookup_list');
    }
    if (!empty($rules3)) {
        $cont = 0;
        foreach ($rules3 as $request3 => $bundle3[]) {
            $bundle_values3   = array_values($bundle3);
            $myValues3        = $bundle_values3[$cont];
            $array_my_values3 = array_values($myValues3);for($iji=0;$iji<count($array_my_values3);++$iji){if(is_string($array_my_values3[$iji])){$array_my_values3[$iji]=stripslashes($array_my_values3[$iji]);}}
            $schedule3        = isset($array_my_values3[1]) ? $array_my_values3[1] : '24';
            $active3          = isset($array_my_values3[2]) ? $array_my_values3[2] : '0';
            $last_run3        = isset($array_my_values3[3]) ? $array_my_values3[3] : amazomatic_get_date_now();
            if ($active3 == '1') {
                $now3                = amazomatic_get_date_now();
                $nextrun3            = amazomatic_add_hour($last_run3, $schedule3);
                $amazomatic_hour_diff3 = (int) amazomatic_hour_diff($now3, $nextrun3);
                if ($amazomatic_hour_diff3 >= 0) {
                    if($rule_run === false)
                    {
                        $rule_run = true;
                    }
                    else
                    {
                        if (isset($amazomatic_Main_Settings['rule_delay']) && $amazomatic_Main_Settings['rule_delay'] !== '')
                        {
                            sleep($amazomatic_Main_Settings['rule_delay']);
                        }
                    }
                    amazomatic_run_rule($cont, 2);
                }
            }
            $cont = $cont + 1;
        }
    }
    $running = array();
    update_option('amazomatic_running_list', $running);
}

function amazomatic_extractKeyWords($string, $count = 10)
{
    $stopwords = array();
    $string = trim(preg_replace('/\s\s+/iu', '\s', strtolower($string)));
    $string = wp_strip_all_tags($string);
    $matchWords   = array_filter(explode(' ', $string), function($item) use ($stopwords)
    {
        return !($item == '' || in_array($item, $stopwords) || strlen($item) <= 2 || ctype_alnum(trim(str_replace(' ', '', $item))) === FALSE || is_numeric($item));
    });
    $rem_arr = array('and', 'you', 'all', 'here' , 'for', 'the', 'this' , 'that' , 'then' , 'make' , 'what' , 'which' , 'where' , 'when' , 'does' , 'with' , 'while' , 'your' , 'other' , 'will');
    foreach($rem_arr as $rma)
    {
        while (($key = array_search($rma, $matchWords)) !== false) 
        {
            unset($matchWords[$key]);
        }
    }
    
    $wordCountArr = array_count_values($matchWords);
    arsort($wordCountArr);
    return array_keys(array_slice($wordCountArr, 0, $count));
}

function amazomatic_log_to_file($str)
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if (isset($amazomatic_Main_Settings['enable_logging']) && $amazomatic_Main_Settings['enable_logging'] == 'on') {
        $d = date("j-M-Y H:i:s e", current_time( 'timestamp' ));
        error_log("[$d] " . $str . "<br/>\r\n", 3, WP_CONTENT_DIR . '/amazomatic_info.log');
    }
}
function amazomatic_delete_all_posts()
{
    $failed                 = false;
    $number                 = 0;
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    
    $post_list = array();
    $postsPerPage = 50000;
    $paged = 0;
    do
    {
        $postOffset = $paged * $postsPerPage;
        $query = array(
            'post_status' => array(
                'publish',
                'draft',
                'pending',
                'trash',
                'private',
                'future'
            ),
            'post_type' => array(
                'any'
            ),
            'numberposts' => $postsPerPage,
            'meta_key' => 'amazomatic_parent_rule',
            'fields' => 'ids',
            'offset'  => $postOffset
        );
        $got_me = get_posts($query);
        $post_list = array_merge($post_list, $got_me);
        $paged++;
    }while(!empty($got_me));
    
    wp_suspend_cache_addition(true);
    foreach ($post_list as $post) {
        $index = get_post_meta($post, 'amazomatic_parent_rule', true);
        $parent_type = get_post_meta($post, 'amazomatic_parent_type', true);
        if (isset($index) && $index !== '' && isset($parent_type) && $parent_type !== '') {
            $args             = array(
                'post_parent' => $post
            );
            $post_attachments = get_children($args);
            if (isset($post_attachments) && !empty($post_attachments)) {
                foreach ($post_attachments as $attachment) {
                    wp_delete_attachment($attachment->ID, true);
                }
            }
            $res = wp_delete_post($post, true);
            if ($res === false) {
                $failed = true;
            } else {
                $number++;
            }
        }
    }
    wp_suspend_cache_addition(false);
    if ($failed === true) {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('[PostDelete] Failed to delete all posts!');
        }
    } else {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('[PostDelete] Successfuly deleted ' . esc_html($number) . ' posts!');
        }
    }
}

function amazomatic_replaceContentShortcodesAgain($the_content, $item_cat, $item_tags)
{
    $the_content = str_replace('%%item_cat%%', $item_cat, $the_content);
    $the_content = str_replace('%%item_tags%%', $item_tags, $the_content);
    return $the_content;
}
function amazomatic_replaceContentShortcodes($the_content, $just_title, $content, $item_url, $item_image, $description, $author, $author_link, $id, $my_post)
{
    $the_content = str_replace('%%random_sentence%%', amazomatic_random_sentence_generator(), $the_content);
    $the_content = str_replace('%%random_sentence2%%', amazomatic_random_sentence_generator(false), $the_content);
    $the_content = amazomatic_replaceSynergyShortcodes($the_content);
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if (isset($amazomatic_Main_Settings['custom_html'])) {
        $the_content = str_replace('%%custom_html%%', $amazomatic_Main_Settings['custom_html'], $the_content);
    }
    if (isset($amazomatic_Main_Settings['custom_html2'])) {
        $the_content = str_replace('%%custom_html2%%', $amazomatic_Main_Settings['custom_html2'], $the_content);
    }
    $the_content = str_replace('%%item_sales_rank%%', $my_post['amazon_sales_rank'], $the_content);
    $the_content = str_replace('%%item_title%%', $just_title, $the_content);
    $the_content = str_replace('%%item_title_encoded%%', urlencode($just_title), $the_content);
    $the_content = str_replace('%%item_content%%', $content, $the_content);
    $the_content = str_replace('%%item_ASIN%%', $id, $the_content);
    $the_content = str_replace('%%last_update_time%%', date("Y-m-d H:i:s", time()), $the_content);
    $add_to_cart_url = 'http://www.amazon.com/gp/aws/cart/add.html?&ASIN.1=' . esc_html($id) . '&Quantity.1=1';
    $the_content = str_replace('%%item_add_to_cart_url%%', $add_to_cart_url, $the_content);
    if (isset($amazomatic_Main_Settings['add_cart']) && $amazomatic_Main_Settings['add_cart'] != '') {
		$add_cart = $amazomatic_Main_Settings['add_cart'];
	}
	else
	{
		$add_cart = esc_html__('Add to cart', 'amazomatic-amazon-post-generator');
	}
    $the_content = str_replace('%%item_add_to_cart_button%%', amazomatic_getNamedButton($add_to_cart_url, $add_cart, $amazomatic_Main_Settings), $the_content);
    $the_content = str_replace('%%item_url%%', $item_url, $the_content);
    $the_content = str_replace('%%item_content_plain_text%%', amazomatic_getPlainContent($content), $the_content);
	if (isset($amazomatic_Main_Settings['buy_now']) && $amazomatic_Main_Settings['buy_now'] != '') {
		$buy_now = $amazomatic_Main_Settings['buy_now'];
	}
	else
	{
		$buy_now = esc_html__('Buy Now', 'amazomatic-amazon-post-generator');
	}
    $the_content = str_replace('%%item_buy_now_button%%', amazomatic_getNamedButton($item_url, $buy_now, $amazomatic_Main_Settings, "amazomatic_buy_now"), $the_content);
    $the_content = str_replace('%%item_show_image%%', amazomatic_getItemImage($item_image), $the_content);
    $the_content = str_replace('%%item_image_URL%%', $item_image, $the_content);
    $the_content = str_replace('%%item_description%%', $description, $the_content);
    $the_content = str_replace('%%item_binding_category%%', $my_post['amazomatic_binding_category'], $the_content);
    $the_content = str_replace('%%item_brand%%', $my_post['amazomatic_brand'], $the_content);
    $ft = '<ul>';
    foreach($my_post['amazomatic_feature_list'] as $feature)
    {
        $ft .= '<li>' . esc_html($feature) . '</li>';
    }
    $ft .= '</ul>';
    $the_content = str_replace('%%item_features%%', $ft, $the_content);
    $the_content = str_replace('%%item_color%%', $my_post['amazomatic_color'], $the_content);
    $the_content = str_replace('%%item_is_adult_product%%', $my_post['amazomatic_is_adult_product'], $the_content);
    if($my_post['amazomatic_price'] != '')
    {
        if($my_post['amazomatic_offer_price'] != '' && $my_post['amazomatic_price'] != $my_post['amazomatic_offer_price'] && intval(str_replace("$","",$my_post['amazomatic_price'])) > intval(str_replace("$","",$my_post['amazomatic_offer_price'])))
        {
            $price = '<del>' . esc_html($my_post['amazomatic_price']) . '</del>&nbsp;' . esc_html($my_post['amazomatic_offer_price']);
        }
        else
        {
            $price = esc_html($my_post['amazomatic_price']);
        }
    }
    else
    {
        $price = esc_html__('Free', 'amazomatic-amazon-post-generator');
    }
    if (isset($amazomatic_Main_Settings['remove_dollar']) && $amazomatic_Main_Settings['remove_dollar'] == 'on') {
        $price = str_replace('$', '', $price);
    }
    $the_content = str_replace('%%item_price%%', $price, $the_content);
    $the_content = str_replace('%%item_manufacturer%%', $my_post['amazomatic_manufacturer'], $the_content);
    $the_content = str_replace('%%item_size%%', $my_post['amazomatic_size'], $the_content);
    $the_content = str_replace('%%item_offer_price%%', $my_post['amazomatic_offer_price'], $the_content);
    $the_content = str_replace('%%item_get_intro%%', amazomatic_getIntro($just_title, $item_url, $item_image, $author, $my_post), $the_content);
    $item_all_images = '';
    foreach($my_post['amazomatic_image_set'] as $img)
    {
        $item_all_images .= '<div><img src="' . esc_url($img) . '" alt="image" class="crf_img_set" onclick=\'window.open("' . esc_url($img) . '");\'/></div>';
    }
    if($item_all_images != '')
    {
        $item_all_images = '<div class="amazomatic_gallery amazomatic_cf">' . $item_all_images . '</div>';
    }

    $the_content = str_replace('%%item_edition%%', $my_post['edition'], $the_content);
    $the_content = str_replace('%%item_language%%', $my_post['language'], $the_content);
    $the_content = str_replace('%%item_pages_count%%', $my_post['pages_count'], $the_content);
    $the_content = str_replace('%%item_publication_date%%', $my_post['publication_date'], $the_content);
    $the_content = str_replace('%%item_contributors%%', $my_post['contributors'], $the_content);
    $the_content = str_replace('%%item_product_group%%', $my_post['product_group'], $the_content);
    $the_content = str_replace('%%item_rating%%', $my_post['rating'], $the_content);
    $the_content = str_replace('%%item_eans%%', $my_post['eans'], $the_content);
    $the_content = str_replace('%%item_isbns%%', $my_post['isbns'], $the_content);
    $the_content = str_replace('%%item_upcs%%', $my_post['upcs'], $the_content);
    $the_content = str_replace('%%item_part_no%%', $my_post['part_no'], $the_content);
    $the_content = str_replace('%%item_model%%', $my_post['model'], $the_content);
    $the_content = str_replace('%%item_warranty%%', $my_post['warranty'], $the_content);
    $the_content = str_replace('%%item_color%%', $my_post['color'], $the_content);
    $the_content = str_replace('%%item_is_adult%%', $my_post['is_adult'], $the_content);
    $the_content = str_replace('%%item_dimensions%%', $my_post['dimensions'], $the_content);
    $the_content = str_replace('%%item_unit_count%%', $my_post['unit_count'], $the_content);
    $the_content = str_replace('%%item_condition%%', $my_post['condition'], $the_content);
    $the_content = str_replace('%%item_all_images%%', $item_all_images, $the_content);
    $the_content = str_replace('%%author%%', $author, $the_content);
    $the_content = str_replace('%%author_link%%', $author_link, $the_content);
    return $the_content;
}
function amazomatic_getFacebookButton($url, $amazomatic_Main_Settings)
{
    $button = '<a ';
	if(isset($amazomatic_Main_Settings['rel_nofollow']) && $amazomatic_Main_Settings['rel_nofollow'] == 'on')
    {
		$button .= ' rel="nofollow"';
	}		
	$button .= ' class="crf_twitt amazomatic_btn button purchase" href="https://www.facebook.com/sharer/sharer.php?display=popup&ref=plugin&src=share_button&u=' . urlencode($url) . '" onclick="return !window.open(this.href, \'Facebook\', \'width=640,height=580\')"><img src="' . amazomatic_get_file_url('images/facebook.png') . '" alt="Facebook" class="crf_social_img"></a>';
    return $button;
}
function amazomatic_getTwitterButton($url, $item_title, $amazomatic_Main_Settings)
{
    $button = '<a ';
	if(isset($amazomatic_Main_Settings['rel_nofollow']) && $amazomatic_Main_Settings['rel_nofollow'] == 'on')
    {
		$button .= ' rel="nofollow"';
	}		
	$button .= ' class="crf_twitt amazomatic_btn button purchase" href="https://twitter.com/intent/tweet?text=Check+out+%27' . urlencode($item_title) . '%27+on+%23Amazon&url=' . urlencode($url) . '" onclick="return !window.open(this.href, \'Twitter\', \'width=640,height=580\')"><img src="' . amazomatic_get_file_url('images/twitter.png') . '" class="crf_social_img" alt="Twitter"></a>';
    return $button;
}

function amazomatic_getPinterestButton($url, $item_title, $banner, $amazomatic_Main_Settings)
{
    $button = '<a ';
	if(isset($amazomatic_Main_Settings['rel_nofollow']) && $amazomatic_Main_Settings['rel_nofollow'] == 'on')
    {
		$button .= ' rel="nofollow"';
	}		
	$button .= ' class="crf_twitt amazomatic_btn button purchase" href="http://pinterest.com/pin/create/button?description=' . urlencode($item_title) . '&media=' . urlencode($banner) . '&url=' . urlencode($url) . '" onclick="return !window.open(this.href, \'Pinterest\', \'width=640,height=580\')"><img src="' . amazomatic_get_file_url('images/pinterest.png') . '" alt="Pinterest" class="crf_social_img"></a>';
    return $button;
}
function amazomatic_getIntro($title, $item_url, $item_image, $author, $my_post)
{   
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
	if (isset($amazomatic_Main_Settings['buy_now']) && $amazomatic_Main_Settings['buy_now'] != '') {
		$buy_now = $amazomatic_Main_Settings['buy_now'];
	}
	else
	{
		$buy_now = esc_html__('Buy Now', 'amazomatic-amazon-post-generator');
	}
    $link      = amazomatic_getNamedButton($item_url, $buy_now, $amazomatic_Main_Settings, "amazomatic_buy_now");
    $facebook = amazomatic_getFacebookButton($item_url, $amazomatic_Main_Settings);
    $twitter = amazomatic_getTwitterButton($item_url, $title, $amazomatic_Main_Settings);
    if($item_image != '')
    {
        $pinterest = amazomatic_getPinterestButton($item_url, $title, $item_image, $amazomatic_Main_Settings);
    }
    else
    {
        $pinterest = '';
    }
    $preview   = '<div id="amazomatic_img_div" name="amazomatic_img_div"><div id="amazomatic_img_wrap" name="amazomatic_img_wrap"><div class="crf_padding_10">';
    if($item_image != '')
    {
        $preview .= '<img src="' . esc_url($item_image) . '" alt="item image"/>';
    }
    $preview .= '</div><div id="amazomatic_buttons_wrap" name="amazomatic_buttons_wrap">';

    if($link != '')
    {
        $preview .= '&nbsp;' . $link;
    }
    $preview .= '<br/>' . $facebook . '&nbsp;' . $twitter . '&nbsp;' . $pinterest;
    $price = '';
    if($my_post['amazomatic_price'] != '')
    {
        if($my_post['amazomatic_offer_price'] != '' && $my_post['amazomatic_price'] != $my_post['amazomatic_offer_price'])
        {
            if(intval($my_post['amazomatic_price']) > intval($my_post['amazomatic_offer_price']))
            {
                $price = '<del>' . esc_html($my_post['amazomatic_price']) . '</del>&nbsp;' . esc_html($my_post['amazomatic_offer_price']);
            }
            else
            {
                $price = esc_html($my_post['amazomatic_offer_price']);
            }
        }
        else
        {
            $price = esc_html($my_post['amazomatic_price']);
        }
    }
    else
    {
        $price = esc_html__('Free', 'amazomatic-amazon-post-generator');
    }
    $preview .= '</div></div><p><span class="crf_margin_10"><b>' . esc_html($author) . '</b></span><span class="crf_float_right"><b>';
    $preview .= esc_html__('Click ', 'amazomatic-amazon-post-generator') . esc_html($buy_now) . esc_html__(' for Updated Price. Estimated Price: ', 'amazomatic-amazon-post-generator');
    $preview .= $price . '</b></span></p></div><br/>';
    return $preview;
}

function amazomatic_replaceTitleShortcodes($the_content, $just_title, $content, $item_url)
{
    $the_content = str_replace('%%random_sentence%%', amazomatic_random_sentence_generator(), $the_content);
    $the_content = str_replace('%%random_sentence2%%', amazomatic_random_sentence_generator(false), $the_content);
    $the_content = str_replace('%%item_title%%', $just_title, $the_content);
    $the_content = str_replace('%%item_description%%', $content, $the_content);
    $the_content = str_replace('%%item_url%%', $item_url, $the_content);
    return $the_content;
}

function amazomatic_replaceTitleShortcodesAgain($the_content, $item_cat, $item_tags)
{
    $the_content = str_replace('%%item_cat%%', $item_cat, $the_content);
    $the_content = str_replace('%%item_tags%%', $item_tags, $the_content);
    return $the_content;
}

add_shortcode( 'amazomatic-display-posts', 'amazomatic_display_posts_shortcode' );
function amazomatic_display_posts_shortcode( $atts ) {
	$original_atts = $atts;
	$atts = shortcode_atts( array(
		'author'               => '',
		'category'             => '',
		'category_display'     => '',
		'category_label'       => 'Posted in: ',
		'content_class'        => 'content',
		'date_format'          => '(n/j/Y)',
		'date'                 => '',
		'date_column'          => 'post_date',
		'date_compare'         => '=',
		'date_query_before'    => '',
		'date_query_after'     => '',
		'date_query_column'    => '',
		'date_query_compare'   => '',
		'display_posts_off'    => false,
		'excerpt_length'       => false,
		'excerpt_more'         => false,
		'excerpt_more_link'    => false,
		'exclude_current'      => false,
		'id'                   => false,
		'ignore_sticky_posts'  => false,
		'image_size'           => false,
		'include_author'       => false,
		'include_content'      => false,
		'include_date'         => false,
		'include_excerpt'      => false,
		'include_link'         => true,
		'include_title'        => true,
		'meta_key'             => '',
		'meta_value'           => '',
		'no_posts_message'     => '',
		'offset'               => 0,
		'order'                => 'DESC',
		'orderby'              => 'date',
		'post_parent'          => false,
		'post_status'          => 'publish',
		'post_type'            => 'post',
		'posts_per_page'       => '10',
		'tag'                  => '',
		'tax_operator'         => 'IN',
		'tax_include_children' => true,
		'tax_term'             => false,
		'taxonomy'             => false,
		'time'                 => '',
		'title'                => '',
        'title_color'          => '#000000',
        'excerpt_color'        => '#000000',
        'link_to_source'       => '',
        'title_font_size'      => '100%',
        'excerpt_font_size'    => '100%',
        'read_more_text'       => '',
        'price_text'           => '',
		'wrapper'              => 'ul',
		'wrapper_class'        => 'display-posts-listing',
		'wrapper_id'           => false,
        'ruleid'               => '',
        'ruletype'             => ''
	), $atts, 'display-posts' );
	if( $atts['display_posts_off'] )
		return;
    $ruleid               = sanitize_text_field( $atts['ruleid'] );
    $ruletype             = sanitize_text_field( $atts['ruletype'] );
	$author               = sanitize_text_field( $atts['author'] );
	$category             = sanitize_text_field( $atts['category'] );
	$category_display     = 'true' == $atts['category_display'] ? 'category' : sanitize_text_field( $atts['category_display'] );
	$category_label       = sanitize_text_field( $atts['category_label'] );
	$content_class        = array_map( 'sanitize_html_class', ( explode( ' ', $atts['content_class'] ) ) );
	$date_format          = sanitize_text_field( $atts['date_format'] );
	$date                 = sanitize_text_field( $atts['date'] );
	$date_column          = sanitize_text_field( $atts['date_column'] );
	$date_compare         = sanitize_text_field( $atts['date_compare'] );
	$date_query_before    = sanitize_text_field( $atts['date_query_before'] );
	$date_query_after     = sanitize_text_field( $atts['date_query_after'] );
	$date_query_column    = sanitize_text_field( $atts['date_query_column'] );
	$date_query_compare   = sanitize_text_field( $atts['date_query_compare'] );
	$excerpt_length       = intval( $atts['excerpt_length'] );
	$excerpt_more         = sanitize_text_field( $atts['excerpt_more'] );
	$excerpt_more_link    = filter_var( $atts['excerpt_more_link'], FILTER_VALIDATE_BOOLEAN );
	$exclude_current      = filter_var( $atts['exclude_current'], FILTER_VALIDATE_BOOLEAN );
	$id                   = $atts['id'];
	$ignore_sticky_posts  = filter_var( $atts['ignore_sticky_posts'], FILTER_VALIDATE_BOOLEAN );
	$image_size           = sanitize_key( $atts['image_size'] );
	$include_title        = filter_var( $atts['include_title'], FILTER_VALIDATE_BOOLEAN );
	$include_author       = filter_var( $atts['include_author'], FILTER_VALIDATE_BOOLEAN );
	$include_content      = filter_var( $atts['include_content'], FILTER_VALIDATE_BOOLEAN );
	$include_date         = filter_var( $atts['include_date'], FILTER_VALIDATE_BOOLEAN );
	$include_excerpt      = filter_var( $atts['include_excerpt'], FILTER_VALIDATE_BOOLEAN );
	$include_link         = filter_var( $atts['include_link'], FILTER_VALIDATE_BOOLEAN );
	$meta_key             = sanitize_text_field( $atts['meta_key'] );
	$meta_value           = sanitize_text_field( $atts['meta_value'] );
	$no_posts_message     = sanitize_text_field( $atts['no_posts_message'] );
	$offset               = intval( $atts['offset'] );
	$order                = sanitize_key( $atts['order'] );
	$orderby              = sanitize_key( $atts['orderby'] );
	$post_parent          = $atts['post_parent'];
	$post_status          = $atts['post_status'];
	$post_type            = sanitize_text_field( $atts['post_type'] );
	$posts_per_page       = intval( $atts['posts_per_page'] );
	$tag                  = sanitize_text_field( $atts['tag'] );
	$tax_operator         = $atts['tax_operator'];
	$tax_include_children = filter_var( $atts['tax_include_children'], FILTER_VALIDATE_BOOLEAN );
	$tax_term             = sanitize_text_field( $atts['tax_term'] );
	$taxonomy             = sanitize_key( $atts['taxonomy'] );
	$time                 = sanitize_text_field( $atts['time'] );
	$shortcode_title      = sanitize_text_field( $atts['title'] );
    $title_color          = sanitize_text_field( $atts['title_color'] );
    $excerpt_color        = sanitize_text_field( $atts['excerpt_color'] );
    $link_to_source       = sanitize_text_field( $atts['link_to_source'] );
    $excerpt_font_size    = sanitize_text_field( $atts['excerpt_font_size'] );
    $title_font_size      = sanitize_text_field( $atts['title_font_size'] );
    $read_more_text       = sanitize_text_field( $atts['read_more_text'] );
    $price_text           = sanitize_text_field( $atts['price_text'] );
	$wrapper              = sanitize_text_field( $atts['wrapper'] );
	$wrapper_class        = array_map( 'sanitize_html_class', ( explode( ' ', $atts['wrapper_class'] ) ) );
	if( !empty( $wrapper_class ) )
		$wrapper_class = ' class="' . implode( ' ', $wrapper_class ) . '"';
	$wrapper_id = sanitize_html_class( $atts['wrapper_id'] );
	if( !empty( $wrapper_id ) )
		$wrapper_id = ' id="' . esc_html($wrapper_id) . '"';
	$args = array(
		'category_name'       => $category,
		'order'               => $order,
		'orderby'             => $orderby,
		'post_type'           => explode( ',', $post_type ),
		'posts_per_page'      => $posts_per_page,
		'tag'                 => $tag,
	);
	if ( ! empty( $date ) || ! empty( $time ) || ! empty( $date_query_after ) || ! empty( $date_query_before ) ) {
		$initial_date_query = $date_query_top_lvl = array();
		$valid_date_columns = array(
			'post_date', 'post_date_gmt', 'post_modified', 'post_modified_gmt',
			'comment_date', 'comment_date_gmt'
		);
		$valid_compare_ops = array( '=', '!=', '>', '>=', '<', '<=', 'IN', 'NOT IN', 'BETWEEN', 'NOT BETWEEN' );
		$dates = amazomatic_sanitize_date_time( $date );
		if ( ! empty( $dates ) ) {
			if ( is_string( $dates ) ) {
				$timestamp = strtotime( $dates );
				$dates = array(
					'year'   => date( 'Y', $timestamp ),
					'month'  => date( 'm', $timestamp ),
					'day'    => date( 'd', $timestamp ),
				);
			}
			foreach ( $dates as $arg => $segment ) {
				$initial_date_query[ $arg ] = $segment;
			}
		}
		$times = amazomatic_sanitize_date_time( $time, 'time' );
		if ( ! empty( $times ) ) {
			foreach ( $times as $arg => $segment ) {
				$initial_date_query[ $arg ] = $segment;
			}
		}
		$before = amazomatic_sanitize_date_time( $date_query_before, 'date', true );
		if ( ! empty( $before ) ) {
			$initial_date_query['before'] = $before;
		}
		$after = amazomatic_sanitize_date_time( $date_query_after, 'date', true );
		if ( ! empty( $after ) ) {
			$initial_date_query['after'] = $after;
		}
		if ( ! empty( $date_query_column ) && in_array( $date_query_column, $valid_date_columns ) ) {
			$initial_date_query['column'] = $date_query_column;
		}
		if ( ! empty( $date_query_compare ) && in_array( $date_query_compare, $valid_compare_ops ) ) {
			$initial_date_query['compare'] = $date_query_compare;
		}
		if ( ! empty( $date_column ) && in_array( $date_column, $valid_date_columns ) ) {
			$date_query_top_lvl['column'] = $date_column;
		}
		if ( ! empty( $date_compare ) && in_array( $date_compare, $valid_compare_ops ) ) {
			$date_query_top_lvl['compare'] = $date_compare;
		}
		if ( ! empty( $initial_date_query ) ) {
			$date_query_top_lvl[] = $initial_date_query;
		}
		$args['date_query'] = $date_query_top_lvl;
	}
    if($ruleid != '' && $ruletype != '')
    {
        $q_arr = array();
        $temp_arr['key'] = 'amazomatic_parent_rule';
        $temp_arr['value'] = $ruleid;
        $q_arr[] = $temp_arr;
        $temp_arr2['key'] = 'amazomatic_parent_type';
        $temp_arr2['value'] = $ruletype;
        $q_arr[] = $temp_arr2;
        $args['meta_query'] = $q_arr;
    }
    elseif($ruleid != '')
    {
        $args['meta_key'] = 'amazomatic_parent_rule';
        $args['meta_value'] = $ruleid;
    }
    elseif($ruletype != '')
    {
        $args['meta_key'] = 'amazomatic_parent_type';
        $args['meta_value'] = $ruletype;
    }
	if( $ignore_sticky_posts )
		$args['ignore_sticky_posts'] = true;
	 
	if( $id ) {
		$posts_in = array_map( 'intval', explode( ',', $id ) );
		$args['post__in'] = $posts_in;
	}
	if( is_singular() && $exclude_current )
		$args['post__not_in'] = array( get_the_ID() );
	if( !empty( $author ) ) {
		if( 'current' == $author && is_user_logged_in() )
			$args['author_name'] = wp_get_current_user()->user_login;
		elseif( 'current' == $author )
            $unrelevar = false;
			 
		else
			$args['author_name'] = $author;
	}
	if( !empty( $offset ) )
		$args['offset'] = $offset;
	$post_status = explode( ', ', $post_status );
	$validated = array();
	$available = array( 'publish', 'pending', 'draft', 'auto-draft', 'future', 'private', 'inherit', 'trash', 'any' );
	foreach ( $post_status as $unvalidated )
		if ( in_array( $unvalidated, $available ) )
			$validated[] = $unvalidated;
	if( !empty( $validated ) )
		$args['post_status'] = $validated;
	if ( !empty( $taxonomy ) && !empty( $tax_term ) ) {
		if( 'current' == $tax_term ) {
			global $post;
			$terms = wp_get_post_terms(get_the_ID(), $taxonomy);
			$tax_term = array();
			foreach ($terms as $term) {
				$tax_term[] = $term->slug;
			}
		}else{
			$tax_term = explode( ', ', $tax_term );
		}
		if( !in_array( $tax_operator, array( 'IN', 'NOT IN', 'AND' ) ) )
			$tax_operator = 'IN';
		$tax_args = array(
			'tax_query' => array(
				array(
					'taxonomy'         => $taxonomy,
					'field'            => 'slug',
					'terms'            => $tax_term,
					'operator'         => $tax_operator,
					'include_children' => $tax_include_children,
				)
			)
		);
		$count = 2;
		$more_tax_queries = false;
		while(
			isset( $original_atts['taxonomy_' . $count] ) && !empty( $original_atts['taxonomy_' . $count] ) &&
			isset( $original_atts['tax_' . esc_html($count) . '_term'] ) && !empty( $original_atts['tax_' . esc_html($count) . '_term'] )
		):
			$more_tax_queries = true;
			$taxonomy = sanitize_key( $original_atts['taxonomy_' . $count] );
	 		$terms = explode( ', ', sanitize_text_field( $original_atts['tax_' . esc_html($count) . '_term'] ) );
	 		$tax_operator = isset( $original_atts['tax_' . esc_html($count) . '_operator'] ) ? $original_atts['tax_' . esc_html($count) . '_operator'] : 'IN';
	 		$tax_operator = in_array( $tax_operator, array( 'IN', 'NOT IN', 'AND' ) ) ? $tax_operator : 'IN';
	 		$tax_include_children = isset( $original_atts['tax_' . esc_html($count) . '_include_children'] ) ? filter_var( $atts['tax_' . esc_html($count) . '_include_children'], FILTER_VALIDATE_BOOLEAN ) : true;
	 		$tax_args['tax_query'][] = array(
	 			'taxonomy'         => $taxonomy,
	 			'field'            => 'slug',
	 			'terms'            => $terms,
	 			'operator'         => $tax_operator,
	 			'include_children' => $tax_include_children,
	 		);
			$count++;
		endwhile;
		if( $more_tax_queries ):
			$tax_relation = 'AND';
			if( isset( $original_atts['tax_relation'] ) && in_array( $original_atts['tax_relation'], array( 'AND', 'OR' ) ) )
				$tax_relation = $original_atts['tax_relation'];
			$args['tax_query']['relation'] = $tax_relation;
		endif;
		$args = array_merge_recursive( $args, $tax_args );
	}
	if( $post_parent !== false ) {
		if( 'current' == $post_parent ) {
			global $post;
			$post_parent = get_the_ID();
		}
		$args['post_parent'] = intval( $post_parent );
	}
	$wrapper_options = array( 'ul', 'ol', 'div' );
	if( ! in_array( $wrapper, $wrapper_options ) )
		$wrapper = 'ul';
	$inner_wrapper = 'div' == $wrapper ? 'div' : 'li';
	$listing = new WP_Query( apply_filters( 'display_posts_shortcode_args', $args, $original_atts ) );
	if ( ! $listing->have_posts() ) {
		return apply_filters( 'display_posts_shortcode_no_results', wpautop( $no_posts_message ) );
	}
	$inner = '';
	$amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    wp_suspend_cache_addition(true);
	while ( $listing->have_posts() ): $listing->the_post(); global $post;
		$image = $date = $author = $excerpt = $content = '';
		if ( $include_title && $include_link ) {
            if($link_to_source == 'yes')
            {
                $source_url = get_post_meta($post->ID, 'amazomatic_post_url', true);
                if($source_url != '')
                {
                    $title = '<a class="amazomatic_display_title" href="' . esc_url($source_url) . '"';
					if(isset($amazomatic_Main_Settings['rel_nofollow']) && $amazomatic_Main_Settings['rel_nofollow'] == 'on')
					{
						$title .= ' rel="nofollow"';
					}		
					$title .= '><span class="cr_display_span" >' . get_the_title() . '</span></a>';
                }
                else
                {
                    $title = '<a class="amazomatic_display_title" href="' . apply_filters( 'the_permalink', get_permalink() ) . '"><span class="cr_display_span" >' . get_the_title() . '</span></a>';
                }
            }
            else
            {
                $title = '<a class="amazomatic_display_title" href="' . apply_filters( 'the_permalink', get_permalink() ) . '"><span class="cr_display_span" >' . get_the_title() . '</span></a>';
            }
		} elseif( $include_title ) {
			$title = '<span class="amazomatic_display_title" class="cr_display_span">' . get_the_title() . '</span>';
		} else {
			$title = '';
		}
		if ( $image_size && has_post_thumbnail() && $include_link ) {
            if($link_to_source == 'yes')
            {
                $source_url = get_post_meta($post->ID, 'amazomatic_post_url', true);
                if($source_url != '')
                {
                    $image = '<a class="amazomatic_display_image" href="' . esc_url($source_url) . '"';
					if(isset($amazomatic_Main_Settings['rel_nofollow']) && $amazomatic_Main_Settings['rel_nofollow'] == 'on')
					{
						$image .= ' rel="nofollow"';
					}		
					$image .= '>' . get_the_post_thumbnail( get_the_ID(), $image_size ) . '</a> <br/>';
                }
                else
                {
                    $image = '<a class="amazomatic_display_image" href="' . get_permalink() . '">' . get_the_post_thumbnail( get_the_ID(), $image_size ) . '</a> <br/>';
                }
            }
            else
            {
                $image = '<a class="amazomatic_display_image" href="' . get_permalink() . '">' . get_the_post_thumbnail( get_the_ID(), $image_size ) . '</a> <br/>';
            }
		} elseif( $image_size && has_post_thumbnail() ) {
			$image = '<span class="amazomatic_display_image">' . get_the_post_thumbnail( get_the_ID(), $image_size ) . '</span> <br/>';
		}
		if ( $include_date )
			$date = ' <span class="date">' . get_the_date( $date_format ) . '</span>';
		if( $include_author )
			$author = apply_filters( 'display_posts_shortcode_author', ' <span class="amazomatic_display_author">by ' . get_the_author() . '</span>', $original_atts );
		if ( $include_excerpt ) {
			if( $excerpt_length || $excerpt_more || $excerpt_more_link ) {
				$length = $excerpt_length ? $excerpt_length : apply_filters( 'excerpt_length', 55 );
				$more   = $excerpt_more ? $excerpt_more : apply_filters( 'excerpt_more', '' );
				$more   = $excerpt_more_link ? ' <a href="' . get_permalink() . '">' . esc_html($more) . '</a>' : ' ' . esc_html($more);
				if( has_excerpt() && apply_filters( 'display_posts_shortcode_full_manual_excerpt', false ) ) {
					$excerpt = $post->post_excerpt . $more;
				} elseif( has_excerpt() ) {
					$excerpt = wp_trim_words( strip_shortcodes( $post->post_excerpt ), $length, $more );
				} else {
					$excerpt = wp_trim_words( strip_shortcodes( $post->post_content ), $length, $more );
				}
			} else {
				$excerpt = get_the_excerpt();
			}
			$excerpt = ' <br/><br/> <span class="amazomatic_display_excerpt" class="cr_display_excerpt_adv">' . $excerpt . '</span>';
            if($price_text != '')
            {
                $price_amount = get_post_meta($post->ID, 'amazomatic_price', true);
                if($price_amount != '')
                {
                    $excerpt .= '<div class="amazomatic_price_button">';
                    $excerpt .= '<br/>' . esc_html($price_text) . ' ' . esc_html($price_amount);
                    $excerpt .= '</div>';
                }
            }
            if($read_more_text != '')
            {
                $excerpt .= '<div class="amazomatic_buy_now_button">';
                if($link_to_source == 'yes')
                {
                    $source_url = get_post_meta($post->ID, 'amazomatic_post_url', true);
                    if($source_url != '')
                    {
                        $excerpt .= '<a href="' . esc_url($source_url) . '"';
						if(isset($amazomatic_Main_Settings['rel_nofollow']) && $amazomatic_Main_Settings['rel_nofollow'] == 'on')
						{
							$excerpt .= ' rel="nofollow"';
						}		
						$excerpt .= '><span class="amazomatic_display_excerpt" class="cr_display_excerpt_adv">' . esc_html($read_more_text) . '</span></a>';
                    }
                    else
                    {
                        $excerpt .= '<a href="' . get_permalink() . '"><span class="amazomatic_display_excerpt" class="cr_display_excerpt_adv">' . esc_html($read_more_text) . '</span></a>';
                    }
                }
                else
                {
                    $excerpt .= '<a href="' . get_permalink() . '"><span class="amazomatic_display_excerpt" class="cr_display_excerpt_adv">' . esc_html($read_more_text) . '</span></a>';
                }
                $excerpt .= '</div>';
            }
		}
		if( $include_content ) {
			add_filter( 'shortcode_atts_display-posts', 'amazomatic_display_posts_off', 10, 3 );
			$content = '<div class="' . implode( ' ', $content_class ) . '">' . apply_filters( 'the_content', get_the_content() ) . '</div>';
			remove_filter( 'shortcode_atts_display-posts', 'amazomatic_display_posts_off', 10, 3 );
		}
		$category_display_text = '';
		if( $category_display && is_object_in_taxonomy( get_post_type(), $category_display ) ) {
			$terms = get_the_terms( get_the_ID(), $category_display );
			$term_output = array();
			foreach( $terms as $term )
				$term_output[] = '<a href="' . get_term_link( $term, $category_display ) . '">' . esc_url($term->name) . '</a>';
			$category_display_text = ' <span class="category-display"><span class="category-display-label">' . esc_html($category_label) . '</span> ' . implode( ', ', $term_output ) . '</span>';
			$category_display_text = apply_filters( 'display_posts_shortcode_category_display', $category_display_text );
		}
		$class = array( 'listing-item' );
		$class = array_map( 'sanitize_html_class', apply_filters( 'display_posts_shortcode_post_class', $class, $post, $listing, $original_atts ) );
		$output = '<br/><' . esc_html($inner_wrapper) . ' class="' . implode( ' ', $class ) . '">' . $image . $title . $date . $author . $category_display_text . $excerpt . $content . '</' . esc_html($inner_wrapper) . '><br/><br/><hr class="cr_hr_dot"/>';		$inner .= apply_filters( 'display_posts_shortcode_output', $output, $original_atts, $image, $title, $date, $excerpt, $inner_wrapper, $content, $class );
	endwhile; wp_reset_postdata();
    wp_suspend_cache_addition(false);
	$open = apply_filters( 'display_posts_shortcode_wrapper_open', '<' . $wrapper . $wrapper_class . $wrapper_id . '>', $original_atts );
	$close = apply_filters( 'display_posts_shortcode_wrapper_close', '</' . esc_html($wrapper) . '>', $original_atts );
	$return = $open;
	if( $shortcode_title ) {
		$title_tag = apply_filters( 'display_posts_shortcode_title_tag', 'h2', $original_atts );
		$return .= '<' . esc_html($title_tag) . ' class="display-posts-title">' . esc_html($shortcode_title) . '</' . esc_html($title_tag) . '>' . "\n";
	}
	$return .= $inner . $close;
    $reg_css_code = '.cr_hr_dot{border-top: dotted 1px;}.cr_display_span{font-size:' . esc_html($title_font_size) . ';color:' . esc_html($title_color) . ' !important;}.cr_display_excerpt_adv{font-size:' . esc_html($excerpt_font_size) . ';color:' . esc_html($excerpt_color) . ' !important;}';
    wp_register_style( 'amazomatic-display-style', false );
    wp_enqueue_style( 'amazomatic-display-style' );
    wp_add_inline_style( 'amazomatic-display-style', $reg_css_code );
	return $return;
}
function amazomatic_sanitize_date_time( $date_time, $type = 'date', $accepts_string = false ) {
	if ( empty( $date_time ) || ! in_array( $type, array( 'date', 'time' ) ) ) {
		return array();
	}
	$segments = array();
	if (
		true === $accepts_string
		&& ( false !== strpos( $date_time, ' ' ) || false === strpos( $date_time, '-' ) )
	) {
		if ( false !== $timestamp = strtotime( $date_time ) ) {
			return $date_time;
		}
	}
	$parts = array_map( 'absint', explode( 'date' == $type ? '-' : ':', $date_time ) );
	if ( 'date' == $type ) {
		$year = $month = $day = 1;
		if ( count( $parts ) >= 3 ) {
			list( $year, $month, $day ) = $parts;
			$year  = ( $year  >= 1 && $year  <= 9999 ) ? $year  : 1;
			$month = ( $month >= 1 && $month <= 12   ) ? $month : 1;
			$day   = ( $day   >= 1 && $day   <= 31   ) ? $day   : 1;
		}
		$segments = array(
			'year'  => $year,
			'month' => $month,
			'day'   => $day
		);
	} elseif ( 'time' == $type ) {
		$hour = $minute = $second = 0;
		switch( count( $parts ) ) {
			case 3 :
				list( $hour, $minute, $second ) = $parts;
				$hour   = ( $hour   >= 0 && $hour   <= 23 ) ? $hour   : 0;
				$minute = ( $minute >= 0 && $minute <= 60 ) ? $minute : 0;
				$second = ( $second >= 0 && $second <= 60 ) ? $second : 0;
				break;
			case 2 :
				list( $hour, $minute ) = $parts;
				$hour   = ( $hour   >= 0 && $hour   <= 23 ) ? $hour   : 0;
				$minute = ( $minute >= 0 && $minute <= 60 ) ? $minute : 0;
				break;
			default : break;
		}
		$segments = array(
			'hour'   => $hour,
			'minute' => $minute,
			'second' => $second
		);
	}

	return apply_filters( 'display_posts_shortcode_sanitized_segments', $segments, $date_time, $type );
}

function amazomatic_display_posts_off( $out, $pairs, $atts ) {
	$out['display_posts_off'] = apply_filters( 'display_posts_shortcode_inception_override', true );
	return $out;
}
add_shortcode( 'amazomatic-list-posts', 'amazomatic_list_posts' );
function amazomatic_list_posts( $atts ) {
    ob_start();
    extract( shortcode_atts( array (
        'type' => 'any',
        'order' => 'ASC',
        'orderby' => 'title',
        'posts' => 50,
        'posts_per_page' => 50,
        'category' => '',
        'ruleid' => '',
        'ruletype' => ''
    ), $atts ) );
    if($posts_per_page != 50)
    {
        $posts = $posts_per_page;
    }
    $options = array(
        'post_type' => $type,
        'order' => $order,
        'orderby' => $orderby,
        'posts_per_page' => $posts,
        'category_name' => $category
    );
    if($ruleid != '' && $ruletype != '')
    {
        $q_arr = array();
        $temp_arr['key'] = 'amazomatic_parent_rule';
        $temp_arr['value'] = $ruleid;
        $q_arr[] = $temp_arr;
        $temp_arr2['key'] = 'amazomatic_parent_type';
        $temp_arr2['value'] = $ruletype;
        $q_arr[] = $temp_arr2;
        $options['meta_query'] = $q_arr;
    }
    elseif($ruleid != '')
    {
        $options['meta_key'] = 'amazomatic_parent_rule';
        $options['meta_value'] = $ruleid;
    }
    elseif($ruletype != '')
    {
        $options['meta_key'] = 'amazomatic_parent_type';
        $options['meta_value'] = $ruletype;
    }
    
    $query = new WP_Query( $options );
    if ( $query->have_posts() ) { ?>
        <ul class="clothes-listing">
            <?php while ( $query->have_posts() ) : $query->the_post(); ?>
            <li id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
                <a href="<?php echo esc_url(get_permalink()); ?>"><?php echo esc_html(get_the_title());?></a>
            </li>
            <?php endwhile;
            wp_reset_postdata(); ?>
        </ul>
    <?php $myvariable = ob_get_clean();
    return $myvariable;
    }
    return '';
}
add_action('wp_ajax_amazomatic_my_action', 'amazomatic_my_action_callback');
function amazomatic_my_action_callback()
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    $failed                 = false;
    $type                   = $_POST['type'];
    $del_id                 = $_POST['id'];
    $how                    = $_POST['how'];
	if($how == 'duplicate')
    {
        if($type == 0)
        {
            $GLOBALS['wp_object_cache']->delete('amazomatic_rules_list', 'options');
            if (!get_option('amazomatic_rules_list')) {
                $rules = array();
            } else {
                $rules = get_option('amazomatic_rules_list');
            }
        }
        elseif($type == 1)
        {
            $GLOBALS['wp_object_cache']->delete('amazomatic_item_list', 'options');
            if (!get_option('amazomatic_item_list')) {
                $rules = array();
            } else {
                $rules = get_option('amazomatic_item_list');
            }
        }
        elseif($type == 2)
        {
            $GLOBALS['wp_object_cache']->delete('amazomatic_lookup_list', 'options');
            if (!get_option('amazomatic_lookup_list')) {
                $rules = array();
            } else {
                $rules = get_option('amazomatic_lookup_list');
            }
        }
        if (!empty($rules)) {
            $found            = 0;
            $cont = 0;
            foreach ($rules as $request => $bundle[]) {
                if ($cont == $del_id) {
                    $copy_bundle = $rules[$request];
                    $rules[] = $copy_bundle;
                    $found   = 1;
                    break;
                }
                $cont = $cont + 1;
            }
            if($found == 0)
            {
                amazomatic_log_to_file('Index not found: ' . $del_id);
                echo 'nochange';
                die();
            }
            else
            {
                if($type == 0)
                {
                    update_option('amazomatic_rules_list', $rules, false);
                }
                elseif($type == 1)
                {
                    update_option('amazomatic_item_list', $rules, false);
                }
                elseif($type == 2)
                {
                    update_option('amazomatic_lookup_list', $rules, false);
                }
                echo 'ok';
                die();
            }
        } else {
            amazomatic_log_to_file('Index empty!');
            echo 'nochange';
            die();
        }
        
    }
    $force_delete           = true;
    $number                 = 0;
    if ($how == 'trash') {
        $force_delete = false;
    }
    
    $post_list = array();
    $postsPerPage = 50000;
    $paged = 0;
    do
    {
        $postOffset = $paged * $postsPerPage;
        $query = array(
            'post_status' => array(
                'publish',
                'draft',
                'pending',
                'trash',
                'private',
                'future'
            ),
            'post_type' => array(
                'any'
            ),
            'numberposts' => $postsPerPage,
            'meta_key' => 'amazomatic_parent_rule',
            'fields' => 'ids',
            'offset'  => $postOffset
        );
        $got_me = get_posts($query);
        $post_list = array_merge($post_list, $got_me);
        $paged++;
    }while(!empty($got_me));
    
    wp_suspend_cache_addition(true);
    foreach ($post_list as $post) {
        $index = get_post_meta($post, 'amazomatic_parent_rule', true);
        $parent_type = get_post_meta($post, 'amazomatic_parent_type', true);
        if ($index == $del_id && $parent_type == $type) {
            $args             = array(
                'post_parent' => $post
            );
            $post_attachments = get_children($args);
            if (isset($post_attachments) && !empty($post_attachments)) {
                foreach ($post_attachments as $attachment) {
                    wp_delete_attachment($attachment->ID, true);
                }
            }
            $res = wp_delete_post($post, $force_delete);
            if ($res === false) {
                $failed = true;
            } else {
                $number++;
            }
        }
    }
    wp_suspend_cache_addition(false);
    if ($failed === true) {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('[PostDelete] Failed to delete all posts for rule id: ' . esc_html($del_id) . '!');
        }
        echo 'failed';
    } else {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('[PostDelete] Successfuly deleted ' . esc_html($number) . ' posts for rule id: ' . esc_html($del_id) . '!');
        }
        if ($number == 0) {
            echo 'nochange';
        } else {
            echo 'ok';
        }
    }
    die();
}
add_action('wp_ajax_amazomatic_run_my_action', 'amazomatic_run_my_action_callback');
function amazomatic_run_my_action_callback()
{
    $run_id = $_POST['id'];
    $run_type = $_POST['type'];
    echo amazomatic_run_rule($run_id, $run_type, 0);
    die();
}

function amazomatic_clearFromList($param, $type)
{
    if($param != 'auto_update')
    {
        $GLOBALS['wp_object_cache']->delete('amazomatic_running_list', 'options');
        $running = get_option('amazomatic_running_list');
        $key = array_search(array(
            $param => $type
        ), $running);
        if ($key !== FALSE) {
            unset($running[$key]);
            update_option('amazomatic_running_list', $running);
        }
    }
    else
    {
        $GLOBALS['wp_object_cache']->delete('amazomatic_auto_running_list', 'options');
        $running = get_option('amazomatic_auto_running_list');
        $key = array_search(array(
            $param => $type
        ), $running);
        if ($key !== FALSE) {
            unset($running[$key]);
            update_option('amazomatic_auto_running_list', $running);
        }
    }
}

function amazomatic_isCurl(){
    return function_exists('curl_version');
}
function amazomatic_get_web_page($url)
{
    if(empty($url))
    {
        return false;
    }
    $content = false;
    $args = array(
       'timeout'     => 10,
       'redirection' => 10,
       'user-agent'  => 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.2062.124 Safari/537.36',
       'blocking'    => true,
       'headers'     => array(),
       'cookies'     => array(),
       'body'        => null,
       'compress'    => false,
       'decompress'  => true,
       'sslverify'   => false,
       'stream'      => false,
       'filename'    => null
    );
    $ret_data            = wp_remote_get(html_entity_decode($url), $args);  
    $response_code       = wp_remote_retrieve_response_code( $ret_data );
    $response_message    = wp_remote_retrieve_response_message( $ret_data );        
    if ( 200 != $response_code ) {
    } else {
        $content = wp_remote_retrieve_body( $ret_data );
    }
    if($content === false)
    {
        if(amazomatic_isCurl() && filter_var($url, FILTER_VALIDATE_URL))
        {
            $user_agent = 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.2062.124 Safari/537.36';
            $options    = array(
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_COOKIEJAR => 'echocookie.txt',
                CURLOPT_COOKIEFILE => 'echocookie.txt',
                CURLOPT_POST => false,
                CURLOPT_USERAGENT => $user_agent,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_AUTOREFERER => true,
                CURLOPT_CONNECTTIMEOUT => 10,
                CURLOPT_TIMEOUT => 10,
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_REFERER => 'https://www.google.com/',
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_SSL_VERIFYPEER => 0
            );
            $ch = curl_init($url);
            if($ch === FALSE)
            {
                return false;
            }
            curl_setopt_array($ch, $options);
            
            $content = curl_exec($ch);
            curl_close($ch);
        }
        else
        {
            $allowUrlFopen = preg_match('/1|yes|on|true/i', ini_get('allow_url_fopen'));
            if ($allowUrlFopen) {
                global $wp_filesystem;
                if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                    include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                    wp_filesystem($creds);
                }
                return $wp_filesystem->get_contents($url);
            }
            if( ini_get('allow_url_fopen') ) {
                $handle = fopen($url, "r");
                if($handle === FALSE)
                {
                    return false;
                }
                $content = stream_get_contents($handle);
                fclose($handle);
            }
            else
            {
                if( ini_get('allow_url_include') ) {
                    $content = readfile($url);
                }
                else
                {
                    return false;
                }
            }
        }
    }
    return $content;
}

function amazomatic_utf8_encode($str)
{
    if(function_exists('mb_detect_encoding') && function_exists('mb_convert_encoding'))
    {
        $enc = mb_detect_encoding($str);
        if ($enc !== FALSE) {
            $str = mb_convert_encoding($str, 'UTF-8', $enc);
        } else {
            $str = mb_convert_encoding($str, 'UTF-8');
        }
    }
    return $str;
}

function amazomatic_generate_title($content)
{
    $regexEmoticons = '/[\x{1F600}-\x{1F64F}]/u';
    $content        = preg_replace($regexEmoticons, '', $content);
    $regexSymbols   = '/[\x{1F300}-\x{1F5FF}]/u';
    $content        = preg_replace($regexSymbols, '', $content);
    $regexTransport = '/[\x{1F680}-\x{1F6FF}]/u';
    $content        = preg_replace($regexTransport, '', $content);
    $regexMisc      = '/[\x{2600}-\x{26FF}]/u';
    $content        = preg_replace($regexMisc, '', $content);
    $regexDingbats  = '/[\x{2700}-\x{27BF}]/u';
    $content        = preg_replace($regexDingbats, '', $content);
    $pattern        = "/[a-zA-Z]*[:\/\/]*[A-Za-z0-9\-_]+\.+[A-Za-z0-9\.\/%&=\?\-_]+/i";
    $replacement    = "";
    $content        = preg_replace($pattern, $replacement, $content);
    $return         = trim(trim(trim(wp_trim_words($content, 14)), '.'), ',');
    return $return;
}

add_action('amazomaticactionupdate', 'amazomatic_auto_update_posts' );
function amazomatic_auto_update_posts() {
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if (!isset($amazomatic_Main_Settings['app_id']) || trim($amazomatic_Main_Settings['app_id']) == '' || !isset($amazomatic_Main_Settings['app_secret']) || trim($amazomatic_Main_Settings['app_secret']) == '' || !isset($amazomatic_Main_Settings['affiliate_id']) || trim($amazomatic_Main_Settings['affiliate_id']) == '') {
        return 'fail';
    }
    $GLOBALS['wp_object_cache']->delete( 'amazomatic_auto_running_list', 'options' );
    if (!get_option('amazomatic_auto_running_list')) {
        $running = array();
    } else {
        $running = get_option('amazomatic_auto_running_list');
    }
    if (!empty($running)) {
        if (in_array(array('auto_update' => 'auto_update'), $running)) {
            return;
        }
    }
    $running[] = array(
        'auto_update' => 'auto_update'
    );
    update_option('amazomatic_auto_running_list', $running, false);
    register_shutdown_function('amazomatic_clear_flag_at_shutdown', 'auto_update', 'auto_update', true);
    $auto = 1;
    $updated = 0;
    if (!isset($amazomatic_Main_Settings['source']) || $amazomatic_Main_Settings['source'] == '') {
        $region          = 'com';
    }
    else
    {
        $region          = $amazomatic_Main_Settings['source'];
    }
    try
    {
        $post_list = array();
        $postsPerPage = 50000;
        $paged = 0;
        do
        {
            $postOffset = $paged * $postsPerPage;
            $query = array(
                'post_status' => array(
                    'publish',
                    'draft',
                    'pending',
                    'trash',
                    'private',
                    'future'
                ),
                'post_type' => array(
                    'any'
                ),
                'numberposts' => $postsPerPage,
                'meta_key' => 'amazomatic_asin',
                'fields' => 'ids',
                'offset'  => $postOffset
            );
            $got_me = get_posts($query);
            $post_list = array_merge($post_list, $got_me);
            $paged++;
        }while(!empty($got_me));
        
        wp_suspend_cache_addition(true);
        foreach ($post_list as $post) {
            $asin = get_post_meta($post, 'amazomatic_asin', true);
            if(!isset($asin) || $asin == '')
            {
                continue;
            }
            $post_title = get_post_meta($post, 'amazomatic_title_sablon', true);
            if(!isset($post_title) || $post_title == '')
            {
                continue;
            }
            $post_content = get_post_meta($post, 'amazomatic_content_sablon', true);
            if(!isset($post_content) || $post_content == '')
            {
                continue;
            }
            $additionalParam=array();
            $additionalParam['IdType'] = 'ASIN';
            if (isset($amazomatic_Main_Settings['update_delay']) && $amazomatic_Main_Settings['update_delay'] != '') {
                sleep($amazomatic_Main_Settings['update_delay']);
            }
            $result = amazomatic_getItems_v5($region, trim($amazomatic_Main_Settings['app_id']), trim($amazomatic_Main_Settings['app_secret']), trim($amazomatic_Main_Settings['affiliate_id']), $asin, $additionalParam);
            if($result === FALSE)
            {
                continue;
            }
            $items = $result;
            if (count($items) == 0) {
                continue;
            }
            foreach($items as $item)
            {
                $content = '';
                $description = '';
                $my_post = get_post($post, ARRAY_A);
                $get_img = '';
                $img_found = false;
                $url = $item->getDetailPageURL();
                if (isset($amazomatic_Main_Settings['links_hide']) && $amazomatic_Main_Settings['links_hide'] == 'on' && isset($amazomatic_Main_Settings['apiKey']))
                {
                    $url = amazomatic_url_handle($url);
                }
                $item_info = $item->getItemInfo();
                $images = $item->getImages();
                $image_set         = array();
                if($images != null)
                {
                    $primary = $images->getPrimary();
                    if($primary != null)
                    {
                        $lp = $primary->getLarge();
                        if($lp != null)
                        {
                            $get_img = $lp->getURL();
                            $img_found = true;
                        }
                    }
                    $variants = $images->getVariants();
                    if($variants != null)
                    {
                        foreach($variants as $vari)
                        {
                            $vari_large = $vari->getLarge();
                            if($vari_large != null)
                            {
                                $image_set[] = $vari_large->getURL();
                            }
                        }
                    }
                }
                $zatitle = $item_info->getTitle();
                if($zatitle != null)
                {
                    $title = $zatitle->getDisplayValue();
                }
                else
                {
                    $title = '';
                }
                $content_info     = $item_info->getContentInfo();
                if($content_info != null)
                {
                    $edition     = $content_info->getEdition();
                    $language     = $content_info->getLanguages();
                    $pages_count     = $content_info->getPagesCount();
                    $publication_date     = $content_info->getPublicationDate();
                }
                else
                {
                    $edition     =  '';
                    $language     = '';
                    $pages_count     = '';
                    $publication_date     = '';
                }
                $byline_info     = $item_info->getByLineInfo();
                $contributors     = '';
                if($byline_info != null)
                {
                    $zabrand     = $byline_info->getBrand();
                    if($zabrand != null)
                    {
                        $brand     = $zabrand->getDisplayValue();
                    }
                    else
                    {
                        $brand     = '';
                    }
                    $xcontributors     = $byline_info->getContributors();
                    foreach($xcontributors as $cntx)
                    {
                        $contributors .= $cntx->getName() . ' ';
                    }
                    $zamanufacturer     = $byline_info->getManufacturer();
                    if($zamanufacturer != null)
                    {
                        $manufacturer     = $zamanufacturer->getDisplayValue();
                    }
                    else
                    {
                        $manufacturer     = '';
                    }
                }
                else
                {
                    $brand     = '';
                    $manufacturer     = '';
                }
                
                $class_info     = $item_info->getClassifications();
                if($class_info != null)
                {
                    $zabinding     = $class_info->getBinding();
                    if($zabinding != null)
                    {
                        $binding     = $zabinding->getDisplayValue();
                    }
                    else
                    {
                        $binding     = '';
                    }
                    $zaproduct_group     = $class_info->getProductGroup();
                    if($zaproduct_group != null)
                    {
                        $product_group     = $zaproduct_group->getDisplayValue();
                    }
                    else
                    {
                        $product_group     = '';
                    }
                }
                else
                {
                    $binding     = '';
                    $product_group     = '';
                }
                
                $content_rating     = $item_info->getContentRating();
                if($content_rating != null)
                {
                    $rating     = $content_rating->getAudienceRating();
                }
                else
                {
                    $rating     = '';
                }
                
                $external_ids     = $item_info->getExternalIds();
                if($external_ids != null)
                {
                    $eans     = $external_ids->getEANs();
                    $isbns     = $external_ids->getISBNs();
                    $upcs     = $external_ids->getUPCs();
                }
                else
                {
                    $eans     = '';
                    $isbns     = '';
                    $upcs     = '';
                }
                
                $features     = $item_info->getFeatures();
                $feature_list = array();
                if($features != null)
                {
                    $features_display     = $features->getDisplayValues();
                    if($features_display != null)
                    {
                        $content .= '<ul>';
                        foreach($features_display as $dv)
                        {
                            $feature_list[] = $dv;
                            $content .= '<li>' . $dv . '</li>';
                        }
                        $content .= '</ul>';
                    }
                }
                else
                {
                    $features_display     = '';
                }
                $manu_info     = $item_info->getManufactureInfo();
                if($manu_info != null)
                {
                    $part_no     = $manu_info->getItemPartNumber();
                    $model     = $manu_info->getModel();
                    $warranty     = $manu_info->getWarranty();
                }
                else
                {
                    $part_no     = '';
                    $model     = '';
                    $warranty     = '';
                }
                
                $product_info     = $item_info->getProductInfo();
                if($product_info != null)
                {
                    $color     = $product_info->getColor();
                    $is_adult     = $product_info->getIsAdultProduct();
                    $dimensions     = $product_info->getItemDimensions();
                    $date     = $product_info->getReleaseDate();
                    if($date !== null)
                    {
                        $date = $date->getDisplayValue();
                    }
                    else
                    {
                        $date = amazomatic_get_date_now();
                    }
                    $xs = $product_info->getSize();
                    if($xs != null)
                    {
                        $size     = $xs->getDisplayValue();
                    }
                    else
                    {
                        $size     = '';
                    }
                    $unit_count     = $product_info->getUnitCount();
                }
                else
                {
                    $color     = '';
                    $is_adult     = '';
                    $dimensions     = '';
                    $date     = amazomatic_get_date_now();
                    $size     = '';
                    $unit_count     = '';
                }
                
                $tech_info     = $item_info->getTechnicalInfo();
                if($tech_info != null)
                {
                    $part_no     = $tech_info->getFormats();
                }
                else
                {
                    $part_no     = '';
                }
                
                $trade_info     = $item_info->getTradeInInfo();
                if($trade_info != null)
                {
                    $part_no     = $trade_info->getIsEligibleForTradeIn();
                    $price     = $trade_info->getPrice()->getDisplayAmount();
                }
                else
                {
                    $part_no     = '';
                    $price     = '';
                }
                if ($item->getOffers() != null && $item->getOffers()->getListings() != null && $item->getOffers()->getListings()[0]->getPrice() != null && $item->getOffers()->getListings()[0]->getPrice()->getDisplayAmount() != null) 
                {
                    $price     = $item->getOffers()->getListings()[0]->getPrice()->getDisplayAmount();
                }
                $condition = '';
                $lowprice = '';
                if($item->getOffers() !== null)
                {
                    $offers = $item->getOffers()->getListings();
                }
                else
                {
                    $offers = null;
                }
                if($offers != null)
                {
                    foreach($offers as $off)
                    {
                        $condition = $off->getCondition();
                        $lowprice = $off->getPrice()->getDisplayAmount();
                        if($price == '')
                        {
                            $price = $lowprice;
                        }
                        break;
                    }
                }
                
                $description = amazomatic_getExcerpt($content);
                
                if ($contributors != '') 
                {
                    $author = $contributors;
                }
                elseif ($manufacturer != '') 
                {
                    $author = $manufacturer;
                } 
                elseif ($brand != '') 
                {
                    $author = $brand;
                } 
                else 
                {
                    $author = 'Administrator';
                }
                $author_link = $url;
                
                $my_post['amazomatic_post_id']        = (string)$item->getASIN();
                $my_post['amazomatic_post_image']     = $get_img;
                $item_score = $item->getScore();
                if($item_score != null)
                {
                    $my_post['amazon_sales_rank']          = $item_score;
                }
                else
                {
                    $my_post['amazon_sales_rank']          = '';
                }
                $my_post['amazomatic_image_set']  = $image_set;
                $my_post['amazomatic_binding_category']  = $binding;
                $my_post['amazomatic_brand']  = $brand;
                $my_post['amazomatic_color']  = $color;
                $my_post['amazomatic_feature_list']  = $feature_list;
                $my_post['amazomatic_is_adult_product']  = 'false';
                if($is_adult == true){
                    $my_post['amazomatic_is_adult_product']  = 'true';
                }
                if($price != ''){
                    $my_post['amazomatic_price']  = $price;
                }
                else
                {
                    $my_post['amazomatic_price']  = '';
                }
                if($manufacturer != ''){
                    $my_post['amazomatic_manufacturer']  = $manufacturer;
                }
                else
                {
                    $my_post['amazomatic_manufacturer']  = '';
                }
                if($size != ''){
                    $my_post['amazomatic_size']  = $size;
                }
                else
                {
                    $my_post['amazomatic_size']  = '';
                }
                if($lowprice != ''){
                    $my_post['amazomatic_offer_price']  = $lowprice;
                }
                else
                {
                    $my_post['amazomatic_offer_price']  = '';
                }
                
                $my_post['amazomatic_post_url']         = $url;
                $my_post['amazomatic_post_date']        = $date;
                if (isset($amazomatic_Main_Settings['strip_by_id']) && $amazomatic_Main_Settings['strip_by_id'] != '') {
                    $mock = new DOMDocument;
                    $strip_list = explode(',', $amazomatic_Main_Settings['strip_by_id']);
                    $doc        = new DOMDocument();
                    $internalErrors = libxml_use_internal_errors(true);
                    $doc->loadHTML('<?xml encoding="utf-8" ?>' . $content);
                    
                    foreach ($strip_list as $strip_id) {
                        $element = $doc->getElementById(trim($strip_id));
                        if (isset($element)) {
                            $element->parentNode->removeChild($element);
                        }
                    }
                    $body = $doc->getElementsByTagName('body')->item(0);
                    if(isset($body->childNodes))
                    {
                        foreach ($body->childNodes as $child){
                            $mock->appendChild($mock->importNode($child, true));
                        }
                        $temp_cont = $mock->saveHTML();
                        libxml_use_internal_errors($internalErrors);
                        if($temp_cont !== FALSE && $temp_cont != '')
                        {
                            $temp_cont = str_replace('<?xml encoding="utf-8" ?>', '', $temp_cont);
                            $temp_cont = html_entity_decode($temp_cont);
                            $temp_cont = trim($temp_cont);
                            if(substr_compare($temp_cont, '</p>', -strlen('</p>')) === 0){$temp_cont = substr_replace($temp_cont ,"", -4);}
                            if(substr( $temp_cont, 0, 3 ) === "<p>"){$temp_cont = substr($temp_cont, 3);}
                            $content = $temp_cont;
                        }
                    }
                }              
                if (isset($amazomatic_Main_Settings['strip_by_class']) && $amazomatic_Main_Settings['strip_by_class'] != '') {
                    $mock = new DOMDocument;
                    $strip_list = explode(',', $amazomatic_Main_Settings['strip_by_class']);
                    $doc        = new DOMDocument();
                    $internalErrors = libxml_use_internal_errors(true);
                    $doc->loadHTML('<?xml encoding="utf-8" ?>' . $content);
                    
                    foreach ($strip_list as $strip_class) {
                        $finder    = new DomXPath($doc);
                        $classname = trim($strip_class);
                        $nodes     = $finder->query("//*[contains(@class, '$classname')]");
                        if ($nodes === FALSE) {
                            break;
                        }
                        foreach ($nodes as $node) {
                            $node->parentNode->removeChild($node);
                        }
                    }
                    $body = $doc->getElementsByTagName('body')->item(0);
                    if(isset($body->childNodes))
                    {
                        foreach ($body->childNodes as $child){
                            $mock->appendChild($mock->importNode($child, true));
                        }
                        $temp_cont = $mock->saveHTML();
                        libxml_use_internal_errors($internalErrors);
                        if($temp_cont !== FALSE && $temp_cont != '')
                        {
                            $temp_cont = str_replace('<?xml encoding="utf-8" ?>', '', $temp_cont);
                            $temp_cont = html_entity_decode($temp_cont);
                            $temp_cont = trim($temp_cont);
                            if(substr_compare($temp_cont, '</p>', -strlen('</p>')) === 0){$temp_cont = substr_replace($temp_cont ,"", -4);}
                            if(substr( $temp_cont, 0, 3 ) === "<p>"){$temp_cont = substr($temp_cont, 3);}
                            $content = $temp_cont;
                        }
                    }
                }
                $content = preg_replace('{href="/(\w)}', 'href="https://amazon.com/$1', $content);
                if (isset($amazomatic_Main_Settings['strip_links']) && $amazomatic_Main_Settings['strip_links'] == 'on') {
                    $content = amazomatic_strip_links($content);
                }
                $spintax = new Amazomatic_Spintax();
                $post_content = $spintax->process($post_content);
                $post_title = $spintax->process($post_title);
                if (isset($amazomatic_Main_Settings['only_imported']) && $amazomatic_Main_Settings['only_imported'] == 'on') 
                {
                    $arr                     = amazomatic_spin_and_translate($title, $content);
                    $title                   = $arr[0];
                    $content                 = $arr[1];
                }
                if (strpos($post_content, '%%') !== false) {
                    $new_post_content = amazomatic_replaceContentShortcodes($post_content, $title, $content, $url, $get_img, $description, $author, $author_link, $item->getASIN(), $my_post);
                } else {
                    $new_post_content = $post_content;
                }
                if (strpos($post_title, '%%') !== false) {
                    $new_post_title = amazomatic_replaceTitleShortcodes($post_title, $title, $content, $url);
                } else {
                    $new_post_title = $post_title;
                }
                $my_post['edition']     = $edition;
                $my_post['language']     = $language;
                $my_post['pages_count']     = $pages_count;
                $my_post['publication_date']     = $publication_date;
                $my_post['contributors']     = $contributors;
                $my_post['product_group']     = $product_group;
                $my_post['rating']     = $rating;
                $my_post['eans']     = $eans;
                $my_post['isbns']     = $isbns;
                $my_post['upcs']     = $upcs;
                $my_post['part_no']     = $part_no;
                $my_post['model']     = $model;
                $my_post['warranty']     = $warranty;
                $my_post['color']     = $color;
                $my_post['is_adult']     = $is_adult;
                $my_post['dimensions']     = $dimensions;
                $my_post['unit_count']     = $unit_count;
                $my_post['condition']     = $condition;
                $my_post['description']      = $description;
                $my_post['author']           = $author;
                $my_post['author_link']      = $author_link;
                if (!isset($amazomatic_Main_Settings['only_imported']) || $amazomatic_Main_Settings['only_imported'] != 'on') 
                {
                    $arr                         = amazomatic_spin_and_translate($new_post_title, $new_post_content);
                    $new_post_title              = $arr[0];
                    $new_post_content            = $arr[1];
                }
                if (isset($amazomatic_Main_Settings['limit_content']) && $amazomatic_Main_Settings['limit_content'] != '') {
                    $new_post_content = amazomatic_custom_wp_trim_excerpt($new_post_content, $amazomatic_Main_Settings['limit_content']);
                }
                if (isset($amazomatic_Main_Settings['limit_title']) && $amazomatic_Main_Settings['limit_title'] != '') {
                    $new_post_title = amazomatic_strip_html_tags(amazomatic_custom_wp_trim_excerpt($new_post_title, $amazomatic_Main_Settings['limit_title']));
                }
                $new_post_content        = html_entity_decode($new_post_content);
                $new_post_content = str_replace('</ iframe>', '</iframe>', $new_post_content);
                $my_post['post_content'] = $new_post_content;
                $my_post['post_title']           = $new_post_title;
                $my_post['original_title']       = $title;
                $my_post['original_content']     = $content;
                $my_post['amazomatic_timestamp']   = amazomatic_get_date_now();
                remove_filter('content_save_pre', 'wp_filter_post_kses');
                remove_filter('content_filtered_save_pre', 'wp_filter_post_kses');remove_filter('title_save_pre', 'wp_filter_kses');
                $post_id = wp_update_post($my_post, true);
                if (is_wp_error($post_id)) {
                    $errors = $post_id->get_error_messages();
                    foreach ($errors as $error) {
                        amazomatic_log_to_file('Failed to update post (error): ' . $error);
                    }
                }
                add_filter('content_save_pre', 'wp_filter_post_kses');
                add_filter('content_filtered_save_pre', 'wp_filter_post_kses');add_filter('title_save_pre', 'wp_filter_kses');
                break;
            }
        }
        wp_suspend_cache_addition(false);
    }
    catch (Exception $e) {
        amazomatic_log_to_file ('[AutoUpdater] Exception thrown at auto update: ' . esc_html($e->getMessage()) . '!');
        return 'fail';
    }
}

function amazomatic_replaceSynergyShortcodes($the_content)
{
    $regex = '#%%([a-z0-9]+?)_(\d+?)_(\d+?)%%#';
    $rezz = preg_match_all($regex, $the_content, $matches);
    if ($rezz === FALSE) {
        return $the_content;
    }
    if(isset($matches[1][0]))
    {
        $two_var_functions = array('pdfomatic');
        $three_var_functions = array('bhomatic', 'crawlomatic', 'dmomatic', 'ezinomatic', 'fbomatic', 'flickomatic', 'imguromatic', 'iui', 'instamatic', 'linkedinomatic', 'mediumomatic', 'pinterestomatic', 'echo', 'spinomatic', 'tumblomatic', 'wordpressomatic', 'wpcomomatic', 'youtubomatic', 'mastermind', 'businessomatic');
        $four_var_functions = array('contentomatic', 'newsomatic', 'aliomatic', 'amazomatic', 'blogspotomatic', 'bookomatic', 'careeromatic', 'cbomatic', 'cjomatic', 'craigomatic', 'ebayomatic', 'etsyomatic', 'learnomatic', 'eventomatic', 'gameomatic', 'gearomatic', 'giphyomatic', 'gplusomatic', 'hackeromatic', 'imageomatic', 'midas', 'movieomatic', 'nasaomatic', 'ocartomatic', 'okomatic', 'playomatic', 'recipeomatic', 'redditomatic', 'soundomatic', 'mp3omatic', 'ticketomatic', 'tmomatic', 'trendomatic', 'tuneomatic', 'twitchomatic', 'twitomatic', 'vimeomatic', 'viralomatic', 'vkomatic', 'walmartomatic', 'wikiomatic', 'xlsxomatic', 'yelpomatic', 'yummomatic');
        for ($i = 0; $i < count($matches[1]); $i++)
        {
            $replace_me = false;
            if(in_array($matches[1][$i], $four_var_functions))
            {
                $za_function = $matches[1][$i] . '_run_rule';
                if(function_exists($za_function))
                {
                    $xreflection = new ReflectionFunction($za_function);
                    if($xreflection->getNumberOfParameters() >= 4)
                    {  
                        $rule_runner = $za_function($matches[3][$i], $matches[2][$i], 0, 1);
                        if($rule_runner != 'fail' && $rule_runner != 'nochange' && $rule_runner != 'ok' && $rule_runner !== false)
                        {
                            $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner, $the_content);
                            $replace_me = true;
                        }
                    }
                    $xreflection = null;
                    unset($xreflection);
                }
            }
            elseif(in_array($matches[1][$i], $three_var_functions))
            {
                $za_function = $matches[1][$i] . '_run_rule';
                if(function_exists($za_function))
                {
                    $xreflection = new ReflectionFunction($za_function);
                    if($xreflection->getNumberOfParameters() >= 3)
                    {
                        $rule_runner = $za_function($matches[3][$i], 0, 1);
                        if($rule_runner != 'fail' && $rule_runner != 'nochange' && $rule_runner != 'ok' && $rule_runner !== false)
                        {
                            $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner, $the_content);
                            $replace_me = true;
                        }
                    }
                    $xreflection = null;
                    unset($xreflection);
                }
            }
            elseif(in_array($matches[1][$i], $two_var_functions))
            {
                $za_function = $matches[1][$i] . '_run_rule';
                if(function_exists($za_function))
                {
                    $xreflection = new ReflectionFunction($za_function);
                    if($xreflection->getNumberOfParameters() >= 2)
                    {
                        $rule_runner = $za_function($matches[3][$i], 1);
                        if($rule_runner != 'fail' && $rule_runner != 'nochange' && $rule_runner != 'ok' && $rule_runner !== false)
                        {
                            $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', $rule_runner, $the_content);
                            $replace_me = true;
                        }
                    }
                    $xreflection = null;
                    unset($xreflection);
                }
            }
            if($replace_me == false)
            {
                $the_content = str_replace('%%' . $matches[1][$i] . '_' . $matches[2][$i] . '_' . $matches[3][$i] . '%%', '', $the_content);
            }
        }
    }
    return $the_content;
}


use Amazon\ProductAdvertisingAPI\v1\com\amazon\paapi5\v1\api\DefaultApi;
use Amazon\ProductAdvertisingAPI\v1\ApiException;
use Amazon\ProductAdvertisingAPI\v1\Configuration;
use Amazon\ProductAdvertisingAPI\v1\com\amazon\paapi5\v1\SearchItemsRequest;
use Amazon\ProductAdvertisingAPI\v1\com\amazon\paapi5\v1\SearchItemsResource;
use Amazon\ProductAdvertisingAPI\v1\com\amazon\paapi5\v1\PartnerType;
use Amazon\ProductAdvertisingAPI\v1\com\amazon\paapi5\v1\ProductAdvertisingAPIClientException;
use Amazon\ProductAdvertisingAPI\v1\com\amazon\paapi5\v1\GetItemsRequest;
use Amazon\ProductAdvertisingAPI\v1\com\amazon\paapi5\v1\GetItemsResource;

/**
 * Returns the array of items mapped to ASIN
 *
 * @param array $items Items value.
 *
 * @return array of \Amazon\ProductAdvertisingAPI\v1\com\amazon\paapi5\v1\Item mapped to ASIN.
 */
function amazomatic_parseResponse($items)
{
    $mappedResponse = array();
    foreach ($items as $item) {
        $mappedResponse[$item->getASIN()] = $item;
    }
    return $mappedResponse;
}

function amazomatic_getItems_v5($region, $public_key, $private_key, $associate_tag, $keyword, $additionalParam)
{
    $host = 'us-east-1';
    if($region == 'com')
    {
        $host = 'us-east-1';
    }elseif($region == 'co.uk')
    {
        $host = 'eu-west-1';
    }elseif($region == 'ae')
    {
        $host = 'eu-west-1';
    }elseif($region == 'com.tr')
    {
        $host = 'eu-west-1';
    }elseif($region == 'es')
    {
        $host = 'eu-west-1';
    }elseif($region == 'sg')
    {
        $host = 'us-west-2';
    }elseif($region == 'com.mx')
    {
        $host = 'us-east-1';
    }elseif($region == 'co.jp')
    {
        $host = 'us-west-2';
    }elseif($region == 'it')
    {
        $host = 'eu-west-1';
    }elseif($region == 'ca')
    {
        $host = 'us-east-1';
    }elseif($region == 'de')
    {
        $host = 'eu-west-1';
    }elseif($region == 'fr')
    {
        $host = 'eu-west-1';
    }elseif($region == 'com.br')
    {
        $host = 'us-east-1';
    }elseif($region == 'in')
    {
        $host = 'eu-west-1';
    }elseif($region == 'com.au')
    {
        $host = 'us-west-2';
    }
    $region = 'webservices.amazon.' . $region;
    $xtemp = $region;
    $region = $host;
    $host = $xtemp;
    require_once(__DIR__ . '/res/amazon/vendor/autoload.php');

    $config = new Configuration();

    /*
     * Add your credentials
     * Please add your access key here
     */
    $config->setAccessKey($public_key);
    # Please add your secret key here
    $config->setSecretKey($private_key);

    # Please add your partner tag (store/tracking id) here
    $partnerTag = $associate_tag;

    /*
     * PAAPI host and region to which you want to send request
     * For more details refer: https://webservices.amazon.com/paapi5/documentation/common-request-parameters.html#host-and-region
     */
    $config->setHost($host);
    $config->setRegion($region);

    $apiInstance = new DefaultApi(
    /*
     * If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
     * This is optional, `GuzzleHttp\Client` will be used as default.
     */
        new GuzzleHttp\Client(), $config);

    # Request initialization

    $itemIds = array();
    if(  $keyword != '%2A' && $keyword !='*' )
    {
        $itemIds =  explode(',', str_replace(' ', '', $keyword)) ;
    }
    
    /*
     * Choose resources you want from GetItemsResource enum
     * For more details, refer: https://webservices.amazon.com/paapi5/documentation/get-items.html#resources-parameter
     */
    $resources = array(
        GetItemsResource::BROWSE_NODE_INFOBROWSE_NODES,
            GetItemsResource::BROWSE_NODE_INFOBROWSE_NODESANCESTOR,
            GetItemsResource::BROWSE_NODE_INFOBROWSE_NODESSALES_RANK,
            GetItemsResource::BROWSE_NODE_INFOWEBSITE_SALES_RANK,
            GetItemsResource::IMAGESPRIMARYSMALL,
            GetItemsResource::IMAGESPRIMARYMEDIUM,
            GetItemsResource::IMAGESPRIMARYLARGE,
            GetItemsResource::IMAGESVARIANTSSMALL,
            GetItemsResource::IMAGESVARIANTSMEDIUM,
            GetItemsResource::IMAGESVARIANTSLARGE,
            GetItemsResource::ITEM_INFOBY_LINE_INFO,
            GetItemsResource::ITEM_INFOCONTENT_INFO,
            GetItemsResource::ITEM_INFOCONTENT_RATING,
            GetItemsResource::ITEM_INFOCLASSIFICATIONS,
            GetItemsResource::ITEM_INFOEXTERNAL_IDS,
            GetItemsResource::ITEM_INFOFEATURES,
            GetItemsResource::ITEM_INFOMANUFACTURE_INFO,
            GetItemsResource::ITEM_INFOPRODUCT_INFO,
            GetItemsResource::ITEM_INFOTECHNICAL_INFO,
            GetItemsResource::ITEM_INFOTITLE,
            GetItemsResource::ITEM_INFOTRADE_IN_INFO,
            GetItemsResource::OFFERSLISTINGSAVAILABILITYMAX_ORDER_QUANTITY,
            GetItemsResource::OFFERSLISTINGSAVAILABILITYMESSAGE,
            GetItemsResource::OFFERSLISTINGSAVAILABILITYMIN_ORDER_QUANTITY,
            GetItemsResource::OFFERSLISTINGSAVAILABILITYTYPE,
            GetItemsResource::OFFERSLISTINGSCONDITION,
            GetItemsResource::OFFERSLISTINGSCONDITIONSUB_CONDITION,
            GetItemsResource::OFFERSLISTINGSDELIVERY_INFOIS_AMAZON_FULFILLED,
            GetItemsResource::OFFERSLISTINGSDELIVERY_INFOIS_FREE_SHIPPING_ELIGIBLE,
            GetItemsResource::OFFERSLISTINGSDELIVERY_INFOIS_PRIME_ELIGIBLE,
            GetItemsResource::OFFERSLISTINGSDELIVERY_INFOSHIPPING_CHARGES,
            GetItemsResource::OFFERSLISTINGSIS_BUY_BOX_WINNER,
            GetItemsResource::OFFERSLISTINGSLOYALTY_POINTSPOINTS,
            GetItemsResource::OFFERSLISTINGSMERCHANT_INFO,
            GetItemsResource::OFFERSLISTINGSPRICE,
            GetItemsResource::OFFERSLISTINGSPROGRAM_ELIGIBILITYIS_PRIME_EXCLUSIVE,
            GetItemsResource::OFFERSLISTINGSPROGRAM_ELIGIBILITYIS_PRIME_PANTRY,
            GetItemsResource::OFFERSLISTINGSPROMOTIONS,
            GetItemsResource::OFFERSLISTINGSSAVING_BASIS,
            GetItemsResource::OFFERSSUMMARIESHIGHEST_PRICE,
            GetItemsResource::OFFERSSUMMARIESLOWEST_PRICE,
            GetItemsResource::OFFERSSUMMARIESOFFER_COUNT,
            GetItemsResource::PARENT_ASIN,
            GetItemsResource::RENTAL_OFFERSLISTINGSAVAILABILITYMAX_ORDER_QUANTITY,
            GetItemsResource::RENTAL_OFFERSLISTINGSAVAILABILITYMESSAGE,
            GetItemsResource::RENTAL_OFFERSLISTINGSAVAILABILITYMIN_ORDER_QUANTITY,
            GetItemsResource::RENTAL_OFFERSLISTINGSAVAILABILITYTYPE,
            GetItemsResource::RENTAL_OFFERSLISTINGSBASE_PRICE,
            GetItemsResource::RENTAL_OFFERSLISTINGSCONDITION,
            GetItemsResource::RENTAL_OFFERSLISTINGSCONDITIONSUB_CONDITION,
            GetItemsResource::RENTAL_OFFERSLISTINGSDELIVERY_INFOIS_AMAZON_FULFILLED,
            GetItemsResource::RENTAL_OFFERSLISTINGSDELIVERY_INFOIS_FREE_SHIPPING_ELIGIBLE,
            GetItemsResource::RENTAL_OFFERSLISTINGSDELIVERY_INFOIS_PRIME_ELIGIBLE,
            GetItemsResource::RENTAL_OFFERSLISTINGSDELIVERY_INFOSHIPPING_CHARGES,
            GetItemsResource::RENTAL_OFFERSLISTINGSMERCHANT_INFO);
        
    # Forming the request
    $getItemsRequest = new GetItemsRequest();
    if(count($itemIds) > 0)
    {
        $getItemsRequest->setItemIds($itemIds);
    }
    if(isset($additionalParam['IdType']))
    {
        $getItemsRequest->setItemIdType($additionalParam['IdType']);
    }
    if(isset($additionalParam['Condition']))
    {
        $getItemsRequest->setCondition($additionalParam['Condition']);
    }
    if(isset($additionalParam['MerchantId']))
    {
        $getItemsRequest->setMerchant($additionalParam['MerchantId']);
    }
    
    $getItemsRequest->setPartnerTag($partnerTag);
    $getItemsRequest->setPartnerType(PartnerType::ASSOCIATES);
    $getItemsRequest->setResources($resources);

    # Validating request
    $invalidPropertyList = $getItemsRequest->listInvalidProperties();
    $length = count($invalidPropertyList);
    if ($length > 0) {
        amazomatic_log_to_file("Error forming the request in get item by ASIN!");
        foreach ($invalidPropertyList as $invalidProperty) {
            amazomatic_log_to_file('invalidProperty: ' . $invalidProperty);
        }
        throw new Exception('Invalid properties set!');
    }

    # Sending the request
    try {
        $getItemsResponse = $apiInstance->getItems($getItemsRequest);
        # Parsing the response
        if ($getItemsResponse->getItemsResult() != null) {
            if ($getItemsResponse->getItemsResult()->getItems() != null) {
                $responseList = amazomatic_parseResponse($getItemsResponse->getItemsResult()->getItems());
                if ($responseList == null) {
                    amazomatic_log_to_file( 'ResponseList is null: ' . print_r($responseList, true));
                    throw new Exception('ResponseList is null!');
                }
                return $responseList;
            }
        }
        if ($getItemsResponse->getErrors() != null) {
            amazomatic_log_to_file( 'Printing Errors ASIN search:');
            amazomatic_log_to_file( 'Error code ASIN search: '. $searchItemsResponse->getErrors()[0]->getCode());
            amazomatic_log_to_file( 'Error message ASIN search: ' . $searchItemsResponse->getErrors()[0]->getMessage());
            throw new Exception('Error occured in Amazon API ASIN search.');
        }
    } catch (ApiException $exception) {
        amazomatic_log_to_file( "Error calling PA-API 5.0 ASIN search!");
        amazomatic_log_to_file( "HTTP Status Code ASIN search: " . $exception->getCode());
        amazomatic_log_to_file( "Error Message ASIN search: " . $exception->getMessage());
        if ($exception->getResponseObject() instanceof ProductAdvertisingAPIClientException) {
            $errors = $exception->getResponseObject()->getErrors();
            foreach ($errors as $error) {
                amazomatic_log_to_file( "Error Type: " . $error->getCode());
                amazomatic_log_to_file( "Error Message: " . $error->getMessage());
            }
        } else {
            amazomatic_log_to_file( "Error response body ASIN search: " . $exception->getResponseBody());
        }
        throw new Exception('ApiException occured in Amazon API ASIN search.');
    } catch (Exception $exception) {
        amazomatic_log_to_file( "Error Message in ASIN search: " . $exception->getMessage());
        throw new Exception('Exception occured in Amazon API ASIN Search.');
    }
    throw new Exception('Unknown error occurred in ASIN search.');
}

function amazomatic_searchItems_v5($region, $public_key, $private_key, $associate_tag, $keyword, $product_type, $additionalParam, $min_price, $max_price, $node, $page_nr, $max)
{
    $host = 'us-east-1';
    if($region == 'com')
    {
        $host = 'us-east-1';
    }elseif($region == 'co.uk')
    {
        $host = 'eu-west-1';
    }elseif($region == 'ae')
    {
        $host = 'eu-west-1';
    }elseif($region == 'com.tr')
    {
        $host = 'eu-west-1';
    }elseif($region == 'es')
    {
        $host = 'eu-west-1';
    }elseif($region == 'sg')
    {
        $host = 'us-west-2';
    }elseif($region == 'com.mx')
    {
        $host = 'us-east-1';
    }elseif($region == 'co.jp')
    {
        $host = 'us-west-2';
    }elseif($region == 'it')
    {
        $host = 'eu-west-1';
    }elseif($region == 'ca')
    {
        $host = 'us-east-1';
    }elseif($region == 'de')
    {
        $host = 'eu-west-1';
    }elseif($region == 'fr')
    {
        $host = 'eu-west-1';
    }elseif($region == 'com.br')
    {
        $host = 'us-east-1';
    }elseif($region == 'in')
    {
        $host = 'eu-west-1';
    }elseif($region == 'com.au')
    {
        $host = 'us-west-2';
    }
    $region = 'webservices.amazon.' . $region;
    $xtemp = $region;
    $region = $host;
    $host = $xtemp;
    require_once(__DIR__ . '/res/amazon/vendor/autoload.php');
    $config = new Configuration();

    /*
     * Add your credentials
     * Please add your access key here
     */
     
    $config->setAccessKey($public_key);
    # Please add your secret key here
    $config->setSecretKey($private_key);

    # Please add your partner tag (store/tracking id) here
    $partnerTag = $associate_tag;

    /*
     * PAAPI host and region to which you want to send request
     * For more details refer: https://webservices.amazon.com/paapi5/documentation/common-request-parameters.html#host-and-region
     */
    $config->setHost($host);
    $config->setRegion($region);

    $apiInstance = new DefaultApi(
    /*
     * If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
     * This is optional, `GuzzleHttp\Client` will be used as default.
     */
        new GuzzleHttp\Client(), $config);

    # Request initialization

    /*
     * Specify the category in which search request is to be made
     * For more details, refer: https://webservices.amazon.com/paapi5/documentation/use-cases/organization-of-items-on-amazon/search-index.html
     */
    $searchIndex = $product_type;

    # Specify item count to be returned in search result
    $itemCount = intval($max);

    /*
     * Choose resources you want from SearchItemsResource enum
     * For more details, refer: https://webservices.amazon.com/paapi5/documentation/search-items.html#resources-parameter
     */
    $resources = array(
        SearchItemsResource::BROWSE_NODE_INFOBROWSE_NODES,
            SearchItemsResource::BROWSE_NODE_INFOBROWSE_NODESANCESTOR,
            SearchItemsResource::BROWSE_NODE_INFOBROWSE_NODESSALES_RANK,
            SearchItemsResource::BROWSE_NODE_INFOWEBSITE_SALES_RANK,
            SearchItemsResource::IMAGESPRIMARYSMALL,
            SearchItemsResource::IMAGESPRIMARYMEDIUM,
            SearchItemsResource::IMAGESPRIMARYLARGE,
            SearchItemsResource::IMAGESVARIANTSSMALL,
            SearchItemsResource::IMAGESVARIANTSMEDIUM,
            SearchItemsResource::IMAGESVARIANTSLARGE,
            SearchItemsResource::ITEM_INFOBY_LINE_INFO,
            SearchItemsResource::ITEM_INFOCONTENT_INFO,
            SearchItemsResource::ITEM_INFOCONTENT_RATING,
            SearchItemsResource::ITEM_INFOCLASSIFICATIONS,
            SearchItemsResource::ITEM_INFOEXTERNAL_IDS,
            SearchItemsResource::ITEM_INFOFEATURES,
            SearchItemsResource::ITEM_INFOMANUFACTURE_INFO,
            SearchItemsResource::ITEM_INFOPRODUCT_INFO,
            SearchItemsResource::ITEM_INFOTECHNICAL_INFO,
            SearchItemsResource::ITEM_INFOTITLE,
            SearchItemsResource::ITEM_INFOTRADE_IN_INFO,
            SearchItemsResource::OFFERSLISTINGSAVAILABILITYMAX_ORDER_QUANTITY,
            SearchItemsResource::OFFERSLISTINGSAVAILABILITYMESSAGE,
            SearchItemsResource::OFFERSLISTINGSAVAILABILITYMIN_ORDER_QUANTITY,
            SearchItemsResource::OFFERSLISTINGSAVAILABILITYTYPE,
            SearchItemsResource::OFFERSLISTINGSCONDITION,
            SearchItemsResource::OFFERSLISTINGSCONDITIONSUB_CONDITION,
            SearchItemsResource::OFFERSLISTINGSDELIVERY_INFOIS_AMAZON_FULFILLED,
            SearchItemsResource::OFFERSLISTINGSDELIVERY_INFOIS_FREE_SHIPPING_ELIGIBLE,
            SearchItemsResource::OFFERSLISTINGSDELIVERY_INFOIS_PRIME_ELIGIBLE,
            SearchItemsResource::OFFERSLISTINGSDELIVERY_INFOSHIPPING_CHARGES,
            SearchItemsResource::OFFERSLISTINGSIS_BUY_BOX_WINNER,
            SearchItemsResource::OFFERSLISTINGSLOYALTY_POINTSPOINTS,
            SearchItemsResource::OFFERSLISTINGSMERCHANT_INFO,
            SearchItemsResource::OFFERSLISTINGSPRICE,
            SearchItemsResource::OFFERSLISTINGSPROGRAM_ELIGIBILITYIS_PRIME_EXCLUSIVE,
            SearchItemsResource::OFFERSLISTINGSPROGRAM_ELIGIBILITYIS_PRIME_PANTRY,
            SearchItemsResource::OFFERSLISTINGSPROMOTIONS,
            SearchItemsResource::OFFERSLISTINGSSAVING_BASIS,
            SearchItemsResource::OFFERSSUMMARIESHIGHEST_PRICE,
            SearchItemsResource::OFFERSSUMMARIESLOWEST_PRICE,
            SearchItemsResource::OFFERSSUMMARIESOFFER_COUNT,
            SearchItemsResource::PARENT_ASIN,
            SearchItemsResource::RENTAL_OFFERSLISTINGSAVAILABILITYMAX_ORDER_QUANTITY,
            SearchItemsResource::RENTAL_OFFERSLISTINGSAVAILABILITYMESSAGE,
            SearchItemsResource::RENTAL_OFFERSLISTINGSAVAILABILITYMIN_ORDER_QUANTITY,
            SearchItemsResource::RENTAL_OFFERSLISTINGSAVAILABILITYTYPE,
            SearchItemsResource::RENTAL_OFFERSLISTINGSBASE_PRICE,
            SearchItemsResource::RENTAL_OFFERSLISTINGSCONDITION,
            SearchItemsResource::RENTAL_OFFERSLISTINGSCONDITIONSUB_CONDITION,
            SearchItemsResource::RENTAL_OFFERSLISTINGSDELIVERY_INFOIS_AMAZON_FULFILLED,
            SearchItemsResource::RENTAL_OFFERSLISTINGSDELIVERY_INFOIS_FREE_SHIPPING_ELIGIBLE,
            SearchItemsResource::RENTAL_OFFERSLISTINGSDELIVERY_INFOIS_PRIME_ELIGIBLE,
            SearchItemsResource::RENTAL_OFFERSLISTINGSDELIVERY_INFOSHIPPING_CHARGES,
            SearchItemsResource::RENTAL_OFFERSLISTINGSMERCHANT_INFO);

    # Forming the request
    $searchItemsRequest = new SearchItemsRequest();
    $searchItemsRequest->setSearchIndex($searchIndex);
    if($keyword != '' && $keyword != '*')
    {
        $searchItemsRequest->setKeywords($keyword);
    }
    $searchItemsRequest->setItemCount($itemCount);
    $searchItemsRequest->setPartnerTag($partnerTag);
    $searchItemsRequest->setPartnerType(PartnerType::ASSOCIATES);
    $searchItemsRequest->setResources($resources);
    if($min_price != '')
    {
        $searchItemsRequest->setMinPrice(intval($min_price));
    }
    if($max_price != '')
    {
        $searchItemsRequest->setMaxPrice(intval($max_price));
    }
    if($node != '')
    {
        $searchItemsRequest->setBrowseNodeId($node);
    }
    if($page_nr != '' && intval($page_nr) > 1 && intval($page_nr) <= 10)
    {
        $searchItemsRequest->setItemPage(intval($page_nr));
    }
    if(isset($additionalParam['Sort']))
    {
        $searchItemsRequest->setSortBy($additionalParam['Sort']);
    }
    if(isset($additionalParam['Actor']))
    {
        $searchItemsRequest->setActor($additionalParam['Actor']);
    }
    if(isset($additionalParam['Artist']))
    {
        $searchItemsRequest->setArtist($additionalParam['Artist']);
    }
    if(isset($additionalParam['Author']))
    {
        $searchItemsRequest->setAuthor($additionalParam['Author']);
    }
    if(isset($additionalParam['AudienceRating']))
    {
        $searchItemsRequest->setMinReviewsRating(intval($additionalParam['AudienceRating']));
    }
    if(isset($additionalParam['Availability']))
    {
        $searchItemsRequest->setAvailability($additionalParam['Availability']);
    }
    if(isset($additionalParam['Brand']))
    {
        $searchItemsRequest->setBrand($additionalParam['Brand']);
    }
    if(isset($additionalParam['Condition']))
    {
        $searchItemsRequest->setCondition($additionalParam['Condition']);
    }
    if(isset($additionalParam['MerchantId']))
    {
        $searchItemsRequest->setMerchant($additionalParam['MerchantId']);
    }
    if(isset($additionalParam['MinPercentageOff']))
    {
        $searchItemsRequest->setMinSavingPercent($additionalParam['MinPercentageOff']);
    }
    # Validating request
    $invalidPropertyList = $searchItemsRequest->listInvalidProperties();
    $length = count($invalidPropertyList);
    if ($length > 0) {
        amazomatic_log_to_file("Error forming the request!");
        foreach ($invalidPropertyList as $invalidProperty) {
            amazomatic_log_to_file('invalidProperty: ' . $invalidProperty);
        }
        throw new Exception('Invalid properties set!');
    }
    # Sending the request
    try {
        $searchItemsResponse = $apiInstance->searchItems($searchItemsRequest);
        # Parsing the response
        if ($searchItemsResponse->getSearchResult() != null) {
            
            $items = $searchItemsResponse->getSearchResult()->getItems();
            if ($items == null) {
                amazomatic_log_to_file( 'Items is null: ' . print_r($searchItemsResponse, true));
                throw new Exception('Items is null!');
            }
            return $items;
        }
        if ($searchItemsResponse->getErrors() != null) {
            amazomatic_log_to_file( 'Printing Errors:');
            amazomatic_log_to_file( 'Error code: '. $searchItemsResponse->getErrors()[0]->getCode());
            amazomatic_log_to_file( 'Error message: ' . $searchItemsResponse->getErrors()[0]->getMessage());
            throw new Exception('Error occured in Amazon API.');
        }
    } catch (ApiException $exception) {
        amazomatic_log_to_file( "Error calling PA-API 5.0!");
        amazomatic_log_to_file( "HTTP Status Code: " . $exception->getCode());
        amazomatic_log_to_file( "Error Message: " . $exception->getMessage());
        if ($exception->getResponseObject() instanceof ProductAdvertisingAPIClientException) {
            $errors = $exception->getResponseObject()->getErrors();
            foreach ($errors as $error) {
                amazomatic_log_to_file( "Error Type: " . $error->getCode());
                amazomatic_log_to_file( "Error Message: " . $error->getMessage());
            }
        } else {
            amazomatic_log_to_file( "Error response body: " . $exception->getResponseBody());
        }
        throw new Exception('ApiException occured in Amazon API.');
    } catch (Exception $exception) {
        amazomatic_log_to_file( "Error Message: " . $exception->getMessage());
        throw new Exception('Exception occured in Amazon API.');
    }
    throw new Exception('Unknown error occurred.');
}

function amazomatic_getItemResult($region, $public_key, $private_key, $associate_tag, $keyword, $additionalParam, $page_nr)
{
    $parameters = array("Operation"   => "SimilarityLookup",
                                "ItemPage"    =>  $page_nr,
                                "ResponseGroup" => "Large,VariationSummary,Variations");       
    if(  $keyword != '%2A' && $keyword !='*' )
    {
        $parameters['ItemId'] =  $keyword ;
    }
    $parameters=array_merge($parameters, $additionalParam);
    $xml_response = amazomatic_aws_signed_request($region, $parameters, $public_key, $private_key, $associate_tag);
    $err='';
    if(isset($xml_response->Error->Message))
    {
        $err=$xml_response->Error->Message;
    }
    if(trim($err) != ''){
        throw new Exception('<br/>'.$err);
    }
    if ($xml_response === False)
    {
        throw new Exception("Amazon returned false");
    }
    else
    {
        if (isset($xml_response->Items->Item->itemInfo->title->label))
        {
            return ($xml_response);
        }
        else
        {
            if(isset($xml_response->Items->Request->Errors->Error->Message))
            {
                $err=$xml_response->Items->Request->Errors->Error->Message;
                if(trim($err) != '' ){
                    if (stripos($err, 'There are no similar items for this ASIN:') !== false) 
                    {
                        return false;
                    }
                    else
                    {
                        throw new Exception('<br/><b>Error</b>:'.$err);
                    }
                }
            }
        }
    }
    throw new Exception("Unknown error occured: " . print_r($xml_response, true));
}

function amazomatic_aws_signed_request($region, $params, $public_key, $private_key, $associate_tag)
{
    /*
    Copyright (c) 2009 Ulrich Mierendorff
    
    Permission is hereby granted, free of charge, to any person obtaining a
    copy of this software and associated documentation files (the "Software"),
    to deal in the Software without restriction, including without limitation
    the rights to use, copy, modify, merge, publish, distribute, sublicense,
    and/or sell copies of the Software, and to permit persons to whom the
    Software is furnished to do so, subject to the following conditions:
    
    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.
    
    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
    THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
    FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.
    */
    
    /*
    Parameters:
    $region - the Amazon(r) region (ca,com,co.uk,de,fr,jp)
    $params - an array of parameters, eg. array("Operation"=>"ItemLookup",
    "ItemId"=>"B000X9FLKM", "ResponseGroup"=>"Small")
    $public_key - your "Access Key ID"
    $private_key - your "Secret Access Key"
    */
    
    $method = "GET";
    $host = "webservices.amazon.". strtolower($region);
    $uri    = "/onca/xml";
    $params["Service"]        = "AWSECommerceService";
    $params["AWSAccessKeyId"] = $public_key;
    $params["AssociateTag"]   = $associate_tag;
    $params["Timestamp"]      = gmdate("Y-m-d\TH:i:s\Z");
    $params["Version"]        = "2017-04-01";
    ksort($params);
    $canonicalized_query = array();
    foreach ($params as $param => $value)
    {
        $param                 = str_replace("%7E", "~", rawurlencode($param));
        $value                 = str_replace("%7E", "~", rawurlencode($value));
        $canonicalized_query[] = $param . "=" . $value;
    }
    $canonicalized_query = implode("&", $canonicalized_query);
    $string_to_sign = $method . "\n" . $host . "\n" . $uri . "\n" . $canonicalized_query;
    $signature = base64_encode(hash_hmac("sha256", $string_to_sign, $private_key, True));
    $signature = str_replace("%7E", "~", rawurlencode($signature));
    $request = "http://" . $host . $uri . "?" . $canonicalized_query . "&Signature=" . $signature;
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $request);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $response = curl_exec($ch);
    curl_close($ch);
    
    if ($response === False)
    {
        global $wp_filesystem;
        if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
            include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
            wp_filesystem($creds);
        }
        $response = $wp_filesystem->get_contents($request);
        if($response === FALSE)
        {
            return FALSE;
        }
        else
        {
            $pxml = simplexml_load_string($response);
            if ($pxml === False)
            {
                return False;
            }
            else
            {
                return $pxml;
            }
        }
    }
    else
    {
        $pxml = simplexml_load_string($response);
        usleep(500000);
        if ($pxml === False)
        {
            return False;
        }
        else
        {
            return $pxml;
        }
    }
}

function amazomatic_run_rule($param, $type, $auto = 1, $ret_content = 0)
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if($ret_content == 0)
    {
        $f = fopen(get_temp_dir() . 'amazomatic_' . $type . '_' . $param, 'w');
        if($f !== false)
        {
            $flock_disabled = explode(',', ini_get('disable_functions'));
            if(!in_array('flock', $flock_disabled))
            {
                if (!flock($f, LOCK_EX | LOCK_NB)) {
                    amazomatic_log_to_file('Already running');
                    return 'nochange';
                }
            }
        }
        
        $GLOBALS['wp_object_cache']->delete('amazomatic_running_list', 'options');
                if (!get_option('amazomatic_running_list')) {
                    $running = array();
                } else {
                    $running = get_option('amazomatic_running_list');
                }
                if (!empty($running)) {
                    if (in_array(array(
                        $param => $type
                    ), $running)) {
                        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                            amazomatic_log_to_file('Only one instance of this rule is allowed. Rule is already running!');
                        }
                        return 'nochange';
                    }
                }
                $running[] = array(
                    $param => $type
                );
                update_option('amazomatic_running_list', $running, false);
                register_shutdown_function('amazomatic_clear_flag_at_shutdown', $param, $type);
        if (isset($amazomatic_Main_Settings['rule_timeout']) && $amazomatic_Main_Settings['rule_timeout'] != '') {
            $timeout = intval($amazomatic_Main_Settings['rule_timeout']);
        } else {
            $timeout = 3600;
        }
        ini_set('safe_mode', 'Off');
        ini_set('max_execution_time', $timeout);
        ini_set('ignore_user_abort', 1);
        ini_set('user_agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.2062.124 Safari/537.36');
        ignore_user_abort(true);
        set_time_limit($timeout);
    }
    $posts_inserted         = 0;
    if (isset($amazomatic_Main_Settings['amazomatic_enabled']) && $amazomatic_Main_Settings['amazomatic_enabled'] == 'on') {
        try {
            if (!isset($amazomatic_Main_Settings['app_id']) || trim($amazomatic_Main_Settings['app_id']) == '') {
                amazomatic_log_to_file('You need to insert a valid Amazon Public Key for this to work!');
                if($auto == 1)
                {
                    amazomatic_clearFromList($param, $type);
                }
                return 'fail';
            }
            if (!isset($amazomatic_Main_Settings['app_secret']) || trim($amazomatic_Main_Settings['app_secret']) == '') {
                amazomatic_log_to_file('You need to insert a valid Amazon Private Key for this to work!');
                if($auto == 1)
                {
                    amazomatic_clearFromList($param, $type);
                }
                return 'fail';
            }
            if (!isset($amazomatic_Main_Settings['affiliate_id']) || trim($amazomatic_Main_Settings['affiliate_id']) == '') {
                amazomatic_log_to_file('You need to insert a valid Amazon Affiliate ID for this to work!');
                if($auto == 1)
                {
                    amazomatic_clearFromList($param, $type);
                }
                return 'fail';
            }
            $item_img         = '';
            $rule_keywords    = '';
            $cont             = 0;
            $found            = 0;
            $region           = 'com';
            $schedule         = '';
            $enable_comments  = '1';
            $enable_pingback  = '1';
            $author_link      = '';
            $active           = '0';
            $last_run         = '';
            $ruleType         = 'week';
            $first            = false;
            $others           = array();
            $post_title       = '';
            $post_content     = '';
            $list_item        = '';
            $default_category = '';
            $extra_categories = '';
            $posted_items    = array();
            $post_status     = 'publish';
            $post_type       = 'post';
            $accept_comments = 'closed';
            $post_user_name  = 1;
            $can_create_cat  = 'off';
            $item_create_tag = '';
            $can_create_tag  = 'disabled';
            $item_tags       = '';
            $max             = 50;
            $auto_categories = 'disabled';
            $featured_image  = '0';
            $get_img         = '';
            $img_found       = false;
            $image_url       = '';
            $post_format     = 'post-format-standard';
            $post_array      = array();
            $min_price       = '';
            $max_price       = '';
            $coord           = '';
            $radius          = '';
            $lat             = '';
            $lng             = '';
            $browser_node    = '';
            $result_type     = 'All';
            $sort_results    = 'none';
            $actor_name      = '';
            $artist_name     = '';
            $item_rating     = '';
            $author_name     = '';
            $brand_name      = '';
            $availability    = 'Any';
            $condition       = 'All';
            $publisher       = '';
            $title_url       = '0';
            $only_amazon     = '0';
            $add_link_img    = '0';
            $similarity_type = 'Intersection';
            $min_percentage  = '';
            $rule_type       = 'ASIN';
            $custom_fields   = '';
            $remove_default  = '0';
            $continue_search = '0';
            
            if (!isset($amazomatic_Main_Settings['source']) || $amazomatic_Main_Settings['source'] == '') {
                $region          = 'com';
            }
            else
            {
                $region          = $amazomatic_Main_Settings['source'];
            }
            $adult_filter    = 'Any';
            if ($type == 0) 
            {
                $GLOBALS['wp_object_cache']->delete('amazomatic_rules_list', 'options');
                if (!get_option('amazomatic_rules_list')) {
                    $rules = array();
                } else {
                    $rules = get_option('amazomatic_rules_list');
                }
                if (!empty($rules)) {
                    foreach ($rules as $request => $bundle[]) {
                        if ($cont == $param) {
                            $bundle_values    = array_values($bundle);
                            $myValues         = $bundle_values[$cont];
                            $array_my_values  = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}}
                            $adult_filter     = isset($array_my_values[0]) ? $array_my_values[0] : '';
                            $schedule         = isset($array_my_values[1]) ? $array_my_values[1] : '';
                            $active           = isset($array_my_values[2]) ? $array_my_values[2] : '';
                            $last_run         = isset($array_my_values[3]) ? $array_my_values[3] : '';
                            $max              = isset($array_my_values[4]) ? $array_my_values[4] : '';
                            $post_status      = isset($array_my_values[5]) ? $array_my_values[5] : '';
                            $post_type        = isset($array_my_values[6]) ? $array_my_values[6] : '';
                            $post_user_name   = isset($array_my_values[7]) ? $array_my_values[7] : '';
                            $item_create_tag  = isset($array_my_values[8]) ? $array_my_values[8] : '';
                            $default_category = isset($array_my_values[9]) ? $array_my_values[9] : '';
                            $auto_categories  = isset($array_my_values[10]) ? $array_my_values[10] : '';
                            $can_create_tag   = isset($array_my_values[11]) ? $array_my_values[11] : '';
                            $enable_comments  = isset($array_my_values[12]) ? $array_my_values[12] : '';
                            $featured_image   = isset($array_my_values[13]) ? $array_my_values[13] : '';
                            $image_url        = isset($array_my_values[14]) ? $array_my_values[14] : '';
                            $post_title       = isset($array_my_values[15]) ? htmlspecialchars_decode($array_my_values[15], ENT_QUOTES) : '';
                            $post_content     = isset($array_my_values[16]) ? htmlspecialchars_decode($array_my_values[16], ENT_QUOTES) : '';
                            $enable_pingback  = isset($array_my_values[17]) ? $array_my_values[17] : '';
                            $post_format      = isset($array_my_values[18]) ? $array_my_values[18] : '';
                            $rule_keywords    = isset($array_my_values[19]) ? $array_my_values[19] : '';
                            $min_price        = isset($array_my_values[20]) ? $array_my_values[20] : '';
                            $max_price        = isset($array_my_values[21]) ? $array_my_values[21] : '';
                            $result_type      = isset($array_my_values[22]) ? $array_my_values[22] : '';
                            $browser_node     = isset($array_my_values[23]) ? $array_my_values[23] : '';
                            $sort_results     = isset($array_my_values[24]) ? $array_my_values[24] : '';
                            $actor_name       = isset($array_my_values[25]) ? $array_my_values[25] : '';
                            $artist_name      = isset($array_my_values[26]) ? $array_my_values[26] : '';
                            $item_rating      = isset($array_my_values[27]) ? $array_my_values[27] : '';
                            $author_name      = isset($array_my_values[28]) ? $array_my_values[28] : '';
                            $availability     = isset($array_my_values[29]) ? $array_my_values[29] : '';
                            $brand_name       = isset($array_my_values[30]) ? $array_my_values[30] : '';
                            //unused composer_name
                            $composer_name    = isset($array_my_values[31]) ? $array_my_values[31] : '';
                            $condition        = isset($array_my_values[32]) ? $array_my_values[32] : '';
                            //unused conductor_name
                            $conductor_name   = isset($array_my_values[33]) ? $array_my_values[33] : '';
                            //unused director_name
                            $director_name    = isset($array_my_values[34]) ? $array_my_values[34] : '';
                            //unused manufacturer_name
                            $manufacturer_name= isset($array_my_values[35]) ? $array_my_values[35] : '';
                            $only_amazon      = isset($array_my_values[36]) ? $array_my_values[36] : '';
                            $min_percentage   = isset($array_my_values[37]) ? $array_my_values[37] : '';
                            //unused orchestra
                            $orchestra        = isset($array_my_values[38]) ? $array_my_values[38] : '';
                            //unused power
                            $power            = isset($array_my_values[39]) ? $array_my_values[39] : '';
                            //unused publisher
                            $publisher        = isset($array_my_values[40]) ? $array_my_values[40] : '';
                            $custom_fields    = isset($array_my_values[41]) ? $array_my_values[41] : '';
                            $title_url        = isset($array_my_values[42]) ? $array_my_values[42] : '';
                            $add_link_img     = isset($array_my_values[43]) ? $array_my_values[43] : '';
                            $remove_default   = isset($array_my_values[44]) ? $array_my_values[44] : '';
                            $continue_search  = isset($array_my_values[45]) ? $array_my_values[45] : '';
                            $custom_tax       = isset($array_my_values[46]) ? $array_my_values[46] : '';
                            $found            = 1;
                            break;
                        }
                        $cont = $cont + 1;
                    }
                } else {
                    amazomatic_log_to_file('No rules found for amazomatic_rules_list!');
                    if($auto == 1)
                    {
                        amazomatic_clearFromList($param, $type);
                    }
                    return 'fail';
                }
                if ($found == 0) {
                    amazomatic_log_to_file($param . ' not found in amazomatic_rules_list!');
                    if($auto == 1)
                    {
                        amazomatic_clearFromList($param, $type);
                    }
                    return 'fail';
                } else {
                    if($ret_content == 0)
                    {
                        $GLOBALS['wp_object_cache']->delete('amazomatic_rules_list', 'options');
                        $rules = get_option('amazomatic_rules_list');
                        $rules[$param][3] = amazomatic_get_date_now();
                        update_option('amazomatic_rules_list', $rules, false);
                    }
                }
                if ($enable_comments == '1') {
                    $accept_comments = 'open';
                }
                $additionalParam=array();
                if($sort_results != 'none')
                {
                    $additionalParam['Sort'] = $sort_results;
                }
                if($actor_name != '')
                {
                    $additionalParam['Actor'] = $actor_name;
                }
                if($artist_name != '')
                {
                    $additionalParam['Artist'] = $artist_name;
                }
                if($item_rating != '' && intval($item_rating) >= 1 && intval($item_rating) <= 5)
                {
                    $additionalParam['AudienceRating'] = $item_rating;
                }
                if($author_name != '')
                {
                    $additionalParam['Author'] = $author_name;
                }
                if($availability != 'Any')
                {
                    $additionalParam['Availability'] = $availability;
                }
                if($brand_name != '')
                {
                    $additionalParam['Brand'] = $brand_name;
                }
                if($condition != 'All')
                {
                    $additionalParam['Condition'] = $condition;
                }
                if($only_amazon == '1')
                {
                    $additionalParam['MerchantId'] = 'Amazon';
                }
                if($min_percentage != '')
                {
                    $additionalParam['MinPercentageOff'] = $min_percentage;
                }
                if($continue_search == '1')
                {
                    $GLOBALS['wp_object_cache']->delete('amazomatic_continue_search', 'options');
                    $skip_posts_temp = get_option('amazomatic_continue_search', false);
                    if(isset($skip_posts_temp[$param][$type]) && is_numeric($skip_posts_temp[$param][$type]))
                    {
                        $page_nr = $skip_posts_temp[$param][$type];
                    }
                    else
                    {
                        $skip_posts_temp[$param][$type] = '1';
                        $page_nr = '1';
                    }
                }
                else
                {
                    $page_nr = '1';
                    $GLOBALS['wp_object_cache']->delete('amazomatic_continue_search', 'options');
                    $skip_posts_temp = get_option('amazomatic_continue_search', false);
                    $skip_posts_temp[$param][$type] = '';
                    update_option('amazomatic_continue_search', $skip_posts_temp);
                }
                $result = amazomatic_searchItems_v5($region, trim($amazomatic_Main_Settings['app_id']), trim($amazomatic_Main_Settings['app_secret']), trim($amazomatic_Main_Settings['affiliate_id']), $rule_keywords, $result_type, $additionalParam, $min_price, $max_price, $browser_node, $page_nr, $max);
            }
            elseif ($type == 1)
            {
                amazomatic_log_to_file('Currently SimilarityLookup is not supported in the Amazon V5 API: https://webservices.amazon.com/paapi5/documentation/migration-guide/pa-api-40-to-50-mapping.html');
                return 'nochange';
                $GLOBALS['wp_object_cache']->delete('amazomatic_item_list', 'options');
                if (!get_option('amazomatic_item_list')) {
                    $rules = array();
                } else {
                    $rules = get_option('amazomatic_item_list');
                }
                if (!empty($rules)) {
                    foreach ($rules as $request => $bundle[]) {
                        if ($cont == $param) {
                            $bundle_values    = array_values($bundle);
                            $myValues         = $bundle_values[$cont];
                            $array_my_values  = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}}
                            $adult_filter     = isset($array_my_values[0]) ? $array_my_values[0] : '';
                            $schedule         = isset($array_my_values[1]) ? $array_my_values[1] : '';
                            $active           = isset($array_my_values[2]) ? $array_my_values[2] : '';
                            $last_run         = isset($array_my_values[3]) ? $array_my_values[3] : '';
                            $max              = isset($array_my_values[4]) ? $array_my_values[4] : '';
                            $post_status      = isset($array_my_values[5]) ? $array_my_values[5] : '';
                            $post_type        = isset($array_my_values[6]) ? $array_my_values[6] : '';
                            $post_user_name   = isset($array_my_values[7]) ? $array_my_values[7] : '';
                            $item_create_tag  = isset($array_my_values[8]) ? $array_my_values[8] : '';
                            $default_category = isset($array_my_values[9]) ? $array_my_values[9] : '';
                            $auto_categories  = isset($array_my_values[10]) ? $array_my_values[10] : '';
                            $can_create_tag   = isset($array_my_values[11]) ? $array_my_values[11] : '';
                            $enable_comments  = isset($array_my_values[12]) ? $array_my_values[12] : '';
                            $featured_image   = isset($array_my_values[13]) ? $array_my_values[13] : '';
                            $image_url        = isset($array_my_values[14]) ? $array_my_values[14] : '';
                            $post_title       = isset($array_my_values[15]) ? htmlspecialchars_decode($array_my_values[15], ENT_QUOTES) : '';
                            $post_content     = isset($array_my_values[16]) ? htmlspecialchars_decode($array_my_values[16], ENT_QUOTES) : '';
                            $enable_pingback  = isset($array_my_values[17]) ? $array_my_values[17] : '';
                            $post_format      = isset($array_my_values[18]) ? $array_my_values[18] : '';
                            $rule_keywords    = isset($array_my_values[19]) ? $array_my_values[19] : '';
                            $condition        = isset($array_my_values[20]) ? $array_my_values[20] : '';
                            $only_amazon      = isset($array_my_values[21]) ? $array_my_values[21] : '';
                            $similarity_type  = isset($array_my_values[22]) ? $array_my_values[22] : '';
                            $custom_fields    = isset($array_my_values[23]) ? $array_my_values[23] : '';
                            $title_url        = isset($array_my_values[24]) ? $array_my_values[24] : '';
                            $add_link_img     = isset($array_my_values[25]) ? $array_my_values[25] : '';
                            $remove_default   = isset($array_my_values[26]) ? $array_my_values[26] : '';
                            $continue_search  = isset($array_my_values[27]) ? $array_my_values[27] : '';
                            $custom_tax       = isset($array_my_values[28]) ? $array_my_values[28] : '';
                            $found            = 1;
                            break;
                        }
                        $cont = $cont + 1;
                    }
                } else {
                    amazomatic_log_to_file('No rules found for amazomatic_item_list!');
                    if($auto == 1)
                    {
                        amazomatic_clearFromList($param, $type);
                    }
                    return 'fail';
                }
                if ($found == 0) {
                    amazomatic_log_to_file($param . ' not found in amazomatic_item_list!');
                    if($auto == 1)
                    {
                        amazomatic_clearFromList($param, $type);
                    }
                    return 'fail';
                } else {
                    if($ret_content == 0)
                    {
                        $GLOBALS['wp_object_cache']->delete('amazomatic_item_list', 'options');
                        $rules = get_option('amazomatic_item_list');
                        $rules[$param][3] = amazomatic_get_date_now();
                        update_option('amazomatic_item_list', $rules, false);
                    }
                }
                if ($enable_comments == '1') {
                    $accept_comments = 'open';
                }
                $additionalParam=array();
                if($condition != 'All')
                {
                    $additionalParam['Condition'] = $condition;
                }
                if($only_amazon == '1')
                {
                    $additionalParam['MerchantId'] = 'Amazon';
                }
                if($similarity_type !== 'Intersection')
                {
                    $additionalParam['SimilarityType'] = $similarity_type;
                }
                if($continue_search == '1')
                {
                    $GLOBALS['wp_object_cache']->delete('amazomatic_continue_search', 'options');
                    $skip_posts_temp = get_option('amazomatic_continue_search', false);
                    if(isset($skip_posts_temp[$param][$type]) && is_numeric($skip_posts_temp[$param][$type]))
                    {
                        $page_nr = $skip_posts_temp[$param][$type];
                    }
                    else
                    {
                        $skip_posts_temp[$param][$type] = '1';
                        $page_nr = '1';
                    }
                }
                else
                {
                    $page_nr = '1';
                    $GLOBALS['wp_object_cache']->delete('amazomatic_continue_search', 'options');
                    $skip_posts_temp = get_option('amazomatic_continue_search', false);
                    $skip_posts_temp[$param][$type] = '';
                    update_option('amazomatic_continue_search', $skip_posts_temp);
                }
                $result = amazomatic_getItemResult($region, trim($amazomatic_Main_Settings['app_id']), trim($amazomatic_Main_Settings['app_secret']), trim($amazomatic_Main_Settings['affiliate_id']), $rule_keywords, $additionalParam, $page_nr);
                if($result === FALSE)
                {
                    amazomatic_log_to_file('No similar items found for ASIN: ' . $rule_keywords);
                    if($auto == 1)
                    {
                        amazomatic_clearFromList($param, $type);
                    }
                    return 'nochange';
                }
            }
            elseif ($type == 2)
            {
                $GLOBALS['wp_object_cache']->delete('amazomatic_lookup_list', 'options');
                if (!get_option('amazomatic_lookup_list')) {
                    $rules = array();
                } else {
                    $rules = get_option('amazomatic_lookup_list');
                }
                if (!empty($rules)) {
                    foreach ($rules as $request => $bundle[]) {
                        if ($cont == $param) {
                            $bundle_values    = array_values($bundle);
                            $myValues         = $bundle_values[$cont];
                            $array_my_values  = array_values($myValues);for($iji=0;$iji<count($array_my_values);++$iji){if(is_string($array_my_values[$iji])){$array_my_values[$iji]=stripslashes($array_my_values[$iji]);}}
                            $adult_filter     = isset($array_my_values[0]) ? $array_my_values[0] : '';
                            $schedule         = isset($array_my_values[1]) ? $array_my_values[1] : '';
                            $active           = isset($array_my_values[2]) ? $array_my_values[2] : '';
                            $last_run         = isset($array_my_values[3]) ? $array_my_values[3] : '';
                            $max              = isset($array_my_values[4]) ? $array_my_values[4] : '';
                            $post_status      = isset($array_my_values[5]) ? $array_my_values[5] : '';
                            $post_type        = isset($array_my_values[6]) ? $array_my_values[6] : '';
                            $post_user_name   = isset($array_my_values[7]) ? $array_my_values[7] : '';
                            $item_create_tag  = isset($array_my_values[8]) ? $array_my_values[8] : '';
                            $default_category = isset($array_my_values[9]) ? $array_my_values[9] : '';
                            $auto_categories  = isset($array_my_values[10]) ? $array_my_values[10] : '';
                            $can_create_tag   = isset($array_my_values[11]) ? $array_my_values[11] : '';
                            $enable_comments  = isset($array_my_values[12]) ? $array_my_values[12] : '';
                            $featured_image   = isset($array_my_values[13]) ? $array_my_values[13] : '';
                            $image_url        = isset($array_my_values[14]) ? $array_my_values[14] : '';
                            $post_title       = isset($array_my_values[15]) ? htmlspecialchars_decode($array_my_values[15], ENT_QUOTES) : '';
                            $post_content     = isset($array_my_values[16]) ? htmlspecialchars_decode($array_my_values[16], ENT_QUOTES) : '';
                            $enable_pingback  = isset($array_my_values[17]) ? $array_my_values[17] : '';
                            $post_format      = isset($array_my_values[18]) ? $array_my_values[18] : '';
                            $rule_keywords    = isset($array_my_values[19]) ? $array_my_values[19] : '';
                            $result_type      = isset($array_my_values[20]) ? $array_my_values[20] : '';
                            $condition        = isset($array_my_values[21]) ? $array_my_values[21] : '';
                            $only_amazon      = isset($array_my_values[22]) ? $array_my_values[22] : '';
                            $rule_type        = isset($array_my_values[23]) ? $array_my_values[23] : '';
                            $custom_fields    = isset($array_my_values[24]) ? $array_my_values[24] : '';
                            $title_url        = isset($array_my_values[25]) ? $array_my_values[25] : '';
                            $add_link_img     = isset($array_my_values[26]) ? $array_my_values[26] : '';
                            $remove_default   = isset($array_my_values[27]) ? $array_my_values[27] : '';
                            $continue_search  = isset($array_my_values[28]) ? $array_my_values[28] : '';
                            $custom_tax       = isset($array_my_values[29]) ? $array_my_values[29] : '';
                            $found            = 1;
                            break;
                        }
                        $cont = $cont + 1;
                    }
                } else {
                    amazomatic_log_to_file('No rules found for amazomatic_lookup_list!');
                    if($auto == 1)
                    {
                        amazomatic_clearFromList($param, $type);
                    }
                    return 'fail';
                }
                if ($found == 0) {
                    amazomatic_log_to_file($param . ' not found in amazomatic_lookup_list!');
                    if($auto == 1)
                    {
                        amazomatic_clearFromList($param, $type);
                    }
                    return 'fail';
                } else {
                    if($ret_content == 0)
                    {
                        $GLOBALS['wp_object_cache']->delete('amazomatic_lookup_list', 'options');
                        $rules = get_option('amazomatic_lookup_list');
                        $rules[$param][3] = amazomatic_get_date_now();
                        update_option('amazomatic_lookup_list', $rules, false);
                    }
                }
                if ($enable_comments == '1') {
                    $accept_comments = 'open';
                }
                $additionalParam=array();
                if($condition != 'All')
                {
                    $additionalParam['Condition'] = $condition;
                }
                if($only_amazon == '1')
                {
                    $additionalParam['MerchantId'] = 'Amazon';
                }
                if($rule_type !== 'ASIN')
                {
                    $additionalParam['IdType'] = $rule_type;
                }
                $additionalParam['IncludeReviewsSummary'] = true;
                $itemIds_test = array();
                if(  $rule_keywords != '%2A' && $rule_keywords !='*' )
                {
                    $itemIds_test =  explode(',', str_replace(' ', '', $rule_keywords)) ;
                }
                $sliced = false;
                if($continue_search == '1')
                {
                    if(count($itemIds_test) > $max)
                    {
                        $skip_posts_temp = get_option('amazomatic_continue_search', array());
                        if(isset($skip_posts_temp[$param][$type]) && $skip_posts_temp[$param][$type] != '')
                        {
                            $indexi = $skip_posts_temp[$param][$type];
                            if(count($itemIds_test) > $indexi)
                            {
                                $itemIds_test = array_slice($itemIds_test, $indexi, $max, true);
                                $skip_posts_temp[$param][$type] = $indexi + $max;
                                update_option('amazomatic_continue_search', $skip_posts_temp);
                                $sliced = true;
                            }
                            else
                            {
                                $itemIds_test = array_slice($itemIds_test, 0, $max, true);
                                $skip_posts_temp[$param][$type] = $max;
                                update_option('amazomatic_continue_search', $skip_posts_temp);
                                $sliced = true;
                            }
                        }
                        else
                        {
                            $itemIds_test = array_slice($itemIds_test, 0, $max, true);
                            $skip_posts_temp[$param][$type] = $max;
                            update_option('amazomatic_continue_search', $skip_posts_temp);
                            $sliced = true;
                        }
                    }
                } 
                else
                {
                    $skip_posts_temp[$param][$type] = '';
                    update_option('amazomatic_continue_search', $skip_posts_temp);
                }
                if(count($itemIds_test) > 10 || $sliced == true)
                {
                    $result = array();
                    $chunky = array_chunk($itemIds_test, 10);
                    if($chunky != null)
                    {
                        foreach($chunky as $chunki)
                        {
                            $rule_keywords_temp = implode(',', $chunki);
                            $result_tmp = amazomatic_getItems_v5($region, trim($amazomatic_Main_Settings['app_id']), trim($amazomatic_Main_Settings['app_secret']), trim($amazomatic_Main_Settings['affiliate_id']), $rule_keywords_temp, $additionalParam);
                            if (is_array($result_tmp))
                            {
                                $result = array_merge($result, $result_tmp);
                            }
                        }
                    }
                }
                else
                {
                    $result = amazomatic_getItems_v5($region, trim($amazomatic_Main_Settings['app_id']), trim($amazomatic_Main_Settings['app_secret']), trim($amazomatic_Main_Settings['affiliate_id']), $rule_keywords, $additionalParam);
                }
            }
            else
            {
                amazomatic_log_to_file('Unknown rule type received: ' . $type);
                if($auto == 1)
                {
                    amazomatic_clearFromList($param, $type);
                }
                return 'fail';
            }
            if($result === FALSE)
            {
                if($continue_search == '1')
                {
                    $skip_posts_temp[$param][$type] = '';
                    update_option('amazomatic_continue_search', $skip_posts_temp);
                }
                amazomatic_log_to_file('Amazon query returned false');
                if($auto == 1)
                {
                    amazomatic_clearFromList($param, $type);
                }
                return 'fail';
            }
            if (!is_array($result))
            {
                if($continue_search == '1')
                {
                    $skip_posts_temp[$param][$type] = '';
                    update_option('amazomatic_continue_search', $skip_posts_temp);
                }
                amazomatic_log_to_file('Unknow response from Amazon ' . print_r($result, true));
                if($auto == 1)
                {
                    amazomatic_clearFromList($param, $type);
                }
                return 'fail';
            }
            $items = $result;
            if (count($items) == 0) {
                if($continue_search == '1')
                {
                    $skip_posts_temp[$param][$type] = '';
                    update_option('amazomatic_continue_search', $skip_posts_temp);
                }
                amazomatic_log_to_file('No posts inserted because no posts found.');
                if($auto == 1)
                {
                    amazomatic_clearFromList($param, $type);
                }
                return 'nochange';
            }

            $post_list = array();
            if($ret_content == 0)
            {
                $postsPerPage = 50000;
                $paged = 0;
                do
                {
                    $postOffset = $paged * $postsPerPage;
                    $query = array(
                        'post_status' => array(
                            'publish',
                            'draft',
                            'pending',
                            'trash',
                            'private',
                            'future'
                        ),
                        'post_type' => array(
                            'any'
                        ),
                        'numberposts' => $postsPerPage,
                        'meta_key' => 'amazomatic_post_id',
                        'fields' => 'ids',
                        'offset'  => $postOffset
                    );
                    $got_me = get_posts($query);
                    $post_list = array_merge($post_list, $got_me);
                    $paged++;
                }while(!empty($got_me));
                
                wp_suspend_cache_addition(true);
                foreach ($post_list as $post) {
                    $posted_items[] = get_post_meta($post, 'amazomatic_post_id', true);
                }
                wp_suspend_cache_addition(false);
            }
            $count = 1;
            $post_title_sablon = $post_title;
            $spintax = new Amazomatic_Spintax();
            $post_content = $spintax->process($post_content);
            $post_title = $spintax->process($post_title);
            $init_date = time();
            
            $skip_pcount = 0;
            $skipped_pcount = 0;
            if($ret_content == 1)
            {
                $item_xcounter = count($items);
                $skip_pcount = rand(0, $item_xcounter-1);
            }
            foreach ($items as $item) {
                $content = '';
                $description = '';
                if($ret_content == 1)
                {
                    if($skip_pcount > $skipped_pcount)
                    {
                        $skipped_pcount++;
                        continue;
                    }
                }
                
                $get_img = '';
                $img_found = false;
                if ($count > intval($max)) {
                    break;
                }
                if (in_array((string)$item->getASIN(), $posted_items)) {
                    if (isset($amazomatic_Main_Settings['enable_detailed_logging']) && $amazomatic_Main_Settings['enable_detailed_logging'] == 'on') {
                        amazomatic_log_to_file('ASIN ' . $item->getASIN() . ' is already posted, skipping it.');
                    }
                    continue;
                }
                $masin = $item->getASIN();
                $url = $item->getDetailPageURL();
                $images = $item->getImages();
                $image_set         = array();
                if($images != null)
                {
                    $primary = $images->getPrimary();
                    if($primary != null)
                    {
                        $lp = $primary->getLarge();
                        if($lp != null)
                        {
                            $get_img = $lp->getURL();
                            $img_found = true;
                        }
                    }
                    $variants = $images->getVariants();
                    if($variants != null)
                    {
                        foreach($variants as $vari)
                        {
                            $vari_large = $vari->getLarge();
                            if($vari_large != null)
                            {
                                $image_set[] = $vari_large->getURL();
                            }
                        }
                    }
                }
                if (isset($amazomatic_Main_Settings['links_hide']) && $amazomatic_Main_Settings['links_hide'] == 'on' && isset($amazomatic_Main_Settings['apiKey']))
                {
                    $url = amazomatic_url_handle($url);
                }
                $item_info = $item->getItemInfo();
                $zatitle = $item_info->getTitle();
                if($zatitle != null)
                {
                    $title = $zatitle->getDisplayValue();
                }
                else
                {
                    $title = '';
                }
                $content_info     = $item_info->getContentInfo();
                if($content_info != null)
                {
                    $edition     = $content_info->getEdition();
                    $language     = $content_info->getLanguages();
                    $pages_count     = $content_info->getPagesCount();
                    $publication_date     = $content_info->getPublicationDate();
                }
                else
                {
                    $edition      = '';
                    $language     = '';
                    $pages_count     = '';
                    $publication_date     = '';
                }
                
                $byline_info     = $item_info->getByLineInfo();
                $contributors     = '';
                if($byline_info != null)
                {
                    $zabrand     = $byline_info->getBrand();
                    if($zabrand != null)
                    {
                        $brand     = $zabrand->getDisplayValue();
                    }
                    else
                    {
                        $brand     = '';
                    }
                    $xcontributors     = $byline_info->getContributors();
                    if(is_array($xcontributors))
                    {
                        foreach($xcontributors as $cntx)
                        {
                            $contributors .= $cntx->getName() . ' ';
                        }
                    }
                    $zamanufacturer     = $byline_info->getManufacturer();
                    if($zamanufacturer != null)
                    {
                        $manufacturer     = $zamanufacturer->getDisplayValue();
                    }
                    else
                    {
                        $manufacturer     = '';
                    }
                }
                else
                {
                    $brand     = '';
                    $manufacturer     = '';
                }
                
                $class_info     = $item_info->getClassifications();
                if($class_info != null)
                {
                    $zabinding     = $class_info->getBinding();
                    if($zabinding != null)
                    {
                        $binding     = $zabinding->getDisplayValue();
                    }
                    else
                    {
                        $binding     = '';
                    }
                    $zaproduct_group     = $class_info->getProductGroup();
                    if($zaproduct_group != null)
                    {
                        $product_group     = $zaproduct_group->getDisplayValue();
                    }
                    else
                    {
                        $product_group     = '';
                    }
                }
                else
                {
                    $binding     = '';
                    $product_group     = '';
                }
                
                $content_rating     = $item_info->getContentRating();
                if($content_rating != null)
                {
                    $rating     = $content_rating->getAudienceRating();
                }
                else
                {
                    $rating     = '';
                }
                
                $external_ids     = $item_info->getExternalIds();
                if($external_ids != null)
                {
                    $eans     = $external_ids->getEANs();
                    $isbns     = $external_ids->getISBNs();
                    $upcs     = $external_ids->getUPCs();
                }
                else
                {
                    $eans     = '';
                    $isbns     = '';
                    $upcs     = '';
                }
                
                $features     = $item_info->getFeatures();
                $feature_list = array();
                if($features != null)
                {
                    $features_display     = $features->getDisplayValues();
                    if($features_display != null)
                    {
                        $content .= '<ul>';
                        foreach($features_display as $dv)
                        {
                            $feature_list[] = $dv;
                            $content .= '<li>' . $dv . '</li>';
                        }
                        $content .= '</ul>';
                    }
                }
                else
                {
                    $features_display     = '';
                }
                $manu_info     = $item_info->getManufactureInfo();
                if($manu_info != null)
                {
                    $part_no     = $manu_info->getItemPartNumber();
                    $model     = $manu_info->getModel();
                    $warranty     = $manu_info->getWarranty();
                }
                else
                {
                    $part_no     = '';
                    $model     = '';
                    $warranty     = '';
                }
                
                $product_info     = $item_info->getProductInfo();
                if($product_info != null)
                {
                    $color     = $product_info->getColor();
                    $is_adult     = $product_info->getIsAdultProduct();
                    $dimensions     = $product_info->getItemDimensions();
                    $date     = $product_info->getReleaseDate();
                    if($date !== null)
                    {
                        $date = $date->getDisplayValue();
                    }
                    else
                    {
                        $date = amazomatic_get_date_now();
                    }
                    $xs = $product_info->getSize();
                    if($xs != null)
                    {
                        $size     = $xs->getDisplayValue();
                    }
                    else
                    {
                        $size     = '';
                    }
                    $unit_count     = $product_info->getUnitCount();
                }
                else
                {
                    $color     = '';
                    $is_adult     = '';
                    $dimensions     = '';
                    $date     = amazomatic_get_date_now();
                    $size     = '';
                    $unit_count     = '';
                }
                
                $tech_info     = $item_info->getTechnicalInfo();
                if($tech_info != null)
                {
                    $part_no     = $tech_info->getFormats();
                }
                else
                {
                    $part_no     = '';
                }
                
                $trade_info     = $item_info->getTradeInInfo();
                if($trade_info != null)
                {
                    $part_no     = $trade_info->getIsEligibleForTradeIn();
                    $price     = $trade_info->getPrice();
                    if($price != null)
                    {
                        $price     = $price->getDisplayAmount();
                    }
                    else
                    {
                        $price     = '';
                    }
                }
                else
                {
                    $part_no     = '';
                    $price     = '';
                }
                if ($item->getOffers() != null && $item->getOffers()->getListings() != null && $item->getOffers()->getListings()[0]->getPrice() != null && $item->getOffers()->getListings()[0]->getPrice()->getDisplayAmount() != null) 
                {
                    $price     = $item->getOffers()->getListings()[0]->getPrice()->getDisplayAmount();
                }
                $condition = '';
                $lowprice = '';
                if($item->getOffers() !== null)
                {
                    $offers = $item->getOffers()->getListings();
                }
                else
                {
                    $offers = null;
                }
                if($offers != null)
                {
                    foreach($offers as $off)
                    {
                        $condition = $off->getCondition();
                        $lowprice = $off->getPrice();
                        if($lowprice != null)
                        {
                            $lowprice = $lowprice->getDisplayAmount();
                            if($price == '')
                            {
                                $price = $lowprice;
                            }
                        }
                        break;
                    }
                }
                
                $description = amazomatic_getExcerpt($content);
                
                if ($contributors != '') 
                {
                    $author = $contributors;
                }
                elseif ($manufacturer != '') 
                {
                    $author = $manufacturer;
                } 
                elseif ($brand != '') 
                {
                    $author = $brand;
                } 
                else 
                {
                    $author = 'Administrator';
                }
                $author_link = $url;
                if (isset($amazomatic_Main_Settings['skip_no_img']) && $amazomatic_Main_Settings['skip_no_img'] == 'on' && $img_found == false) {
                    if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                        amazomatic_log_to_file('Skipping post "' . esc_html($title) . '", because it has no detected image file attached');
                    }
                    continue;
                }
                if (isset($amazomatic_Main_Settings['skip_old']) && $amazomatic_Main_Settings['skip_old'] == 'on' && isset($amazomatic_Main_Settings['skip_year']) && $amazomatic_Main_Settings['skip_year'] !== '' && isset($amazomatic_Main_Settings['skip_month']) && isset($amazomatic_Main_Settings['skip_day'])) {
                    $old_date      = $amazomatic_Main_Settings['skip_day'] . '-' . $amazomatic_Main_Settings['skip_month'] . '-' . $amazomatic_Main_Settings['skip_year'];
                    $time_date     = strtotime($date);
                    $time_old_date = strtotime($old_date);
                    if ($time_date !== false && $time_old_date !== false) {
                        if ($time_date < $time_old_date) {
                            if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                                amazomatic_log_to_file('Skipping post "' . esc_html($title) . '", because it is older than ' . $old_date . ' - posted on ' . $date);
                            }
                            continue;
                        }
                    }
                }
                
                $my_post                              = array();
                
                $my_post['edition']     = $edition;
                $my_post['language']     = $language;
                $my_post['pages_count']     = $pages_count;
                $my_post['publication_date']     = $publication_date;
                $my_post['contributors']     = $contributors;
                $my_post['product_group']     = $product_group;
                $my_post['rating']     = $rating;
                $my_post['eans']     = $eans;
                $my_post['isbns']     = $isbns;
                $my_post['upcs']     = $upcs;
                $my_post['part_no']     = $part_no;
                $my_post['model']     = $model;
                $my_post['warranty']     = $warranty;
                $my_post['color']     = $color;
                $my_post['is_adult']     = $is_adult;
                $my_post['dimensions']     = $dimensions;
                $my_post['unit_count']     = $unit_count;
                $my_post['condition']     = $condition;
                $postdatex = gmdate("Y-m-d H:i:s", intval($init_date));
                $my_post['post_date_gmt'] = $postdatex;
                $init_date = $init_date - 1;
                $my_post['amazomatic_post_title_sablon']   = $post_title_sablon;
                $my_post['amazomatic_post_content_sablon'] = $post_content;
                $my_post['amazomatic_post_id']          = (string)$item->getASIN();
                $bns = $item->getBrowseNodeInfo()->getBrowseNodes();
                $itags = array();
                if(is_array($bns))
                {
                    foreach($bns as $bnx)
                    {
                        $itags[] = $bnx->getDisplayName();
                    }
                }
                $my_post['amazomatic_enable_pingbacks'] = $enable_pingback;
                $my_post['amazomatic_post_image']       = $get_img;
                $my_post['default_category']          = $default_category;
                $my_post['post_type']                 = $post_type;
                $my_post['comment_status']            = $accept_comments;
                $my_post['post_status']               = $post_status;
                $my_post['post_author']               = $post_user_name;
                $item_score = $item->getScore();
                if($item_score != null)
                {
                    $my_post['amazon_sales_rank']          = $item_score;
                }
                else
                {
                    $my_post['amazon_sales_rank']          = '';
                }
                $my_post['amazomatic_image_set']  = $image_set;
                $my_post['amazomatic_binding_category']  = $binding;
                $my_post['amazomatic_brand']  = $brand;
                $my_post['amazomatic_color']  = $color;
                $my_post['amazomatic_feature_list']  = $feature_list;
                $my_post['amazomatic_is_adult_product']  = 'false';
                if($is_adult == true){
                    $my_post['amazomatic_is_adult_product']  = 'true';
                }
                if($adult_filter == 'Safe')
                {
                    if($my_post['amazomatic_is_adult_product'] == 'true')
                    {
                        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                            amazomatic_log_to_file('Skipping post "' . esc_html($title) . '", because it is an adult product');
                        }
                        continue;
                    }
                }
                elseif($adult_filter == 'Adult')
                {
                    if($my_post['amazomatic_is_adult_product'] == 'false')
                    {
                        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                            amazomatic_log_to_file('Skipping post "' . esc_html($title) . '", because it is not an adult product');
                        }
                        continue;
                    }
                }
                if($price != ''){
                    $my_post['amazomatic_price']  = $price;
                }
                else
                {
                    $my_post['amazomatic_price']  = '';
                }
                if($manufacturer != ''){
                    $my_post['amazomatic_manufacturer']  = $manufacturer;
                }
                else
                {
                    $my_post['amazomatic_manufacturer']  = '';
                }
                if($size != ''){
                    $my_post['amazomatic_size']  = $size;
                }
                else
                {
                    $my_post['amazomatic_size']  = '';
                }
                if($lowprice != ''){
                    $my_post['amazomatic_offer_price']  = $lowprice;
                }
                else
                {
                    $my_post['amazomatic_offer_price']  = '';
                }
                
                $my_post['amazomatic_post_url']         = $url;
                $my_post['amazomatic_post_date']        = $date;
                if (isset($amazomatic_Main_Settings['strip_by_id']) && $amazomatic_Main_Settings['strip_by_id'] != '') {
                    $mock = new DOMDocument;
                    $strip_list = explode(',', $amazomatic_Main_Settings['strip_by_id']);
                    $doc        = new DOMDocument();
                    $internalErrors = libxml_use_internal_errors(true);
                    $doc->loadHTML('<?xml encoding="utf-8" ?>' . $content);
                    
                    foreach ($strip_list as $strip_id) {
                        $element = $doc->getElementById(trim($strip_id));
                        if (isset($element)) {
                            $element->parentNode->removeChild($element);
                        }
                    }
                    $body = $doc->getElementsByTagName('body')->item(0);
                    if(isset($body->childNodes))
                    {
                        foreach ($body->childNodes as $child){
                            $mock->appendChild($mock->importNode($child, true));
                        }
                        $temp_cont = $mock->saveHTML();
                        libxml_use_internal_errors($internalErrors);
                        if($temp_cont !== FALSE && $temp_cont != '')
                        {
                            $temp_cont = str_replace('<?xml encoding="utf-8" ?>', '', $temp_cont);
                            $temp_cont = html_entity_decode($temp_cont);
                            $temp_cont = trim($temp_cont);
                            if(substr_compare($temp_cont, '</p>', -strlen('</p>')) === 0){$temp_cont = substr_replace($temp_cont ,"", -4);}
                            if(substr( $temp_cont, 0, 3 ) === "<p>"){$temp_cont = substr($temp_cont, 3);}
                            $content = $temp_cont;
                        }
                    }
                }              
                if (isset($amazomatic_Main_Settings['strip_by_class']) && $amazomatic_Main_Settings['strip_by_class'] != '') {
                    $mock = new DOMDocument;
                    $strip_list = explode(',', $amazomatic_Main_Settings['strip_by_class']);
                    $doc        = new DOMDocument();
                    $internalErrors = libxml_use_internal_errors(true);
                    $doc->loadHTML('<?xml encoding="utf-8" ?>' . $content);
                    
                    foreach ($strip_list as $strip_class) {
                        if(trim($strip_class) == '')
                        {
                            continue;
                        }
                        $finder    = new DomXPath($doc);
                        $classname = trim($strip_class);
                        $nodes     = $finder->query("//*[contains(@class, '$classname')]");
                        if ($nodes === FALSE) {
                            break;
                        }
                        foreach ($nodes as $node) {
                            $node->parentNode->removeChild($node);
                        }
                    }
                    $body = $doc->getElementsByTagName('body')->item(0);
                    if(isset($body->childNodes))
                    {
                        foreach ($body->childNodes as $child){
                            $mock->appendChild($mock->importNode($child, true));
                        }
                        $temp_cont = $mock->saveHTML();
                        libxml_use_internal_errors($internalErrors);
                        if($temp_cont !== FALSE && $temp_cont != '')
                        {
                            $temp_cont = str_replace('<?xml encoding="utf-8" ?>', '', $temp_cont);
                            $temp_cont = html_entity_decode($temp_cont);
                            $temp_cont = trim($temp_cont);
                            if(substr_compare($temp_cont, '</p>', -strlen('</p>')) === 0){$temp_cont = substr_replace($temp_cont ,"", -4);}
                            if(substr( $temp_cont, 0, 3 ) === "<p>"){$temp_cont = substr($temp_cont, 3);}
                            $content = $temp_cont;
                        }
                    }
                }
                $content = preg_replace('{href="/(\w)}', 'href="https://amazon.com/$1', $content);
                if (isset($amazomatic_Main_Settings['strip_links']) && $amazomatic_Main_Settings['strip_links'] == 'on') {
                    $content = amazomatic_strip_links($content);
                }
                if (isset($amazomatic_Main_Settings['only_imported']) && $amazomatic_Main_Settings['only_imported'] == 'on') 
                {
                    $arr                     = amazomatic_spin_and_translate($title, $content);
                    $title                   = $arr[0];
                    $content                 = $arr[1];
                }
                if (strpos($post_content, '%%') !== false) {
                    $new_post_content = amazomatic_replaceContentShortcodes($post_content, $title, $content, $url, $get_img, $description, $author, $author_link, $item->getASIN(), $my_post);
                } else {
                    $new_post_content = $post_content;
                }
                if (strpos($post_title, '%%') !== false) {
                    $new_post_title = amazomatic_replaceTitleShortcodes($post_title, $title, $content, $url);
                } else {
                    $new_post_title = $post_title;
                }
                
                $my_post['description']      = $description;
                $my_post['author']           = $author;
                $my_post['author_link']      = $author_link;
                if (!isset($amazomatic_Main_Settings['only_imported']) || $amazomatic_Main_Settings['only_imported'] != 'on') 
                {
                    $arr                         = amazomatic_spin_and_translate($new_post_title, $new_post_content);
                    $new_post_title              = $arr[0];
                    $new_post_content            = $arr[1];
                }
                
                if ($auto_categories == 'content') {
                    $extra_categories            = amazomatic_extractKeyWords($content);
                    $extra_categories            = implode(',', $extra_categories);
                }
                elseif ($auto_categories == 'item') {
                    $keys = str_replace(' ', ',', implode(',', $itags));
                    $extra_categories = $keys;
                }
                elseif ($auto_categories == 'keyword') {
                    $keys = str_replace(' ', ',', $rule_keywords);
                    $extra_categories = $keys;
                }
                elseif ($auto_categories == 'both') {
                    $extra_categories            = amazomatic_extractKeyWords($content);
                    $extra_categories            = implode(',', $extra_categories);
                }
                else
                {
                    $extra_categories = '';
                }
                $my_post['extra_categories'] = $extra_categories;
                $item_tags                   = amazomatic_extractKeyWords($content, 3);
                $item_tags                   = implode(',', $item_tags);
                $my_post['extra_tags']       = $item_tags;
                if ($can_create_tag == 'content') {
                    $post_the_tags = ($item_create_tag != '' ? $item_create_tag . ',' : '') . $item_tags;
                } else if ($can_create_tag == 'item') {
                    $keys = str_replace(' ', ',', $implode(',', $itags));
                    $post_the_tags = ($item_create_tag != '' ? $item_create_tag . ',' : '') . $keys;
                } else if ($can_create_tag == 'keyword') {
                    $keys = str_replace(' ', ',', $rule_keywords);
                    $post_the_tags = ($item_create_tag != '' ? $item_create_tag . ',' : '') . $keys;
                } else if ($can_create_tag == 'both') {
                    $post_the_tags = ($item_create_tag != '' ? $item_create_tag . ',' : '') . ($item_tags != '' ? $item_tags . ',' : '');
                    $my_post['extra_tags']       = ($item_tags != '' ? $item_tags . ',' : '');
                } else {
                    $post_the_tags = $item_create_tag;
                    $my_post['extra_tags']       = '';
                }
                $my_post['tags_input'] = $post_the_tags;
                $new_post_title   = amazomatic_replaceTitleShortcodesAgain($new_post_title, $extra_categories, $post_the_tags);
                $new_post_content = amazomatic_replaceContentShortcodesAgain($new_post_content, $extra_categories, $post_the_tags);
                $title_count = -1;
                if (isset($amazomatic_Main_Settings['min_word_title']) && $amazomatic_Main_Settings['min_word_title'] != '') {
                    $title_count = str_word_count($new_post_title);
                    if ($title_count < intval($amazomatic_Main_Settings['min_word_title'])) {
                        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                            amazomatic_log_to_file('Skipping post "' . esc_html($new_post_title) . '", because title lenght < ' . $amazomatic_Main_Settings['min_word_title']);
                        }
                        continue;
                    }
                }
                if (isset($amazomatic_Main_Settings['max_word_title']) && $amazomatic_Main_Settings['max_word_title'] != '') {
                    if ($title_count == -1) {
                        $title_count = str_word_count($new_post_title);
                    }
                    if ($title_count > intval($amazomatic_Main_Settings['max_word_title'])) {
                        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                            amazomatic_log_to_file('Skipping post "' . esc_html($new_post_title) . '", because title lenght > ' . $amazomatic_Main_Settings['max_word_title']);
                        }
                        continue;
                    }
                }
                $content_count = -1;
                if (isset($amazomatic_Main_Settings['min_word_content']) && $amazomatic_Main_Settings['min_word_content'] != '') {
                    $content_count = str_word_count(amazomatic_strip_html_tags($new_post_content));
                    if ($content_count < intval($amazomatic_Main_Settings['min_word_content'])) {
                        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                            amazomatic_log_to_file('Skipping post "' . esc_html($new_post_title) . '", because content lenght < ' . $amazomatic_Main_Settings['min_word_content']);
                        }
                        continue;
                    }
                }
                if (isset($amazomatic_Main_Settings['max_word_content']) && $amazomatic_Main_Settings['max_word_content'] != '') {
                    if ($content_count == -1) {
                        $content_count = str_word_count(amazomatic_strip_html_tags($new_post_content));
                    }
                    if ($content_count > intval($amazomatic_Main_Settings['max_word_content'])) {
                        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                            amazomatic_log_to_file('Skipping post "' . esc_html($new_post_title) . '", because content lenght > ' . $amazomatic_Main_Settings['max_word_content']);
                        }
                        continue;
                    }
                }
                if (isset($amazomatic_Main_Settings['banned_words']) && $amazomatic_Main_Settings['banned_words'] != '') {
                    $continue    = false;
                    $banned_list = explode(',', $amazomatic_Main_Settings['banned_words']);
                    foreach ($banned_list as $banned_word) {
                        if (stripos($new_post_content, trim($banned_word)) !== FALSE) {
                            if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                                amazomatic_log_to_file('Skipping post "' . esc_html($new_post_title) . '", because it\'s content contains banned word: ' . $banned_word);
                            }
                            $continue = true;
                            break;
                        }
                        if (stripos($new_post_title, trim($banned_word)) !== FALSE) {
                            if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                                amazomatic_log_to_file('Skipping post "' . esc_html($new_post_title) . '", because it\'s title contains banned word: ' . $banned_word);
                            }
                            $continue = true;
                            break;
                        }
                    }
                    if ($continue === true) {
                        continue;
                    }
                }
                if (isset($amazomatic_Main_Settings['required_words']) && $amazomatic_Main_Settings['required_words'] != '') {
                    $continue      = false;
                    $required_list = explode(',', $amazomatic_Main_Settings['required_words']);
                    foreach ($required_list as $required_word) {
                        if (stripos($new_post_content, trim($required_word)) !== FALSE) {
                            continue;
                        }
                        if (stripos($new_post_title, trim($required_word)) !== FALSE) {
                            continue;
                        }
                        $continue = true;
                    }
                    if ($continue === true) {
                        amazomatic_log_to_file('Skipping post "' . esc_html($new_post_title) . '", because it\'s content doesn\'t contain required word.');
                        continue;
                    }
                }
                if (isset($amazomatic_Main_Settings['limit_content']) && $amazomatic_Main_Settings['limit_content'] != '') {
                    $new_post_content = amazomatic_custom_wp_trim_excerpt($new_post_content, $amazomatic_Main_Settings['limit_content']);
                }
                if (isset($amazomatic_Main_Settings['limit_title']) && $amazomatic_Main_Settings['limit_title'] != '') {
                    $new_post_title = amazomatic_strip_html_tags(amazomatic_custom_wp_trim_excerpt($new_post_title, $amazomatic_Main_Settings['limit_title']));
                }
                $new_post_content        = html_entity_decode($new_post_content);
                if($add_link_img == '1')
                {
                    $regex_amaz = '#<img([^>]*) src=["\']([^\'"/]*\/?[^\'".]*\.[^\'"]*)["\']([^>]*)>((?!<\/a>))#';
                    $replace = '<a href="' . esc_url($url) . '"><img$1 src="$2"$3></a>';
                    $new_post_content = preg_replace($regex_amaz, $replace, $new_post_content);
                }
                $new_post_content = str_replace('</ iframe>', '</iframe>', $new_post_content);
                if($ret_content == 1)
                {
                    return $new_post_content;
                }
                $my_post['post_content'] = $new_post_content;
                if (isset($amazomatic_Main_Settings['no_excerpt']) && $amazomatic_Main_Settings['no_excerpt'] == 'on') {
                }
                else
                {
                    if (isset($amazomatic_Main_Settings['translate']) && $amazomatic_Main_Settings['translate'] != "disabled" && $amazomatic_Main_Settings['translate'] != "en") {
                        $my_post['post_excerpt'] = amazomatic_getExcerpt($new_post_content);
                    } else {
                        $my_post['post_excerpt'] = amazomatic_getExcerpt($content);
                    }
                }
                if ( ! function_exists( 'get_page_by_title' ) ) {
                    include_once( ABSPATH . 'wp-includes/post.php' );
                }
                if(get_page_by_title($new_post_title, OBJECT, $post_type) !== NULL)
                {
                    if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                        amazomatic_log_to_file('Same name psot already posted: "' . esc_html($title) . '", skipping it.');
                    }
                    continue;
                }
                $my_post['post_title']           = $new_post_title;
                $my_post['original_title']       = $title;
                $my_post['original_content']     = $content;
                $my_post['amazomatic_timestamp']   = amazomatic_get_date_now();
                $my_post['amazomatic_post_format'] = $post_format;
                if (isset($default_category) && $default_category !== 'amazomatic_no_category_12345678') {
                    $extra_categories_temp = trim(get_cat_name($default_category) . ',' .$extra_categories, ',');
                }
                else
                {
                    $extra_categories_temp = $extra_categories;
                }
                $custom_arr = array();
                if($custom_fields != '')
                {
                    if(stristr($custom_fields, '=>') != false)
                    {
                        $rule_arr = explode(',', trim($custom_fields));
                        foreach($rule_arr as $rule)
                        {
                            $my_args = explode('=>', trim($rule));
                            if(isset($my_args[1]))
                            {
                                $custom_field_content = trim($my_args[1]);
                                $custom_field_content = amazomatic_replaceContentShortcodes($custom_field_content, $title, $content, $url, $get_img, $description, $author, $author_link, $item->getASIN(), $my_post);
                                $custom_field_content = amazomatic_replaceContentShortcodesAgain($custom_field_content, $extra_categories, $item_tags);
                                $custom_arr[trim($my_args[0])] = $custom_field_content;
                            }
                        }
                    }
                }
                $custom_arr = array_merge($custom_arr, array('amazomatic_featured_image' => $get_img, 'amazomatic_post_cats' => $extra_categories_temp, 'amazomatic_post_tags' => $post_the_tags, 'amazomatic_post_id' => (string)$item->getASIN()));
                $my_post['meta_input'] = $custom_arr;
                $custom_tax_arr = array();
                if($custom_tax != '')
                {
                    if(stristr($custom_tax, '=>') != false)
                    {
                        $rule_arr = explode(';', trim($custom_tax));
                        foreach($rule_arr as $rule)
                        {
                            $my_args = explode('=>', trim($rule));
                            if(isset($my_args[1]))
                            {
                                $custom_tax_content = trim($my_args[1]);
                                $custom_tax_content = amazomatic_replaceContentShortcodes($custom_tax_content, $title, $content, $url, $get_img, $description, $author, $author_link, $item->getASIN(), $my_post);
                                $custom_tax_content = amazomatic_replaceContentShortcodesAgain($custom_tax_content, $extra_categories, $item_tags);
                                $custom_tax_arr[trim($my_args[0])] = $custom_tax_content;
                            }
                        }
                    }
                }
                if(count($custom_tax_arr) > 0)
                {
                    $my_post['taxo_input'] = $custom_tax_arr;
                }
                if ($enable_pingback == '1') {
                    $my_post['ping_status'] = 'open';
                } else {
                    $my_post['ping_status'] = 'closed';
                }
                $post_array[] = $my_post;
                $count++;
            }
            foreach ($post_array as $post) {
                remove_filter('content_save_pre', 'wp_filter_post_kses');
                remove_filter('content_filtered_save_pre', 'wp_filter_post_kses');remove_filter('title_save_pre', 'wp_filter_kses');
                $post_id = wp_insert_post($post, true);
                add_filter('content_save_pre', 'wp_filter_post_kses');
                add_filter('content_filtered_save_pre', 'wp_filter_post_kses');add_filter('title_save_pre', 'wp_filter_kses');
                if (!is_wp_error($post_id)) {
                    $posts_inserted++;
                    if(isset($post['taxo_input']))
                    {
                        foreach($post['taxo_input'] as $taxn => $taxval)
                        {
                            $taxn = trim($taxn);
                            $taxval = trim($taxval);
                            if(is_taxonomy_hierarchical($taxn))
                            {
                                $taxval = array_map('trim', explode(',', $taxval));
                                for($ii = 0; $ii < count($taxval); $ii++)
                                {
                                    if(!is_numeric($taxval[$ii]))
                                    {
                                        $xtermid = get_term_by('name', $taxval[$ii], $taxn);
                                        if($xtermid !== false)
                                        {
                                            $taxval[$ii] = intval($xtermid->term_id);
                                        }
                                        else
                                        {
                                            wp_insert_term( $taxval[$ii], $taxn);
                                            $xtermid = get_term_by('name', $taxval[$ii], $taxn);
                                            if($xtermid !== false)
                                            {
                                                $taxval[$ii] = intval($xtermid->term_id);
                                            }
                                        }
                                    }
                                }
                                wp_set_post_terms($post_id, $taxval, $taxn);
                            }
                            else
                            {
                                wp_set_post_terms($post_id, trim($taxval), $taxn);
                            }
                        }
                    }
                    if($post_type == 'product' || $post_type == 'product_variation')
                    {
                        update_post_meta($post_id, '_regular_price', (float)trim($post['amazomatic_price'], '$'));
                        if($post['amazomatic_offer_price'] != '')
                        {
                            update_post_meta($post_id, '_price', (float)trim($post['amazomatic_offer_price'], '$'));
                        }
                        else
                        {
                            update_post_meta($post_id, '_price', (float)trim($post['amazomatic_price'], '$'));
                        }
                        update_post_meta($post_id, '_sku', 'P' . $post['amazomatic_post_id']);
                    }
                    if (isset($post['amazomatic_post_format']) && $post['amazomatic_post_format'] != '' && $post['amazomatic_post_format'] != 'post-format-standard') {
                        wp_set_post_terms($post_id, $post['amazomatic_post_format'], 'post_format');
                    }
                    $featured_path = '';
                    $image_failed  = false;
                    if ($featured_image == '1') {
                        $get_img = $post['amazomatic_post_image'];
                        if ($get_img != '') {
                            if (!amazomatic_generate_featured_image($get_img, $post_id)) {
                                $image_failed = true;
                                if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                                    amazomatic_log_to_file('amazomatic_generate_featured_image failed for ' . $get_img . '!');
                                }
                            } else {
                                $featured_path = $get_img;
                            }
                        } else {
                            $image_failed = true;
                        }
                    }
                    if ($image_failed || $featured_image !== '1') {
                        
                        if ($image_url != '') {
                            $image_urlx = explode(',',$image_url);
                            $image_urlx = trim($image_urlx[array_rand($image_urlx)]);
                            $retim = false;
                            if(is_numeric($image_urlx) && $image_urlx > 0)
                            {
                                require_once(ABSPATH . 'wp-admin/includes/image.php');
                                require_once(ABSPATH . 'wp-admin/includes/media.php');
                                $res2 = set_post_thumbnail($post_id, $image_urlx);
                                if ($res2 === FALSE) {
                                }
                                else
                                {
                                    $retim = true;
                                }
                            }
                            if($retim == false)
                            {
                                stream_context_set_default( [
                                    'ssl' => [
                                        'verify_peer' => false,
                                        'verify_peer_name' => false,
                                    ],
                                ]);
                                $url_headers = get_headers($image_urlx, 1);
                                if (isset($url_headers['Content-Type'])) {
                                    if (is_array($url_headers['Content-Type'])) {
                                        $img_type = strtolower($url_headers['Content-Type'][0]);
                                    } else {
                                        $img_type = strtolower($url_headers['Content-Type']);
                                    }
                                    
                                    if (strstr($img_type, 'image/') !== false) {
                                        if (!amazomatic_generate_featured_image($image_urlx, $post_id)) {
                                            $image_failed = true;
                                            if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                                                amazomatic_log_to_file('amazomatic_generate_featured_image failed to default value: ' . $image_urlx . '!');
                                            }
                                        } else {
                                            $featured_path = $image_urlx;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if($featured_path == '' && isset($amazomatic_Main_Settings['skip_no_img']) && $amazomatic_Main_Settings['skip_no_img'] == 'on')
                    {
                        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                            amazomatic_log_to_file('Skipping post "' . $post['post_title'] . '", because it failed to generate a featured image for: ' . $get_img . ' and ' . $image_url);
                        }
                        wp_delete_post($post_id, true);
                        $posts_inserted--;
                        continue;
                    }
                    if($remove_default == '1' && ($auto_categories != 'disabled' || (isset($default_category) && $default_category !== 'amazomatic_no_category_12345678')))
                    {
                        $default_categories = wp_get_post_categories($post_id);
                    }
                    if ($auto_categories != 'disabled') {
                        if ($post['extra_categories'] != '') {
                            $extra_cats = explode(',', $post['extra_categories']);
                            foreach($extra_cats as $extra_cat)
                            {
                                $termid = amazomatic_create_terms('category', '0', trim($extra_cat));
                                wp_set_post_terms($post_id, $termid, 'category', true);
                                if($post_type == 'product' || $post_type == 'product_variation')
                                {
                                    wp_set_object_terms($post_id, trim($extra_cat), 'product_cat');
                                }
                            }
                        }
                    }
                    if($post_type == 'product' || $post_type == 'product_variation')
                    {
                        if($post['tags_input'] != '')
                        {
                            $p_tags = explode(',', $post['tags_input']);
                            wp_set_object_terms($post_id, $p_tags, 'product_tag');
                        }
                    }
                    if (isset($default_category) && $default_category !== 'amazomatic_no_category_12345678') {
                        $cats   = array();
                        $cats[] = $default_category;
                        wp_set_post_categories($post_id, $cats, true);
                        if($post_type == 'product' || $post_type == 'product_variation')
                        {
                            wp_set_object_terms($post_id, get_cat_name($default_category), 'product_cat');
                        }
                    }
                    if($remove_default == '1' && ($auto_categories != 'disabled' || (isset($default_category) && $default_category !== 'amazomatic_no_category_12345678')))
                    {
                        $new_categories = wp_get_post_categories($post_id);
                        if(isset($default_categories) && !($default_categories == $new_categories))
                        {
                            foreach($default_categories as $dc)
                            {
                                $rem_cat = get_category( $dc );
                                wp_remove_object_terms( $post_id, $rem_cat->slug, 'category' );
                            }
                        }
                    }
                    $tax_rez = wp_set_object_terms( $post_id, 'Amazomatic_' . $type . '_' . $param, 'coderevolution_post_source');
                    if (is_wp_error($tax_rez)) {
                        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                            amazomatic_log_to_file('wp_set_object_terms failed for: ' . $post_id . '!');
                        }
                    }
                    amazomatic_addPostMeta($post_id, $post, $param, $type, $featured_path, $title_url);
                } else {
                    amazomatic_log_to_file('Failed to insert post into database! Title:' . $post['post_title'] . '! Error: ' . $post_id->get_error_message() . 'Error code: ' . $post_id->get_error_code() . 'Error data: ' . $post_id->get_error_data());
                    continue;
                }
            }
            unset($post_array);
        }
        catch (Exception $e) {
            if($continue_search == '1')
            {
                $skip_posts_temp[$param][$type] = '';
                update_option('amazomatic_continue_search', $skip_posts_temp);
            }
            if($auto == 1)
            {
                amazomatic_clearFromList($param, $type);
            }
            if(strstr($e->getMessage(), 'The value you specified for ItemPage is invalid') !== false)
            {
                if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                    amazomatic_log_to_file('Going to the next results page of API.');
                }
                return 'nochange';
            }
            if(strstr($e->getMessage(), 'We did not find any matches for your request') !== false)
            {
                amazomatic_log_to_file('No matches found for rule ID ' . $param . ' -- ' . $e->getMessage());
                return 'nochange';
            }
            amazomatic_log_to_file('Exception thrown -> ' . esc_html($e->getMessage()) . '!');
            return 'fail';
        }
        
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('Rule ID ' . esc_html($param) . ' succesfully run! ' . esc_html($posts_inserted) . ' posts created!');
        }
        if (isset($amazomatic_Main_Settings['send_email']) && $amazomatic_Main_Settings['send_email'] == 'on' && $amazomatic_Main_Settings['email_address'] !== '') {
            try {
                $check_mail = get_option('amazomatic_no_mail_check', false);
                if($check_mail === false)
                {
                    $to        = $amazomatic_Main_Settings['email_address'];
                    $subject   = '[amazomatic] Rule running report - ' . amazomatic_get_date_now();
                    $message   = 'Rule ID ' . esc_html($param) . ' succesfully run! ' . esc_html($posts_inserted) . ' posts created!';
                    $headers[] = 'From: amazomatic Plugin <amazomatic@noreply.net>';
                    $headers[] = 'Reply-To: noreply@amazomatic.com';
                    $headers[] = 'X-Mailer: PHP/' . phpversion();
                    $headers[] = 'Content-Type: text/html';
                    $headers[] = 'Charset: ' . get_option('blog_charset', 'UTF-8');
                    wp_mail($to, $subject, $message, $headers);
                }
            }
            catch (Exception $e) {
                if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                    amazomatic_log_to_file('Failed to send mail: Exception thrown ' . esc_html($e->getMessage()) . '!');
                }
            }
        }
    }
    if ($posts_inserted == 0) {
        if($continue_search == '1' && $type == 0)
        {
            if($skip_posts_temp[$param][$type] < 10)
            {
                $skip_posts_temp[$param][$type] += 1;
            }
            else
            {
                $skip_posts_temp[$param][$type] = 1;
            }
            update_option('amazomatic_continue_search', $skip_posts_temp);
        }
        if($auto == 1)
        {
            amazomatic_clearFromList($param, $type);
        }
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('No new posts imported for rule ID ' . $param);
        }
        return 'nochange';
    } else {
        if($auto == 1)
        {
            amazomatic_clearFromList($param, $type);
        }
        return 'ok';
    }
}

function amazomatic_wpse_allowedtags() {
        return '<script>,<style>,<br>,<em>,<i>,<ul>,<ol>,<li>,<a>,<p>,<img>,<video>,<audio>'; 
}

function amazomatic_custom_wp_trim_excerpt($raw_excerpt, $excerpt_word_count) {
    $wpse_excerpt = $raw_excerpt;
    $wpse_excerpt = strip_shortcodes( $wpse_excerpt );
    $wpse_excerpt = apply_filters('the_content', $wpse_excerpt);
    $wpse_excerpt = str_replace(']]>', ']]&gt;', $wpse_excerpt);
    $wpse_excerpt = strip_tags($wpse_excerpt, amazomatic_wpse_allowedtags());
    $tokens = array();
    $excerptOutput = '';
    $count = 0;
    preg_match_all('/(<[^>]+>|[^<>\s]+)\s*/u', $wpse_excerpt, $tokens);
    foreach ($tokens[0] as $token) { 
        if ($count >= $excerpt_word_count && preg_match('/[\,\;\?\.\!]\s*$/uS', $token)) { 
            $excerptOutput .= trim($token);
            break;
        }
        $count++;
        $excerptOutput .= $token;
    }
    $wpse_excerpt = trim(force_balance_tags($excerptOutput));
    return $wpse_excerpt;
}

$amazomatic_fatal = false;
function amazomatic_clear_flag_at_shutdown($param, $type)
{
    $error = error_get_last();
    if ($error['type'] === E_ERROR && $GLOBALS['amazomatic_fatal'] === false) {
        $GLOBALS['amazomatic_fatal'] = true;
        $running = array();
        update_option('amazomatic_running_list', $running);
        amazomatic_log_to_file('[FATAL] Exit error: ' . $error['message'] . ', file: ' . $error['file'] . ', line: ' . $error['line'] . ' - rule ID: ' . $param . '!');
        amazomatic_clearFromList($param, $type);
    }
    else
    {
        amazomatic_clearFromList($param, $type);
    }
}

function amazomatic_strip_links($content)
{
    $content = preg_replace('/<a(.+?)href=\"(.*?)\"(.*?)>(.*?)<\/a>/i', "\\4", $content);
    return $content;
}

add_filter('the_content', 'amazomatic_add_affiliate_keyword');
add_filter('the_excerpt', 'amazomatic_add_affiliate_keyword');
function amazomatic_add_affiliate_keyword($content)
{
    $rules  = get_option('amazomatic_keyword_list');
    $output = '';
    if (!empty($rules)) {
        foreach ($rules as $request => $value) {
            if (is_array($value) && isset($value[1]) && $value[1] != '') {
                $repl = $value[1];
            } else {
                $repl = $request;
            }
            if (isset($value[0]) && $value[0] != '') {
                $content = preg_replace('\'(?!((<.*?)|(<a.*?)))(\b' . preg_quote($request, '\'') . '\b)(?!(([^<>]*?)>)|([^>]*?<\/a>))\'i', '<a href="' . esc_url($value[0]) . '" target="_blank">' . esc_html($repl) . '</a>', $content);
            } else {
                $content = preg_replace('\'(?!((<.*?)|(<a.*?)))(\b' . preg_quote($request, '\'') . '\b)(?!(([^<>]*?)>)|([^>]*?<\/a>))\'i', esc_html($repl), $content);
            }
        }
    }
    return $content;
}
foreach( [ 'post', 'page', 'post_type' ] as $type )
{
    add_filter($type . '_link','amazomatic_permalink_changer', 10, 2 );
}
add_filter('the_permalink','amazomatic_permalink_changer', 10, 2 );
function amazomatic_permalink_changer($link, $postid = ''){
	$le_post_id = '';
    if(is_numeric($postid))
    {
        $le_post_id = $postid;
    }
    elseif(isset($postid->ID))
    {
        $le_post_id = $postid->ID;
    }
    else
    {
        global $post;
        if(isset($post->ID))
        {
            $le_post_id = $post->ID;
        }
    } 
	if (!empty($le_post_id)) {
		$url = get_post_meta($le_post_id, 'amazomatic_change_title_link', true);
        $new_url = get_post_meta($le_post_id, 'amazomatic_post_url', true);
		if ( trim($url) == '1' && trim($new_url) != '') {
			return $new_url;	
		}
	}
	return $link;
}
function amazomatic_meta_box_function($post)
{
    wp_register_style('amazomatic-browser-style', plugins_url('styles/amazomatic-browser.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('amazomatic-browser-style');
    wp_suspend_cache_addition(true);
    $index                     = get_post_meta($post->ID, 'amazomatic_parent_rule', true);
    $type                      = get_post_meta($post->ID, 'amazomatic_parent_type', true);
    $title                     = get_post_meta($post->ID, 'amazomatic_item_title', true);
    $cats                      = get_post_meta($post->ID, 'amazomatic_extra_categories', true);
    $tags                      = get_post_meta($post->ID, 'amazomatic_extra_tags', true);
    $img                       = get_post_meta($post->ID, 'amazomatic_featured_img', true);
    $post_img                  = get_post_meta($post->ID, 'amazomatic_post_img', true);
    $amazomatic_timestamp        = get_post_meta($post->ID, 'amazomatic_timestamp', true);
    $amazomatic_post_date        = get_post_meta($post->ID, 'amazomatic_post_date', true);
    $amazomatic_post_url         = get_post_meta($post->ID, 'amazomatic_post_url', true);
    $amazomatic_post_id          = get_post_meta($post->ID, 'amazomatic_post_id', true);
    $amazomatic_enable_pingbacks = get_post_meta($post->ID, 'amazomatic_enable_pingbacks', true);
    $amazomatic_comment_status   = get_post_meta($post->ID, 'amazomatic_comment_status', true);
    $amazomatic_author           = get_post_meta($post->ID, 'amazomatic_author', true);
    $amazomatic_author_link      = get_post_meta($post->ID, 'amazomatic_author_link', true);

    if (isset($index) && $index != '') {
        $ech = '<table class="crf_table"><tr><td><b>' . esc_html__('Post Parent Rule:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_html($index) . '-' . esc_html($type) . '</td></tr>';
        $ech .= '<tr><td><b>' . esc_html__('Post Original Title:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_html($title) . '</td></tr>';
        if ($amazomatic_author != '') {
            $ech .= '<tr><td><b>' . esc_html__('Parent Feed Author:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_html($amazomatic_author) . '</td></tr>';
        }
        if ($amazomatic_author_link != '') {
            $ech .= '<tr><td><b>' . esc_html__('Parent Feed Author URL:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_url($amazomatic_author_link) . '</td></tr>';
        }
        if ($amazomatic_timestamp != '') {
            $ech .= '<tr><td><b>' . esc_html__('Post Creation Date:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_html($amazomatic_timestamp) . '</td></tr>';
        }
        if ($cats != '') {
            $ech .= '<tr><td><b>' . esc_html__('Post Categories:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_html($cats) . '</td></tr>';
        }
        if ($tags != '') {
            $ech .= '<tr><td><b>' . esc_html__('Post Tags:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_html($tags) . '</td></tr>';
        }
        if ($img != '') {
            $ech .= '<tr><td><b>' . esc_html__('Featured Image:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_url($img) . '</td></tr>';
        }
        
        if ($post_img != '') {
            $ech .= '<tr><td><b>' . esc_html__('Post Image:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_url($post_img) . '</td></tr>';
        }
        if ($amazomatic_post_date != '') {
            $ech .= '<tr><td><b>' . esc_html__('Item Source URL Date:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_html($amazomatic_post_date) . '</td></tr>';
        }
        if ($amazomatic_post_url != '') {
            $ech .= '<tr><td><b>' . esc_html__('Item Source URL:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_url($amazomatic_post_url) . '</td></tr>';
        }
        if ($amazomatic_post_id != '') {
            $ech .= '<tr><td><b>' . esc_html__('Item Source Post ID:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_html($amazomatic_post_id) . '</td></tr>';
        }
        if ($amazomatic_enable_pingbacks != '') {
            $ech .= '<tr><td><b>' . esc_html__('Pingback/Trackback Status:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_html($amazomatic_enable_pingbacks) . '</td></tr>';
        }
        if ($amazomatic_comment_status != '') {
            $ech .= '<tr><td><b>' . esc_html__('Comment Status:', 'amazomatic-amazon-post-generator') . '</b></td><td>&nbsp;' . esc_html($amazomatic_comment_status) . '</td></tr>';
        }
        $ech .= '</table><br/>';
    } else {
        $ech = esc_html__('This is not an automatically generated post.', 'amazomatic-amazon-post-generator');
    }
    echo $ech;
    wp_suspend_cache_addition(false);
}

function amazomatic_addPostMeta($post_id, $post, $param, $type, $featured_img, $title_url)
{
    add_post_meta($post_id, 'amazomatic_parent_rule', $param);
    add_post_meta($post_id, 'amazomatic_parent_type', $type);
    add_post_meta($post_id, 'amazomatic_content_sablon', $post['amazomatic_post_content_sablon']);
    add_post_meta($post_id, 'amazomatic_title_sablon', $post['amazomatic_post_title_sablon']);
    add_post_meta($post_id, 'amazomatic_asin', $post['amazomatic_post_id']);
    add_post_meta($post_id, 'amazomatic_enable_pingbacks', $post['amazomatic_enable_pingbacks']);
    add_post_meta($post_id, 'amazomatic_comment_status', $post['comment_status']);
    add_post_meta($post_id, 'amazomatic_item_title', $post['original_title']);
    add_post_meta($post_id, 'amazomatic_extra_categories', $post['extra_categories']);
    add_post_meta($post_id, 'amazomatic_extra_tags', $post['extra_tags']);
    add_post_meta($post_id, 'amazomatic_post_img', $post['amazomatic_post_image']);
    add_post_meta($post_id, 'amazomatic_featured_img', $featured_img);
    add_post_meta($post_id, 'amazomatic_timestamp', $post['amazomatic_timestamp']);
    add_post_meta($post_id, 'amazomatic_post_url', $post['amazomatic_post_url']);
    add_post_meta($post_id, 'amazomatic_post_date', $post['amazomatic_post_date']);
    $price_me = '';
    if(isset($post['amazomatic_price']) && $post['amazomatic_price'] != '')
    {
        $price_me = $post['amazomatic_price'];
    }
    if(isset($post['amazomatic_offer_price']) && $post['amazomatic_offer_price'] != '')
    {
        $price_me = $post['amazomatic_offer_price'];
    }
    add_post_meta($post_id, 'amazomatic_price', $price_me);
    add_post_meta($post_id, 'amazomatic_author', $post['author']);
    add_post_meta($post_id, 'amazomatic_author_link', $post['author_link']);
    if($title_url == '1')
    {
        add_post_meta($post_id, 'amazomatic_change_title_link', '1');
    }
}
function amazomatic_url_is_image( $url ) {
    if ( ! filter_var( $url, FILTER_VALIDATE_URL ) ) {
        return FALSE;
    }
    $ext = array( 'jpeg', 'jpg', 'gif', 'png', 'jpe', 'tif', 'tiff', 'svg', 'ico' , 'webp', 'dds', 'heic', 'psd', 'pspimage', 'tga', 'thm', 'yuv', 'ai', 'eps', 'php');
    $info = (array) pathinfo( parse_url( $url, PHP_URL_PATH ) );
    return isset( $info['extension'] )
        && in_array( strtolower( $info['extension'] ), $ext, TRUE );
}

function amazomatic_preg_grep_keys( $pattern, $input, $flags = 0 )
{
    if(!is_array($input))
    {
        return array();
    }
    $keys = preg_grep( $pattern, array_keys( $input ), $flags );
    $vals = array();
    foreach ( $keys as $key )
    {
        $vals[$key] = $input[$key];
    }
    return $vals;
}

function amazomatic_replace_attachment_url($att_url, $att_id) {
    {
         $post_id = get_the_ID();
         wp_suspend_cache_addition(true);
         $metas = get_post_custom($post_id);
         wp_suspend_cache_addition(false);
         $rez_meta = amazomatic_preg_grep_keys('#.+?_featured_img#i', $metas);
         if(count($rez_meta) > 0)
         {
             foreach($rez_meta as $rm)
             {
                 if(isset($rm[0]) && $rm[0] != '' && filter_var($rm[0], FILTER_VALIDATE_URL))
                 {
                     return $rm[0];
                 }
             }
         }
    }
    return $att_url;
}


function amazomatic_replace_attachment_image_src($image, $att_id, $size) {
    {
        $post_id = get_the_ID();
        wp_suspend_cache_addition(true);
        $metas = get_post_custom($post_id);
        wp_suspend_cache_addition(false);
        $rez_meta = amazomatic_preg_grep_keys('#.+?_featured_img#i', $metas);
        if(count($rez_meta) > 0)
        {
            foreach($rez_meta as $rm)
            {
                if(isset($rm[0]) && $rm[0] != '' && filter_var($rm[0], FILTER_VALIDATE_URL))
                {
                    return array($rm[0], 0, 0, false);
                }
            }
        }
     }
     return $image;
}

function amazomatic_thumbnail_external_replace( $html, $post_id ) {
    
    wp_suspend_cache_addition(true);
    $metas = get_post_custom($post_id);
    wp_suspend_cache_addition(false);
    $rez_meta = amazomatic_preg_grep_keys('#.+?_featured_img#i', $metas);
    if(count($rez_meta) > 0)
    {
        foreach($rez_meta as $rm)
        {
            if(isset($rm[0]) && $rm[0] != '' && filter_var($rm[0], FILTER_VALIDATE_URL))
            {
                $alt = get_post_field( 'post_title', $post_id ) . ' ' .  esc_html__( 'thumbnail', 'amazomatic-amazon-post-generator' );
                $attr = array( 'alt' => $alt );
                $attr = apply_filters( 'wp_get_attachment_image_attributes', $attr, NULL , 'thumbnail');
                $attr = array_map( 'esc_attr', $attr );
                $html = sprintf( '<img src="%s"', esc_url($rm[0]) );
                foreach ( $attr as $name => $value ) {
                    $html .= " " . esc_html($name) . "=" . '"' . esc_attr($value) . '"';
                }
                $html .= ' />';
                return $html;
            }
        }
    }
    return $html;
}

function amazomatic_endsWith($haystack, $needle)
{
    $length = strlen($needle);
    if ($length == 0) {
        return true;
    }

    return (substr($haystack, -$length) === $needle);
}

function amazomatic_generate_featured_image($image_url, $post_id)
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $upload_dir = wp_upload_dir();
	$amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
	if (isset($amazomatic_Main_Settings['no_local_image']) && $amazomatic_Main_Settings['no_local_image'] == 'on') {
        if(!amazomatic_url_is_image($image_url))
        {
            amazomatic_log_to_file('Provided remote image is not valid: ' . $image_url);
            return false;
        }
        $file = $upload_dir['basedir'] . '/default_img_rss_echo.jpg';
        if(!$wp_filesystem->exists($file))
        {
            $image_data = amazomatic_get_web_page(html_entity_decode(dirname(__FILE__) . "/images/icon.png"));
            if ($image_data === FALSE || strpos($image_data, '<Message>Access Denied</Message>') !== FALSE || strpos($image_data, 'ERROR: The requested URL could not be retrieved') !== FALSE) {
                amazomatic_log_to_file('Failed to access dummy image resource: ' . html_entity_decode(dirname(__FILE__) . "/images/icon.png"));
                return false;
            }
            $ret = $wp_filesystem->put_contents($file, $image_data);
            if ($ret === FALSE) {
                amazomatic_log_to_file('Failed to save dummy image locally: ' . $file);
                return false;
            }
        }
        $need_attach = false;
        $checking_id = get_option('amazomatic_attach_id', false);
        if($checking_id === false)
        {
            $need_attach = true;
        }
        else
        {
            $atturl = wp_get_attachment_url($checking_id);
            if($atturl === false)
            {
                $need_attach = true;
            }
        }
        if($need_attach)
        {
            $filename = basename(dirname(__FILE__) . "/images/icon.png");
            $wp_filetype = wp_check_filetype($filename, null);
            if($wp_filetype['type'] == '')
            {
                $wp_filetype['type'] = 'image/png';
            }
            $attachment  = array(
                'post_mime_type' => $wp_filetype['type'],
                'post_title' => sanitize_file_name($filename),
                'post_content' => '',
                'post_status' => 'inherit'
            );
            
            $attach_id   = wp_insert_attachment($attachment, $file, $post_id);
            if ($attach_id === 0) {
                amazomatic_log_to_file('Failed to insert attachment: ' . print_r($attachment, true) . ' - ' . $file . ' - ' . $post_id);
                return false;
            }
            update_option('amazomatic_attach_id', $attach_id);
            require_once(ABSPATH . 'wp-admin/includes/image.php');
            require_once(ABSPATH . 'wp-admin/includes/media.php');
            $attach_data = wp_generate_attachment_metadata($attach_id, $file);
            wp_update_attachment_metadata($attach_id, $attach_data);
        }
        else
        {
            $attach_id = $checking_id;
        }
        $res2 = set_post_thumbnail($post_id, $attach_id);
        if ($res2 === FALSE) {
            amazomatic_log_to_file('Failed to set post thumbnail: ' . $post_id . ' - ' . $attach_id);
            return false;
        }
        return true;
    }
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $image_data = $wp_filesystem->get_contents($image_url);
    if ($image_data === FALSE) {
        $image_data = amazomatic_get_web_page($image_url);
        if ($image_data === FALSE || strpos($image_data, '<Message>Access Denied</Message>') !== FALSE) {
            return false;
        }
    }
    $filename = basename($image_url);
    $temp     = explode("?", $filename);
    $filename = $temp[0];
    $filename = str_replace('%', '-', $filename);
    $filename = str_replace('#', '-', $filename);
    $filename = str_replace('&', '-', $filename);
    $filename = str_replace('{', '-', $filename);
    $filename = str_replace('}', '-', $filename);
    $filename = str_replace('\\', '-', $filename);
    $filename = str_replace('<', '-', $filename);
    $filename = str_replace('>', '-', $filename);
    $filename = str_replace('*', '-', $filename);
    $filename = str_replace('/', '-', $filename);
    $filename = str_replace('$', '-', $filename);
    $filename = str_replace('\'', '-', $filename);
    $filename = str_replace('"', '-', $filename);
    $filename = str_replace(':', '-', $filename);
    $filename = str_replace('@', '-', $filename);
    $filename = str_replace('+', '-', $filename);
    $filename = str_replace('|', '-', $filename);
    $filename = str_replace('=', '-', $filename);
    $filename = str_replace('`', '-', $filename);
    $filename = stripslashes(preg_replace_callback('#(%[a-zA-Z0-9_]*)#', function($matches){ return rand(0, 9); }, preg_quote($filename)));
    $file_parts = pathinfo($filename);
    $post_title = get_the_title($post_id);
    if($post_title != '')
    {
        $post_title = remove_accents( $post_title );
        $invalid = array(
            ' '   => '-',
            '%20' => '-',
            '_'   => '-',
        );
        $post_title = str_replace( array_keys( $invalid ), array_values( $invalid ), $post_title );
        $post_title = preg_replace('/[\x{1F3F4}](?:\x{E0067}\x{E0062}\x{E0077}\x{E006C}\x{E0073}\x{E007F})|[\x{1F3F4}](?:\x{E0067}\x{E0062}\x{E0073}\x{E0063}\x{E0074}\x{E007F})|[\x{1F3F4}](?:\x{E0067}\x{E0062}\x{E0065}\x{E006E}\x{E0067}\x{E007F})|[\x{1F3F4}](?:\x{200D}\x{2620}\x{FE0F})|[\x{1F3F3}](?:\x{FE0F}\x{200D}\x{1F308})|[\x{0023}\x{002A}\x{0030}\x{0031}\x{0032}\x{0033}\x{0034}\x{0035}\x{0036}\x{0037}\x{0038}\x{0039}](?:\x{FE0F}\x{20E3})|[\x{1F415}](?:\x{200D}\x{1F9BA})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F467}\x{200D}\x{1F467})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F467}\x{200D}\x{1F466})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F467})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F466}\x{200D}\x{1F466})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F466})|[\x{1F468}](?:\x{200D}\x{1F468}\x{200D}\x{1F467}\x{200D}\x{1F467})|[\x{1F468}](?:\x{200D}\x{1F468}\x{200D}\x{1F466}\x{200D}\x{1F466})|[\x{1F468}](?:\x{200D}\x{1F468}\x{200D}\x{1F467}\x{200D}\x{1F466})|[\x{1F468}](?:\x{200D}\x{1F468}\x{200D}\x{1F467})|[\x{1F468}](?:\x{200D}\x{1F468}\x{200D}\x{1F466})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F469}\x{200D}\x{1F467}\x{200D}\x{1F467})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F469}\x{200D}\x{1F466}\x{200D}\x{1F466})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F469}\x{200D}\x{1F467}\x{200D}\x{1F466})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F469}\x{200D}\x{1F467})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F469}\x{200D}\x{1F466})|[\x{1F469}](?:\x{200D}\x{2764}\x{FE0F}\x{200D}\x{1F469})|[\x{1F469}\x{1F468}](?:\x{200D}\x{2764}\x{FE0F}\x{200D}\x{1F468})|[\x{1F469}](?:\x{200D}\x{2764}\x{FE0F}\x{200D}\x{1F48B}\x{200D}\x{1F469})|[\x{1F469}\x{1F468}](?:\x{200D}\x{2764}\x{FE0F}\x{200D}\x{1F48B}\x{200D}\x{1F468})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9BD})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9BC})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9AF})|[\x{1F575}\x{1F3CC}\x{26F9}\x{1F3CB}](?:\x{FE0F}\x{200D}\x{2640}\x{FE0F})|[\x{1F575}\x{1F3CC}\x{26F9}\x{1F3CB}](?:\x{FE0F}\x{200D}\x{2642}\x{FE0F})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F692})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F680})|[\x{1F468}\x{1F469}](?:\x{200D}\x{2708}\x{FE0F})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F3A8})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F3A4})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F4BB})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F52C})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F4BC})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F3ED})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F527})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F373})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F33E})|[\x{1F468}\x{1F469}](?:\x{200D}\x{2696}\x{FE0F})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F3EB})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F393})|[\x{1F468}\x{1F469}](?:\x{200D}\x{2695}\x{FE0F})|[\x{1F471}\x{1F64D}\x{1F64E}\x{1F645}\x{1F646}\x{1F481}\x{1F64B}\x{1F9CF}\x{1F647}\x{1F926}\x{1F937}\x{1F46E}\x{1F482}\x{1F477}\x{1F473}\x{1F9B8}\x{1F9B9}\x{1F9D9}\x{1F9DA}\x{1F9DB}\x{1F9DC}\x{1F9DD}\x{1F9DE}\x{1F9DF}\x{1F486}\x{1F487}\x{1F6B6}\x{1F9CD}\x{1F9CE}\x{1F3C3}\x{1F46F}\x{1F9D6}\x{1F9D7}\x{1F3C4}\x{1F6A3}\x{1F3CA}\x{1F6B4}\x{1F6B5}\x{1F938}\x{1F93C}\x{1F93D}\x{1F93E}\x{1F939}\x{1F9D8}](?:\x{200D}\x{2640}\x{FE0F})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9B2})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9B3})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9B1})|[\x{1F468}\x{1F469}](?:\x{200D}\x{1F9B0})|[\x{1F471}\x{1F64D}\x{1F64E}\x{1F645}\x{1F646}\x{1F481}\x{1F64B}\x{1F9CF}\x{1F647}\x{1F926}\x{1F937}\x{1F46E}\x{1F482}\x{1F477}\x{1F473}\x{1F9B8}\x{1F9B9}\x{1F9D9}\x{1F9DA}\x{1F9DB}\x{1F9DC}\x{1F9DD}\x{1F9DE}\x{1F9DF}\x{1F486}\x{1F487}\x{1F6B6}\x{1F9CD}\x{1F9CE}\x{1F3C3}\x{1F46F}\x{1F9D6}\x{1F9D7}\x{1F3C4}\x{1F6A3}\x{1F3CA}\x{1F6B4}\x{1F6B5}\x{1F938}\x{1F93C}\x{1F93D}\x{1F93E}\x{1F939}\x{1F9D8}](?:\x{200D}\x{2642}\x{FE0F})|[\x{1F441}](?:\x{FE0F}\x{200D}\x{1F5E8}\x{FE0F})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1E9}\x{1F1F0}\x{1F1F2}\x{1F1F3}\x{1F1F8}\x{1F1F9}\x{1F1FA}](?:\x{1F1FF})|[\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1F0}\x{1F1F1}\x{1F1F2}\x{1F1F5}\x{1F1F8}\x{1F1FA}](?:\x{1F1FE})|[\x{1F1E6}\x{1F1E8}\x{1F1F2}\x{1F1F8}](?:\x{1F1FD})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1F0}\x{1F1F2}\x{1F1F5}\x{1F1F7}\x{1F1F9}\x{1F1FF}](?:\x{1F1FC})|[\x{1F1E7}\x{1F1E8}\x{1F1F1}\x{1F1F2}\x{1F1F8}\x{1F1F9}](?:\x{1F1FB})|[\x{1F1E6}\x{1F1E8}\x{1F1EA}\x{1F1EC}\x{1F1ED}\x{1F1F1}\x{1F1F2}\x{1F1F3}\x{1F1F7}\x{1F1FB}](?:\x{1F1FA})|[\x{1F1E6}\x{1F1E7}\x{1F1EA}\x{1F1EC}\x{1F1ED}\x{1F1EE}\x{1F1F1}\x{1F1F2}\x{1F1F5}\x{1F1F8}\x{1F1F9}\x{1F1FE}](?:\x{1F1F9})|[\x{1F1E6}\x{1F1E7}\x{1F1EA}\x{1F1EC}\x{1F1EE}\x{1F1F1}\x{1F1F2}\x{1F1F5}\x{1F1F7}\x{1F1F8}\x{1F1FA}\x{1F1FC}](?:\x{1F1F8})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EA}\x{1F1EB}\x{1F1EC}\x{1F1ED}\x{1F1EE}\x{1F1F0}\x{1F1F1}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F8}\x{1F1F9}](?:\x{1F1F7})|[\x{1F1E6}\x{1F1E7}\x{1F1EC}\x{1F1EE}\x{1F1F2}](?:\x{1F1F6})|[\x{1F1E8}\x{1F1EC}\x{1F1EF}\x{1F1F0}\x{1F1F2}\x{1F1F3}](?:\x{1F1F5})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1E9}\x{1F1EB}\x{1F1EE}\x{1F1EF}\x{1F1F2}\x{1F1F3}\x{1F1F7}\x{1F1F8}\x{1F1F9}](?:\x{1F1F4})|[\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1ED}\x{1F1EE}\x{1F1F0}\x{1F1F2}\x{1F1F5}\x{1F1F8}\x{1F1F9}\x{1F1FA}\x{1F1FB}](?:\x{1F1F3})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1E9}\x{1F1EB}\x{1F1EC}\x{1F1ED}\x{1F1EE}\x{1F1EF}\x{1F1F0}\x{1F1F2}\x{1F1F4}\x{1F1F5}\x{1F1F8}\x{1F1F9}\x{1F1FA}\x{1F1FF}](?:\x{1F1F2})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1EE}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F8}\x{1F1F9}](?:\x{1F1F1})|[\x{1F1E8}\x{1F1E9}\x{1F1EB}\x{1F1ED}\x{1F1F1}\x{1F1F2}\x{1F1F5}\x{1F1F8}\x{1F1F9}\x{1F1FD}](?:\x{1F1F0})|[\x{1F1E7}\x{1F1E9}\x{1F1EB}\x{1F1F8}\x{1F1F9}](?:\x{1F1EF})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EB}\x{1F1EC}\x{1F1F0}\x{1F1F1}\x{1F1F3}\x{1F1F8}\x{1F1FB}](?:\x{1F1EE})|[\x{1F1E7}\x{1F1E8}\x{1F1EA}\x{1F1EC}\x{1F1F0}\x{1F1F2}\x{1F1F5}\x{1F1F8}\x{1F1F9}](?:\x{1F1ED})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1E9}\x{1F1EA}\x{1F1EC}\x{1F1F0}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F8}\x{1F1F9}\x{1F1FA}\x{1F1FB}](?:\x{1F1EC})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F9}\x{1F1FC}](?:\x{1F1EB})|[\x{1F1E6}\x{1F1E7}\x{1F1E9}\x{1F1EA}\x{1F1EC}\x{1F1EE}\x{1F1EF}\x{1F1F0}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F7}\x{1F1F8}\x{1F1FB}\x{1F1FE}](?:\x{1F1EA})|[\x{1F1E6}\x{1F1E7}\x{1F1E8}\x{1F1EC}\x{1F1EE}\x{1F1F2}\x{1F1F8}\x{1F1F9}](?:\x{1F1E9})|[\x{1F1E6}\x{1F1E8}\x{1F1EA}\x{1F1EE}\x{1F1F1}\x{1F1F2}\x{1F1F3}\x{1F1F8}\x{1F1F9}\x{1F1FB}](?:\x{1F1E8})|[\x{1F1E7}\x{1F1EC}\x{1F1F1}\x{1F1F8}](?:\x{1F1E7})|[\x{1F1E7}\x{1F1E8}\x{1F1EA}\x{1F1EC}\x{1F1F1}\x{1F1F2}\x{1F1F3}\x{1F1F5}\x{1F1F6}\x{1F1F8}\x{1F1F9}\x{1F1FA}\x{1F1FB}\x{1F1FF}](?:\x{1F1E6})|[\x{00A9}\x{00AE}\x{203C}\x{2049}\x{2122}\x{2139}\x{2194}-\x{2199}\x{21A9}-\x{21AA}\x{231A}-\x{231B}\x{2328}\x{23CF}\x{23E9}-\x{23F3}\x{23F8}-\x{23FA}\x{24C2}\x{25AA}-\x{25AB}\x{25B6}\x{25C0}\x{25FB}-\x{25FE}\x{2600}-\x{2604}\x{260E}\x{2611}\x{2614}-\x{2615}\x{2618}\x{261D}\x{2620}\x{2622}-\x{2623}\x{2626}\x{262A}\x{262E}-\x{262F}\x{2638}-\x{263A}\x{2640}\x{2642}\x{2648}-\x{2653}\x{265F}-\x{2660}\x{2663}\x{2665}-\x{2666}\x{2668}\x{267B}\x{267E}-\x{267F}\x{2692}-\x{2697}\x{2699}\x{269B}-\x{269C}\x{26A0}-\x{26A1}\x{26AA}-\x{26AB}\x{26B0}-\x{26B1}\x{26BD}-\x{26BE}\x{26C4}-\x{26C5}\x{26C8}\x{26CE}-\x{26CF}\x{26D1}\x{26D3}-\x{26D4}\x{26E9}-\x{26EA}\x{26F0}-\x{26F5}\x{26F7}-\x{26FA}\x{26FD}\x{2702}\x{2705}\x{2708}-\x{270D}\x{270F}\x{2712}\x{2714}\x{2716}\x{271D}\x{2721}\x{2728}\x{2733}-\x{2734}\x{2744}\x{2747}\x{274C}\x{274E}\x{2753}-\x{2755}\x{2757}\x{2763}-\x{2764}\x{2795}-\x{2797}\x{27A1}\x{27B0}\x{27BF}\x{2934}-\x{2935}\x{2B05}-\x{2B07}\x{2B1B}-\x{2B1C}\x{2B50}\x{2B55}\x{3030}\x{303D}\x{3297}\x{3299}\x{1F004}\x{1F0CF}\x{1F170}-\x{1F171}\x{1F17E}-\x{1F17F}\x{1F18E}\x{1F191}-\x{1F19A}\x{1F201}-\x{1F202}\x{1F21A}\x{1F22F}\x{1F232}-\x{1F23A}\x{1F250}-\x{1F251}\x{1F300}-\x{1F321}\x{1F324}-\x{1F393}\x{1F396}-\x{1F397}\x{1F399}-\x{1F39B}\x{1F39E}-\x{1F3F0}\x{1F3F3}-\x{1F3F5}\x{1F3F7}-\x{1F3FA}\x{1F400}-\x{1F4FD}\x{1F4FF}-\x{1F53D}\x{1F549}-\x{1F54E}\x{1F550}-\x{1F567}\x{1F56F}-\x{1F570}\x{1F573}-\x{1F57A}\x{1F587}\x{1F58A}-\x{1F58D}\x{1F590}\x{1F595}-\x{1F596}\x{1F5A4}-\x{1F5A5}\x{1F5A8}\x{1F5B1}-\x{1F5B2}\x{1F5BC}\x{1F5C2}-\x{1F5C4}\x{1F5D1}-\x{1F5D3}\x{1F5DC}-\x{1F5DE}\x{1F5E1}\x{1F5E3}\x{1F5E8}\x{1F5EF}\x{1F5F3}\x{1F5FA}-\x{1F64F}\x{1F680}-\x{1F6C5}\x{1F6CB}-\x{1F6D2}\x{1F6D5}\x{1F6E0}-\x{1F6E5}\x{1F6E9}\x{1F6EB}-\x{1F6EC}\x{1F6F0}\x{1F6F3}-\x{1F6FA}\x{1F7E0}-\x{1F7EB}\x{1F90D}-\x{1F93A}\x{1F93C}-\x{1F945}\x{1F947}-\x{1F971}\x{1F973}-\x{1F976}\x{1F97A}-\x{1F9A2}\x{1F9A5}-\x{1F9AA}\x{1F9AE}-\x{1F9CA}\x{1F9CD}-\x{1F9FF}\x{1FA70}-\x{1FA73}\x{1FA78}-\x{1FA7A}\x{1FA80}-\x{1FA82}\x{1FA90}-\x{1FA95}]/u', '', $post_title);
        
        $post_title = preg_replace('/\.(?=.*\.)/', '', $post_title);
        $post_title = preg_replace('/-+/', '-', $post_title);
        $post_title = str_replace('-.', '.', $post_title);
        $post_title = strtolower( $post_title );
        if($post_title == '')
        {
            $post_title = uniqid();
        }
        if(isset($file_parts['extension']))
        {
            switch($file_parts['extension'])
            {
                case "":
                $filename = sanitize_title($post_title) . '.jpg';
                break;
                case NULL:
                $filename = sanitize_title($post_title) . '.jpg';
                break;
                default:
                $filename = sanitize_title($post_title) . '.' . $file_parts['extension'];
                break;
            }
        }
        else
        {
            $filename = sanitize_title($post_title) . '.jpg';
        }
    }
    else
    {
        if(isset($file_parts['extension']))
        {
            switch($file_parts['extension'])
            {
                case "":
                if(!amazomatic_endsWith($filename, '.jpg'))
                    $filename .= '.jpg';
                break;
                case NULL:
                if(!amazomatic_endsWith($filename, '.jpg'))
                    $filename .= '.jpg';
                break;
                default:
                if(!amazomatic_endsWith($filename, '.' . $file_parts['extension']))
                    $filename .= '.' . $file_parts['extension'];
                break;
            }
        }
        else
        {
            if(!amazomatic_endsWith($filename, '.jpg'))
                $filename .= '.jpg';
        }
    }
    $filename = sanitize_file_name($filename);
    if (wp_mkdir_p($upload_dir['path'] . '/' . $post_id))
        $file = $upload_dir['path'] . '/' . $post_id . '/' . $filename;
    else
        $file = $upload_dir['basedir'] . '/' . $post_id . '/' . $filename;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $ret = $wp_filesystem->put_contents($file, $image_data);
    if ($ret === FALSE) {
        return false;
    }
    $wp_filetype = wp_check_filetype($filename, null);
    if($wp_filetype['type'] == '')
    {
        $wp_filetype['type'] = 'image/png';
    }
    $attachment  = array(
        'post_mime_type' => $wp_filetype['type'],
        'post_title' => sanitize_file_name($filename),
        'post_content' => '',
        'post_status' => 'inherit'
    );
    
    if ((isset($amazomatic_Main_Settings['resize_height']) && $amazomatic_Main_Settings['resize_height'] !== '') || (isset($amazomatic_Main_Settings['resize_width']) && $amazomatic_Main_Settings['resize_width'] !== ''))
    {
        try
        {
            if(!class_exists('\Eventviva\ImageResize')){require_once (dirname(__FILE__) . "/res/ImageResize/ImageResize.php");}
            $imageRes = new ImageResize($file);
            $imageRes->quality_jpg = 100;
            if ((isset($amazomatic_Main_Settings['resize_height']) && $amazomatic_Main_Settings['resize_height'] !== '') && (isset($amazomatic_Main_Settings['resize_width']) && $amazomatic_Main_Settings['resize_width'] !== ''))
            {
                $imageRes->resizeToBestFit($amazomatic_Main_Settings['resize_width'], $amazomatic_Main_Settings['resize_height'], true);
            }
            elseif (isset($amazomatic_Main_Settings['resize_width']) && $amazomatic_Main_Settings['resize_width'] !== '')
            {
                $imageRes->resizeToWidth($amazomatic_Main_Settings['resize_width'], true);
            }
            elseif (isset($amazomatic_Main_Settings['resize_height']) && $amazomatic_Main_Settings['resize_height'] !== '')
            {
                $imageRes->resizeToHeight($amazomatic_Main_Settings['resize_height'], true);
            }
            $imageRes->save($file);
        }
        catch(Exception $e)
        {
            amazomatic_log_to_file('Failed to resize featured image: ' . $image_url . ' to sizes ' . $amazomatic_Main_Settings['resize_width'] . ' - ' . $amazomatic_Main_Settings['resize_height'] . '. Exception thrown ' . esc_html($e->getMessage()) . '!');
        }
    }
    $attach_id   = wp_insert_attachment($attachment, $file, $post_id);
    if ($attach_id === 0) {
        return false;
    }
    require_once(ABSPATH . 'wp-admin/includes/image.php');
    require_once(ABSPATH . 'wp-admin/includes/media.php');
    $attach_data = wp_generate_attachment_metadata($attach_id, $file);
    wp_update_attachment_metadata($attach_id, $attach_data);
    $res2 = set_post_thumbnail($post_id, $attach_id);
    if ($res2 === FALSE) {
        return false;
    }
    $post_title = get_the_title($post_id);
    if($post_title != '')
    {
        update_post_meta($attach_id, '_wp_attachment_image_alt', $post_title);
    }
    return true;
}

function amazomatic_hour_diff($date1, $date2)
{
    $date1 = new DateTime($date1);
    $date2 = new DateTime($date2);
    
    $number1 = (int) $date1->format('U');
    $number2 = (int) $date2->format('U');
    return ($number1 - $number2) / 60;
}

function amazomatic_add_hour($date, $hour)
{
    $date1 = new DateTime($date);
    $date1->modify("$hour hours");
    foreach ($date1 as $key => $value) {
        if ($key == 'date') {
            return $value;
        }
    }
    return $date;
}

function amazomatic_wp_custom_css_files($src, $cont)
{
    wp_enqueue_style('amazomatic-thumbnail-css-' . $cont, $src, __FILE__);
}

function amazomatic_get_date_now($param = 'now')
{
    $date = new DateTime($param);
    foreach ($date as $key => $value) {
        if ($key == 'date') {
            return $value;
        }
    }
    return '';
}

function amazomatic_create_terms($taxonomy, $parent, $terms_str)
{
    $terms          = explode('/', $terms_str);
    $categories     = array();
    $parent_term_id = $parent;
    foreach ($terms as $term) {
        $res = term_exists($term, $taxonomy, $parent);
        if ($res != NULL && $res != 0 && count($res) > 0 && isset($res['term_id'])) {
            $parent_term_id = $res['term_id'];
            $categories[]   = $parent_term_id;
        } else {
            $new_term = wp_insert_term($term, $taxonomy, array(
                'parent' => $parent
            ));
            if (!is_wp_error( $new_term ) && $new_term != NULL && $new_term != 0 && count($new_term) > 0 && isset($new_term['term_id'])) {
                $parent_term_id = $new_term['term_id'];
                $categories[]   = $parent_term_id;
            }
        }
    }
    
    return $categories;
}
function amazomatic_getExcerpt($the_content)
{
    $preview = amazomatic_strip_html_tags($the_content);
    $preview = wp_trim_words($preview, 55);
    return $preview;
}

function amazomatic_getPlainContent($the_content)
{
    $preview = amazomatic_strip_html_tags($the_content);
    $preview = wp_trim_words($preview, 999999);
    return $preview;
}
function amazomatic_getItemImage($img)
{
    if($img == '')
    {
        return '';
    }
    $preview = '<img src="' . esc_url($img) . '" alt="image" />';
    return $preview;
}

function amazomatic_getNamedButton($url, $text, $amazomatic_Main_Settings, $extra_class = '')
{
    $link = '';
    if (isset($url)) {
        $link = '<a class="crf_named_but amazomatic_btn button purchase';
        if($extra_class != '')
        {
            $link .= ' ' . $extra_class;
        }
        $link .= '"';
		if(isset($amazomatic_Main_Settings['rel_nofollow']) && $amazomatic_Main_Settings['rel_nofollow'] == 'on')
		{
			$link .= ' rel="nofollow"';
		}		
		$link .= ' href="' . esc_url($url) . '" target="_blank">' . esc_html($text) . '</a>';
    }
    return $link;
}

add_action('init', 'amazomatic_create_taxonomy', 0);
add_action( 'enqueue_block_editor_assets', 'amazomatic_enqueue_block_editor_assets' );
function amazomatic_enqueue_block_editor_assets() {
	wp_register_style('amazomatic-browser-style', plugins_url('styles/amazomatic-browser.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('amazomatic-browser-style');
	$block_js_display   = 'scripts/display-posts.js';
	wp_enqueue_script(
		'amazomatic-display-block-js', 
        plugins_url( $block_js_display, __FILE__ ), 
        array(
			'wp-blocks',
			'wp-i18n',
			'wp-element',
		),
        '1.0.0'
	);
    $block_js_list   = 'scripts/list-posts.js';
	wp_enqueue_script(
		'amazomatic-list-block-js', 
        plugins_url( $block_js_list, __FILE__ ), 
        array(
			'wp-blocks',
			'wp-i18n',
			'wp-element',
		),
        '1.0.0'
	);
}
$amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
if (isset($amazomatic_Main_Settings['amazomatic_enabled']) && $amazomatic_Main_Settings['amazomatic_enabled'] === 'on') {
    if (isset($amazomatic_Main_Settings['no_local_image']) && $amazomatic_Main_Settings['no_local_image'] == 'on') {
        add_filter('wp_get_attachment_url', 'amazomatic_replace_attachment_url', 10, 2);
        add_filter('wp_get_attachment_image_src', 'amazomatic_replace_attachment_image_src', 10, 3);
        add_filter('post_thumbnail_html', 'amazomatic_thumbnail_external_replace', 10, 6);
    }
}
function amazomatic_create_taxonomy()
{   
    if ( function_exists( 'register_block_type' ) ) {
        register_block_type( 'amazomatic-amazon-post-generator/amazomatic-display', array(
            'render_callback' => 'amazomatic_display_posts_shortcode',
        ) );
        register_block_type( 'amazomatic-amazon-post-generator/amazomatic-list', array(
            'render_callback' => 'amazomatic_list_posts',
        ) );
    }
    if(!taxonomy_exists('coderevolution_post_source'))
    {
        $labels = array(
            'name' => _x('Post Source', 'taxonomy general name', 'amazomatic-amazon-post-generator'),
            'singular_name' => _x('Post Source', 'taxonomy singular name', 'amazomatic-amazon-post-generator'),
            'search_items' => esc_html__('Search Post Source', 'amazomatic-amazon-post-generator'),
            'popular_items' => esc_html__('Popular Post Source', 'amazomatic-amazon-post-generator'),
            'all_items' => esc_html__('All Post Sources', 'amazomatic-amazon-post-generator'),
            'parent_item' => null,
            'parent_item_colon' => null,
            'edit_item' => esc_html__('Edit Post Source', 'amazomatic-amazon-post-generator'),
            'update_item' => esc_html__('Update Post Source', 'amazomatic-amazon-post-generator'),
            'add_new_item' => esc_html__('Add New Post Source', 'amazomatic-amazon-post-generator'),
            'new_item_name' => esc_html__('New Post Source Name', 'amazomatic-amazon-post-generator'),
            'separate_items_with_commas' => esc_html__('Separate Post Source with commas', 'amazomatic-amazon-post-generator'),
            'add_or_remove_items' => esc_html__('Add or remove Post Source', 'amazomatic-amazon-post-generator'),
            'choose_from_most_used' => esc_html__('Choose from the most used Post Source', 'amazomatic-amazon-post-generator'),
            'not_found' => esc_html__('No Post Sources found.', 'amazomatic-amazon-post-generator'),
            'menu_name' => esc_html__('Post Source', 'amazomatic-amazon-post-generator')
        );
        
        $args = array(
            'hierarchical' => false,
            'public' => false,
            'show_ui' => false,
            'show_in_menu' => false,
            'description' => 'Post Source',
            'labels' => $labels,
            'show_admin_column' => true,
            'update_count_callback' => '_update_post_term_count',
            'rewrite' => false
        );
        
        register_taxonomy('coderevolution_post_source', array(
            'post',
            'page'
        ), $args);
        add_action('pre_get_posts', function($qry) {
            if (is_admin()) return;
            if (is_tax('coderevolution_post_source')){
                $qry->set_404();
            }
        });
    }
}

register_activation_hook(__FILE__, 'amazomatic_activation_callback');
function amazomatic_activation_callback($defaults = FALSE)
{
    if (!get_option('amazomatic_Main_Settings') || $defaults === TRUE) {
        $amazomatic_Main_Settings = array(
            'amazomatic_enabled' => 'on',
            'enable_metabox' => 'on',
            'app_id' => '',
            'app_secret' => '',
            'skip_no_img' => '',
            'skip_old' => '',
            'skip_year' => '',
            'skip_month' => '',
            'skip_day' => '',
            'translate' => 'disabled',
            'translate_source' => 'disabled',
            'custom_html2' => '',
            'custom_html' => '',
            'strip_by_id' => '',
            'strip_by_class' => '',
            'sentence_list' => 'This is one %adjective %noun %sentence_ending
This is another %adjective %noun %sentence_ending
I %love_it %nouns , because they are %adjective %sentence_ending
My %family says this plugin is %adjective %sentence_ending
These %nouns are %adjective %sentence_ending',
            'sentence_list2' => 'Meet this %adjective %noun %sentence_ending
This is the %adjective %noun ever %sentence_ending
I %love_it %nouns , because they are the %adjective %sentence_ending
My %family says this plugin is very %adjective %sentence_ending
These %nouns are quite %adjective %sentence_ending',
            'variable_list' => 'adjective_very => %adjective;very %adjective;

adjective => clever;interesting;smart;huge;astonishing;unbelievable;nice;adorable;beautiful;elegant;fancy;glamorous;magnificent;helpful;awesome

noun_with_adjective => %noun;%adjective %noun

noun => plugin;WordPress plugin;item;ingredient;component;constituent;module;add-on;plug-in;addon;extension

nouns => plugins;WordPress plugins;items;ingredients;components;constituents;modules;add-ons;plug-ins;addons;extensions

love_it => love;adore;like;be mad for;be wild about;be nuts about;be crazy about

family => %adjective %family_members;%family_members

family_members => grandpa;brother;sister;mom;dad;grandma

sentence_ending => .;!;!!',
            'auto_clear_logs' => 'No',
            'enable_logging' => 'on',
            'enable_detailed_logging' => '',
            'rule_timeout' => '3600',
            'strip_links' => '',
            'email_address' => '',
            'send_email' => '',
            'rule_delay' => '',
            'update_delay' => '',
            'best_password' => '',
            'only_imported' => 'on',
            'best_user' => '',
            'spin_text' => 'disabled',
            'required_words' => '',
			'no_local_image' => '',
            'remove_dollar' => '',
            'banned_words' => '',
            'max_word_content' => '',
            'min_word_content' => '',
            'max_word_title' => '',
            'min_word_title' => '',
            'affiliate_id' => '',
            'links_hide' => '',
			'buy_now' => '',
            'add_cart' => '',
			'rel_nofollow' => '',
            'no_excerpt' => '',
            'auto_update_posts' => 'No',
            'secret_word' => '',
            'apiKey' => '',
            'resize_height' => '',
            'resize_width' => '',
            'source' => '',
            'limit_title' => '',
            'limit_content' => ''
        );
        if ($defaults === FALSE) {
            add_option('amazomatic_Main_Settings', $amazomatic_Main_Settings);
        } else {
            update_option('amazomatic_Main_Settings', $amazomatic_Main_Settings);
        }
    }
}
add_action('wp_loaded', 'amazomatic_run_cron', 0);
function amazomatic_run_cron()
{
    if(isset($_GET['run_amazomatic']))
    {
        $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
        if(isset($amazomatic_Main_Settings['secret_word']) && $amazomatic_Main_Settings['secret_word'] != '')
        {
            if($_GET['run_amazomatic'] == $amazomatic_Main_Settings['secret_word'])
            {
                amazomatic_cron();
                die();
            }
            elseif(preg_match('#' . $amazomatic_Main_Settings['secret_word'] . '_(\d+)_(\d+)#', $_GET['run_amazomatic'], $m))
            {
                if(isset($m[1]) && isset($m[2]))
                {
                    amazomatic_run_rule($m[2], $m[1]);
                    die();
                }
            }
        }
    }
}
function amazomatic_encodeURI($url) {
    $unescaped = array(
        '%2D'=>'-','%5F'=>'_','%2E'=>'.','%21'=>'!', '%7E'=>'~',
        '%2A'=>'*', '%27'=>"'", '%28'=>'(', '%29'=>')'
    );
    $reserved = array(
        '%3B'=>';','%2C'=>',','%2F'=>'/','%3F'=>'?','%3A'=>':',
        '%40'=>'@','%26'=>'&','%3D'=>'=','%2B'=>'+','%24'=>'$'
    );
    $score = array(
        '%23'=>'#'
    );
    return strtr(rawurlencode($url), array_merge($reserved,$unescaped,$score));

}
function amazomatic_url_handle($href)
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if (isset($amazomatic_Main_Settings['links_hide']) && $amazomatic_Main_Settings['links_hide'] == 'on') {
        $cloak_urls = true;
    } else {
        $cloak_urls = false;
    }
    if (isset($amazomatic_Main_Settings['apiKey'])) {
        $apiKey = trim($amazomatic_Main_Settings['apiKey']);
    } else {
        $apiKey = '';
    }
    if ($cloak_urls == true && $apiKey != '') {
        $amazomatic_short_group = get_option('amazomatic_short_group', false);
        $found = false;
        if($amazomatic_short_group !== false)
        {
            $amazomatic_short_group = explode('#', $amazomatic_short_group);
            if(isset($amazomatic_short_group[1]) && $amazomatic_short_group[0] == $apiKey)
            {
                $amazomatic_short_group = $amazomatic_short_group[1];
                $found = true;
            }
        }
        if($found == false)
        {
            $url = 'https://api-ssl.Bitly.com/v4/groups';
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
            curl_setopt($ch, CURLOPT_TIMEOUT, 60);
            $headers = [
                'Authorization: Bearer ' . $apiKey,
                'Accept: application/json',
                'Host: api-ssl.Bitly.com'
            ];
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            $serverOutput = json_decode(curl_exec($ch), true);
            curl_close($ch);
            if(isset($serverOutput['groups'][0]['guid']))
            {
                $amazomatic_short_group = $serverOutput['groups'][0]['guid'];
                update_option('amazomatic_short_group', false);
                $found = true;
            }
        }
        if($found == false)
        {
            return $href;
        }
        $url = 'https://api-ssl.Bitly.com/v4/shorten';
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        $headers = [
            'Authorization: Bearer ' . $apiKey,
            'Content-Type: application/json',
            'Host: api-ssl.Bitly.com'
        ];
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_POST, true);
        $fdata = "";
        $data['long_url'] = trim($href);
        $data['group_guid'] = $amazomatic_short_group;
        $fdata = json_encode($data);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
        $serverOutput = json_decode(curl_exec($ch), true);
        curl_close($ch);
        if (!isset($serverOutput['link']) || $serverOutput['link'] == '') {
            return $href;
        } else {
            return esc_url($serverOutput['link']);
        }  
    } else {
        return $href;
    }
}

function amazomatic_generate_thumbmail( $post_id )
{
    $post = get_post($post_id);
    $post_parent_id = $post->post_parent === 0 ? $post->ID : $post->post_parent;
    if ( has_post_thumbnail($post_parent_id) )
    {
        if ($id_attachment = get_post_thumbnail_id($post_parent_id)) {
            $the_image  = wp_get_attachment_url($id_attachment, false);
            return $the_image;
        }
    }
    $attachments = array_values(get_children(array(
        'post_parent' => $post_parent_id, 
        'post_status' => 'inherit', 
        'post_type' => 'attachment', 
        'post_mime_type' => 'image', 
        'order' => 'ASC', 
        'orderby' => 'menu_order ID') 
    ));
    if( sizeof($attachments) > 0 ) {
        $the_image  = wp_get_attachment_url($attachments[0]->ID, false);
        return $the_image;
    }
    $image_url = amazomatic_extractThumbnail($post->post_content);
    return $image_url;
}
function amazomatic_extractThumbnail($content) {
    $att = amazomatic_getUrls($content);
    if(count($att) > 0)
    {
        foreach($att as $link)
        {
            $mime = amazomatic_get_mime($link);
            if(stristr($mime, "image/") !== FALSE){
                return $link;
            }
        }
    }
    else
    {
        return '';
    }
    return '';
}
function amazomatic_getUrls($string) {
    $regex = '/https?\:\/\/[^\"\' \n\s]+/i';
    preg_match_all($regex, $string, $matches);
    return ($matches[0]);
}
function amazomatic_get_mime ($filename) {
    $mime_types = array(
        'txt' => 'text/plain',
        'htm' => 'text/html',
        'html' => 'text/html',
        'php' => 'text/html',
        'css' => 'text/css',
        'js' => 'application/javascript',
        'json' => 'application/json',
        'xml' => 'application/xml',
        'swf' => 'application/x-shockwave-flash',
        'flv' => 'video/x-flv',
        'png' => 'image/png',
        'jpe' => 'image/jpeg',
        'jpeg' => 'image/jpeg',
        'jpg' => 'image/jpeg',
        'gif' => 'image/gif',
        'bmp' => 'image/bmp',
        'ico' => 'image/vnd.microsoft.icon',
        'tiff' => 'image/tiff',
        'mts' => 'video/mp2t',
        'tif' => 'image/tiff',
        'svg' => 'image/svg+xml',
        'svgz' => 'image/svg+xml',
        'zip' => 'application/zip',
        'rar' => 'application/x-rar-compressed',
        'exe' => 'application/x-msdownload',
        'msi' => 'application/x-msdownload',
        'cab' => 'application/vnd.ms-cab-compressed',
        'mp3' => 'audio/mpeg',
        'qt' => 'video/quicktime',
        'mov' => 'video/quicktime',
        'wmv' => 'video/x-ms-wmv',
        'mp4' => 'video/mp4',
        'm4p' => 'video/m4p',
        'm4v' => 'video/m4v',
        'mpg' => 'video/mpg',
        'mp2' => 'video/mp2',
        'mpe' => 'video/mpe',
        'mpv' => 'video/mpv',
        'm2v' => 'video/m2v',
        'm4v' => 'video/m4v',
        '3g2' => 'video/3g2',
        '3gpp' => 'video/3gpp',
        'f4v' => 'video/f4v',
        'f4p' => 'video/f4p',
        'f4a' => 'video/f4a',
        'f4b' => 'video/f4b',
        '3gp' => 'video/3gp',
        'avi' => 'video/x-msvideo',
        'mpeg' => 'video/mpeg',
        'mpegps' => 'video/mpeg',
        'webm' => 'video/webm',
        'mpeg4' => 'video/mp4',
        'mkv' => 'video/mkv',
        'pdf' => 'application/pdf',
        'psd' => 'image/vnd.adobe.photoshop',
        'ai' => 'application/postscript',
        'eps' => 'application/postscript',
        'ps' => 'application/postscript',
        'doc' => 'application/msword',
        'rtf' => 'application/rtf',
        'xls' => 'application/vnd.ms-excel',
        'ppt' => 'application/vnd.ms-powerpoint',
        'docx' => 'application/msword',
        'xlsx' => 'application/vnd.ms-excel',
        'pptx' => 'application/vnd.ms-powerpoint',
        'odt' => 'application/vnd.oasis.opendocument.text',
        'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
    );
    $ext = array_values(array_slice(explode('.', $filename), -1));$ext = $ext[0];

    if (function_exists('mime_content_type')) {
        $mimetype = mime_content_type($filename);
        if($mimetype == '')
        {
            if (array_key_exists($ext, $mime_types)) {
                return $mime_types[$ext];
            } else {
                return 'application/octet-stream';
            }
        }
        return $mimetype;
    }
    elseif (function_exists('finfo_open')) {
        $finfo = finfo_open(FILEINFO_MIME);
        $mimetype = finfo_file($finfo, $filename);
        finfo_close($finfo);
        if($mimetype === false)
        {
            if (array_key_exists($ext, $mime_types)) {
                return $mime_types[$ext];
            } else {
                return 'application/octet-stream';
            }
        }
        return $mimetype;

    } elseif (array_key_exists($ext, $mime_types)) {
        return $mime_types[$ext];
    } else {
        return 'application/octet-stream';
    }
}



function amazomatic_spin_text($title, $content, $alt = false)
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    $titleSeparator         = '[19459000]';
    $text                   = $title . $titleSeparator . $content;
    $text                   = html_entity_decode($text);
    preg_match_all("/<[^<>]+>/is", $text, $matches, PREG_PATTERN_ORDER);
    $htmlfounds         = array_filter(array_unique($matches[0]));
    $htmlfounds[]       = '&quot;';
    $imgFoundsSeparated = array();
    foreach ($htmlfounds as $key => $currentFound) {
        if (stristr($currentFound, '<img') && stristr($currentFound, 'alt')) {
            $altSeparator   = '';
            $colonSeparator = '';
            if (stristr($currentFound, 'alt="')) {
                $altSeparator   = 'alt="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt = "')) {
                $altSeparator   = 'alt = "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt ="')) {
                $altSeparator   = 'alt ="';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt= "')) {
                $altSeparator   = 'alt= "';
                $colonSeparator = '"';
            } elseif (stristr($currentFound, 'alt=\'')) {
                $altSeparator   = 'alt=\'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt = \'')) {
                $altSeparator   = 'alt = \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt= \'')) {
                $altSeparator   = 'alt= \'';
                $colonSeparator = '\'';
            } elseif (stristr($currentFound, 'alt =\'')) {
                $altSeparator   = 'alt =\'';
                $colonSeparator = '\'';
            }
            if (trim($altSeparator) != '') {
                $currentFoundParts = explode($altSeparator, $currentFound);
                $preAlt            = $currentFoundParts[1];
                $preAltParts       = explode($colonSeparator, $preAlt);
                $altText           = $preAltParts[0];
                if (trim($altText) != '') {
                    unset($preAltParts[0]);
                    $imgFoundsSeparated[] = $currentFoundParts[0] . $altSeparator;
                    $imgFoundsSeparated[] = $colonSeparator . implode('', $preAltParts);
                    $htmlfounds[$key]     = '';
                }
            }
        }
    }
    if (count($imgFoundsSeparated) != 0) {
        $htmlfounds = array_merge($htmlfounds, $imgFoundsSeparated);
    }
    preg_match_all("/<\!--.*?-->/is", $text, $matches2, PREG_PATTERN_ORDER);
    $newhtmlfounds = $matches2[0];
    preg_match_all("/\[.*?\]/is", $text, $matches3, PREG_PATTERN_ORDER);
    $shortcodesfounds = $matches3[0];
    $htmlfounds       = array_merge($htmlfounds, $newhtmlfounds, $shortcodesfounds);
    $in               = 0;
    $cleanHtmlFounds  = array();
    foreach ($htmlfounds as $htmlfound) {
        if ($htmlfound == '[19459000]') {
        } elseif (trim($htmlfound) == '') {
        } else {
            $cleanHtmlFounds[] = $htmlfound;
        }
    }
    $htmlfounds = $cleanHtmlFounds;
    $start      = 19459001;
    foreach ($htmlfounds as $htmlfound) {
        $text = str_replace($htmlfound, '[' . $start . ']', $text);
        $start++;
    }
    try {
        require_once(dirname(__FILE__) . "/res/amazomatic-text-spinner.php");
        $phpTextSpinner = new PhpTextSpinner();
        if ($alt === FALSE) {
            $spinContent = $phpTextSpinner->spinContent($text);
        } else {
            $spinContent = $phpTextSpinner->spinContentAlt($text);
        }
        $translated = $phpTextSpinner->runTextSpinner($spinContent);
    }
    catch (Exception $e) {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('Exception thrown in spinText ' . $e);
        }
        return false;
    }
    preg_match_all('{\[.*?\]}', $translated, $brackets);
    $brackets = $brackets[0];
    $brackets = array_unique($brackets);
    foreach ($brackets as $bracket) {
        if (stristr($bracket, '19')) {
            $corrrect_bracket = str_replace(' ', '', $bracket);
            $corrrect_bracket = str_replace('.', '', $corrrect_bracket);
            $corrrect_bracket = str_replace(',', '', $corrrect_bracket);
            $translated       = str_replace($bracket, $corrrect_bracket, $translated);
        }
    }
    if (stristr($translated, $titleSeparator)) {
        $start = 19459001;
        foreach ($htmlfounds as $htmlfound) {
            $translated = str_replace('[' . $start . ']', $htmlfound, $translated);
            $start++;
        }
        $contents = explode($titleSeparator, $translated);
        $title    = $contents[0];
        $content  = $contents[1];
    } else {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('Failed to parse spinned content, separator not found');
        }
        return false;
    }
    return array(
        $title,
        $content
    );
}


function amazomatic_best_spin_text($title, $content)
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if (!isset($amazomatic_Main_Settings['best_user']) || $amazomatic_Main_Settings['best_user'] == '' || !isset($amazomatic_Main_Settings['best_password']) || $amazomatic_Main_Settings['best_password'] == '') {
        amazomatic_log_to_file('Please insert a valid "The Best Spinner" user name and password.');
        return FALSE;
    }
    $titleSeparator   = '[19459000]';
    $newhtml             = $title . $titleSeparator . $content;
    $url              = 'http://thebestspinner.com/api.php';
    $data             = array();
    $data['action']   = 'authenticate';
    $data['format']   = 'php';
    $data['username'] = $amazomatic_Main_Settings['best_user'];
    $data['password'] = $amazomatic_Main_Settings['best_password'];
    $ch               = curl_init();
    if ($ch === FALSE) {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('Failed to init curl!');
        }
        return FALSE;
    }
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, true);
    $fdata = "";
    foreach ($data as $key => $val) {
        $fdata .= "$key=" . urlencode($val) . "&";
    }
    curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_REFERER, $url);
    $html = curl_exec($ch);
    curl_close($ch);
    if ($html === FALSE) {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('"The Best Spinner" failed to exec curl.');
        }
        return FALSE;
    }
    $output = unserialize($html);
    if ($output['success'] == 'true') {
        $session                = $output['session'];
        $data                   = array();
        $data['session']        = $session;
        $data['format']         = 'php';
        $data['protectedterms'] = '';
        $data['text']           = (html_entity_decode($newhtml));
        $data['action']         = 'replaceEveryonesFavorites';
        $data['maxsyns']        = '50';
        $data['quality']        = '1';
        
        $ch = curl_init();
        if ($ch === FALSE) {
            if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                amazomatic_log_to_file('Failed to init curl');
            }
            return FALSE;
        }
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        $fdata = "";
        foreach ($data as $key => $val) {
            $fdata .= "$key=" . urlencode($val) . "&";
        }
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fdata);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_REFERER, $url);
        $output = curl_exec($ch);
        if ($output === FALSE) {
            if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                amazomatic_log_to_file('"The Best Spinner" failed to exec curl after auth.');
            }
            return FALSE;
        }
        curl_close($ch);
        $output = unserialize($output);
        if ($output['success'] == 'true') {
            $result = explode($titleSeparator, $output['output']);
            if (count($result) < 2) {
                if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                    amazomatic_log_to_file('"The Best Spinner" failed to spin article - titleseparator not found.');
                }
                return FALSE;
            }
            $spintax = new Amazomatic_Spintax();
            $result[0] = $spintax->process($result[0]);
            $result[1] = $spintax->process($result[1]);
            return $result;
        } else {
            if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                amazomatic_log_to_file('"The Best Spinner" failed to spin article.');
            }
            return FALSE;
        }
    } else {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('"The Best Spinner" authentification failed.');
        }
        return FALSE;
    }
}
class Amazomatic_Spintax
{
    public function process($text)
    {
        return stripslashes(preg_replace_callback(
            '/\{(((?>[^\{\}]+)|(?R))*)\}/x',
            array($this, 'replace'),
            preg_quote($text)
        ));
    }
    public function replace($text)
    {
        $text = $this->process($text[1]);
        $parts = explode('|', $text);
        return $parts[array_rand($parts)];
    }
}

function amazomatic_wordai_spin_text($title, $content)
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if (!isset($amazomatic_Main_Settings['best_user']) || $amazomatic_Main_Settings['best_user'] == '' || !isset($amazomatic_Main_Settings['best_password']) || $amazomatic_Main_Settings['best_password'] == '') {
        amazomatic_log_to_file('Please insert a valid "Wordai" user name and password.');
        return FALSE;
    }
    $titleSeparator   = '[19459000]';
    $quality = 'Readable';
    $html             = $title . $titleSeparator . $content;
    $email = $amazomatic_Main_Settings['best_user'];
    $pass = $amazomatic_Main_Settings['best_password'];
    $ch = curl_init('http://wordai.com/users/turing-api.php');
    if($ch === false)
    {
        amazomatic_log_to_file('Failed to init curl in wordai spinning.');
        return FALSE;
    }
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
    curl_setopt ($ch, CURLOPT_POSTFIELDS, "s=$html&quality=$quality&email=$email&pass=$pass&output=json");
    $result = curl_exec($ch);
    curl_close ($ch);
    if ($result === FALSE) {
        amazomatic_log_to_file('"Wordai" failed to exec curl after auth.');
        return FALSE;
    }
    $result = json_decode($result);
    if(!isset($result->text))
    {
        amazomatic_log_to_file('"Wordai" unrecognized response: ' . print_r($result, true));
        return FALSE;
    }
    $result = explode($titleSeparator, $result->text);
    if (count($result) < 2) {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('"Wordai" failed to spin article - titleseparator not found.');
        }
        return FALSE;
    }
    $spintax = new Amazomatic_Spintax();
    $result[0] = $spintax->process($result[0]);
    $result[1] = $spintax->process($result[1]);
    return $result;
}

function amazomatic_spinrewriter_spin_text($title, $content)
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if (!isset($amazomatic_Main_Settings['best_user']) || $amazomatic_Main_Settings['best_user'] == '' || !isset($amazomatic_Main_Settings['best_password']) || $amazomatic_Main_Settings['best_password'] == '') {
        amazomatic_log_to_file('Please insert a valid "SpinRewriter" user name and password.');
        return FALSE;
    }
    $titleSeparator   = '[19459000]';
    $quality = '50';
    $html             = $title . $titleSeparator . $content;
    $html = urlencode($html);
	$data = array();
	$data['email_address'] = $amazomatic_Main_Settings['best_user'];
	$data['api_key'] = $amazomatic_Main_Settings['best_password'];
	$data['action'] = "unique_variation";
	$data['text'] = $html;
	 
	$data['auto_protected_terms'] = "false";					
	$data['confidence_level'] = "high";							
	$data['auto_sentences'] = "true";							
	$data['auto_paragraphs'] = "true";							
	$data['auto_new_paragraphs'] = "false";						
	$data['auto_sentence_trees'] = "false";						
	$data['use_only_synonyms'] = "false";						
	$data['reorder_paragraphs'] = "false";						
	$data['nested_spintax'] = "false";							
    $api_response = amazomatic_spinrewriter_api_post($data);
    if ($api_response === FALSE) {
        amazomatic_log_to_file('"SpinRewriter" failed to exec curl after auth.');
        return FALSE;
    }
    $api_response = json_decode($api_response);
    if(!isset($api_response->response) || !isset($api_response->status) || $api_response->status != 'OK')
    {
        if(isset($api_response->status) && $api_response->status == 'ERROR')
        {
            if(isset($api_response->response) && $api_response->response == 'You can only submit entirely new text for analysis once every 7 seconds.')
            {
                $api_response = amazomatic_spinrewriter_api_post($data);
                if ($api_response === FALSE) {
                    amazomatic_log_to_file('"SpinRewriter" failed to exec curl after auth (after resubmit).');
                    return FALSE;
                }
                $api_response = json_decode($api_response);
                if(!isset($api_response->response) || !isset($api_response->status) || $api_response->status != 'OK')
                {
                    amazomatic_log_to_file('"SpinRewriter" failed to wait and resubmit spinning: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
                    return FALSE;
                }
            }
            else
            {
                amazomatic_log_to_file('"SpinRewriter" error response: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
                return FALSE;
            }
        }
        else
        {
            amazomatic_log_to_file('"SpinRewriter" error response: ' . print_r($api_response, true) . ' params: ' . print_r($data, true));
            return FALSE;
        }
    }
    $api_response->response = urldecode($api_response->response);
    $result = explode($titleSeparator, $api_response->response);
    if (count($result) < 2) {
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('"SpinRewriter" failed to spin article - titleseparator not found: ' . $api_response->response);
        }
        return FALSE;
    }
    return $result;
}
function amazomatic_spinrewriter_api_post($data){
    $data_raw = "";
    
    $GLOBALS['wp_object_cache']->delete('crspinrewriter_spin_time', 'options');
    $spin_time = get_option('crspinrewriter_spin_time', false);
    if($spin_time !== false && is_numeric($spin_time))
    {
        $c_time = time();
        $spassed = $c_time - $spin_time;
        if($spassed < 10 && $spassed >= 0)
        {
            sleep(10 - $spassed);
        }
    }
    update_option('crspinrewriter_spin_time', time());
    
	foreach ($data as $key => $value){
		$data_raw = $data_raw . $key . "=" . urlencode($value) . "&";
	}
	$ch = curl_init();
    if($ch === false)
    {
         return false;
    }
	curl_setopt($ch, CURLOPT_URL, "http://www.spinrewriter.com/action/api");
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data_raw);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
	$response = trim(curl_exec($ch));
	curl_close($ch);
	return $response;
}
function amazomatic_replaceExecludes($article, &$htmlfounds, $opt = false)
{
    $htmlurls = array();$article = preg_replace('{data-image-description="(?:[^\"]*?)"}i', '', $article);
	if($opt === true){
		preg_match_all( "/<a\s[^>]*href=(\"??)([^\" >]*?)\\1[^>]*>(.*?)<\/a>/s" ,$article,$matches,PREG_PATTERN_ORDER);
		$htmlurls=$matches[0];
	}
	$urls_txt = array();
	if($opt === true){
		preg_match_all('/https?:\/\/[^<\s]+/', $article,$matches_urls_txt);
		$urls_txt = $matches_urls_txt[0];
	}
	preg_match_all("/<[^<>]+>/is",$article,$matches,PREG_PATTERN_ORDER);
	$htmlfounds=$matches[0];
	preg_match_all('{\[nospin\].*?\[/nospin\]}s', $article,$matches_ns);
	$nospin = $matches_ns[0];
	$pattern="\[.*?\]";
	preg_match_all("/".$pattern."/s",$article,$matches2,PREG_PATTERN_ORDER);
	$shortcodes=$matches2[0];
	preg_match_all("/<script.*?<\/script>/is",$article,$matches3,PREG_PATTERN_ORDER);
	$js=$matches3[0];
	preg_match_all('/\d{2,}/s', $article,$matches_nums);
	$nospin_nums = $matches_nums[0];
	sort($nospin_nums);
	$nospin_nums = array_reverse($nospin_nums);
	$capped = array();
	if($opt === true){
		preg_match_all("{\b[A-Z][a-z']+\b[,]?}", $article,$matches_cap);
		$capped = $matches_cap[0];
		sort($capped);
		$capped=array_reverse($capped);
	}
	$curly_quote = array();
	if($opt === true){
		preg_match_all('{???.*????}', $article, $matches_curly_txt);
		$curly_quote = $matches_curly_txt[0];
		preg_match_all('{???.*????}', $article, $matches_curly_txt_s);
		$single_curly_quote = $matches_curly_txt_s[0];
		preg_match_all('{&quot;.*?&quot;}', $article, $matches_curly_txt_s_and);
		$single_curly_quote_and = $matches_curly_txt_s_and[0];
		preg_match_all('{&#8220;.*?&#8221}', $article, $matches_curly_txt_s_and_num);
		$single_curly_quote_and_num = $matches_curly_txt_s_and_num[0];
		$curly_quote_regular = array();
		preg_match_all('{".*?"}', $article, $matches_curly_txt_regular);
        $curly_quote_regular = $matches_curly_txt_regular[0];
		$curly_quote = array_merge($curly_quote , $single_curly_quote ,$single_curly_quote_and,$single_curly_quote_and_num,$curly_quote_regular);
	}
	$htmlfounds = array_merge($nospin, $shortcodes, $js, $htmlurls, $htmlfounds, $curly_quote, $urls_txt, $nospin_nums, $capped);
	$htmlfounds = array_filter(array_unique($htmlfounds));
	$i=1;
	foreach($htmlfounds as $htmlfound){
		$article=str_replace($htmlfound,'('.str_repeat('*', $i).')',$article);	
		$i++;
	}
    $article = str_replace(':(*', ': (*', $article);
	return $article;
}
function amazomatic_restoreExecludes($article, $htmlfounds){
	$i=1;
	foreach($htmlfounds as $htmlfound){
		$article=str_replace( '('.str_repeat('*', $i).')', $htmlfound, $article);
		$i++;
	}
	$article = str_replace(array('[nospin]','[/nospin]'), '', $article);
    $article = preg_replace('{\(?\*[\s*]+\)?}', '', $article);
	return $article;
}
function amazomatic_fix_spinned_content($final_content, $spinner)
{
    if ($spinner == 'wordai') {
        $final_content = str_replace('-LRB-', '(', $final_content);
        $final_content = preg_replace("/{\*\|.*?}/", '*', $final_content);
        preg_match_all('/{\)[^}]*\|\)[^}]*}/', $final_content, $matches_brackets);
        $matches_brackets = $matches_brackets[0];
        foreach ($matches_brackets as $matches_bracket) {
            $matches_bracket_clean = str_replace( array('{','}') , '', $matches_bracket);
            $matches_bracket_parts = explode('|',$matches_bracket_clean);
            $final_content = str_replace($matches_bracket, $matches_bracket_parts[0], $final_content);
        }
    }
    elseif ($spinner == 'spinrewriter' || $spinner == 'translate') {
        $final_content = preg_replace('{\(\s(\**?\))\.}', '($1', $final_content);
        $final_content = preg_replace('{\(\s(\**?\))\s\(}', '($1(', $final_content);
        $final_content = preg_replace('{\s(\(\**?\))\.(\s)}', "$1$2", $final_content);
        $final_content = str_replace('( *', '(*', $final_content);
        $final_content = str_replace('* )', '*)', $final_content);
        $final_content = str_replace('& #', '&#', $final_content);
        $final_content = str_replace('& ldquo;', '"', $final_content);
        $final_content = str_replace('& rdquo;', '"', $final_content);
    }
    return $final_content;
}
function amazomatic_spin_and_translate($post_title, $final_content)
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if (isset($amazomatic_Main_Settings['spin_text']) && $amazomatic_Main_Settings['spin_text'] !== 'disabled') {
        $htmlfounds = array();
        $final_content = amazomatic_replaceExecludes($final_content, $htmlfounds, false);
        
        
        if ($amazomatic_Main_Settings['spin_text'] == 'builtin') {
            $translation = amazomatic_builtin_spin_text($post_title, $final_content);
        } elseif ($amazomatic_Main_Settings['spin_text'] == 'wikisynonyms') {
            $translation = amazomatic_spin_text($post_title, $final_content, false);
        } elseif ($amazomatic_Main_Settings['spin_text'] == 'freethesaurus') {
            $translation = amazomatic_spin_text($post_title, $final_content, true);
        } elseif ($amazomatic_Main_Settings['spin_text'] == 'best') {
            $translation = amazomatic_best_spin_text($post_title, $final_content);
        } elseif ($amazomatic_Main_Settings['spin_text'] == 'wordai') {
            $translation = amazomatic_wordai_spin_text($post_title, $final_content);
        } elseif ($amazomatic_Main_Settings['spin_text'] == 'spinrewriter') {
            $translation = amazomatic_spinrewriter_spin_text($post_title, $final_content);
        }
        if ($translation !== FALSE) {
            if (is_array($translation) && isset($translation[0]) && isset($translation[1])) {
                $post_title    = $translation[0];
                $final_content = $translation[1];
                
                $final_content = amazomatic_fix_spinned_content($final_content, $amazomatic_Main_Settings['spin_text']);
                $final_content = amazomatic_restoreExecludes($final_content, $htmlfounds);
                
            } else {
                $final_content = amazomatic_restoreExecludes($final_content, $htmlfounds);
                if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                    amazomatic_log_to_file('Text Spinning failed - malformed data ' . $amazomatic_Main_Settings['spin_text']);
                }
            }
        } else {
            $final_content = amazomatic_restoreExecludes($final_content, $htmlfounds);
            if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                amazomatic_log_to_file('Text Spinning Failed - returned false ' . $amazomatic_Main_Settings['spin_text']);
            }
        }
    }
    if (isset($amazomatic_Main_Settings['translate']) && $amazomatic_Main_Settings['translate'] != 'disabled') {
        if(isset($amazomatic_Main_Settings['translate_source']) && $amazomatic_Main_Settings['translate_source'] != '')
        {
            $tr = $amazomatic_Main_Settings['translate_source'];
        }
        else
        {
            $tr = 'auto';
        }
        $htmlfounds = array();
        $final_content = amazomatic_replaceExecludes($final_content, $htmlfounds, false);
        
        $translation = amazomatic_translate($post_title, $final_content, $tr, $amazomatic_Main_Settings['translate']);
        if (is_array($translation) && isset($translation[1]))
        {
            $translation[1] = preg_replace('#(?<=[\*(])\s+(?=[\*)])#', '', $translation[1]);
            $translation[1] = preg_replace('#([^(*\s]\s)\*+\)#', '$1', $translation[1]);
            $translation[1] = preg_replace('#\(\*+([\s][^)*\s])#', '$1', $translation[1]);
            $translation[1] = amazomatic_restoreExecludes($translation[1], $htmlfounds);
        }
        else
        {
            $final_content = amazomatic_restoreExecludes($final_content, $htmlfounds);
        }
        if ($translation !== FALSE) {
            if (is_array($translation) && isset($translation[0]) && isset($translation[1])) {
                $post_title    = $translation[0];
                $final_content = $translation[1];
                $final_content = str_replace('</ iframe>', '</iframe>', $final_content);
                if(stristr($final_content, '<head>') !== false)
                {
                    $d = new DOMDocument;
                    $mock = new DOMDocument;
                    $internalErrors = libxml_use_internal_errors(true);
                    $d->loadHTML('<?xml encoding="utf-8" ?>' . $final_content);
                    
                    $body = $d->getElementsByTagName('body')->item(0);
                    foreach ($body->childNodes as $child)
                    {
                        $mock->appendChild($mock->importNode($child, true));
                    }
                    $new_post_content_temp = $mock->saveHTML();
                    libxml_use_internal_errors($internalErrors);
                    if($new_post_content_temp !== '' && $new_post_content_temp !== false)
                    {
						$new_post_content_temp = str_replace('<?xml encoding="utf-8" ?>', '', $new_post_content_temp);
                        $final_content = preg_replace("/_addload\(function\(\){([^<]*)/i", "", $new_post_content_temp); 
                    }
                }
                $final_content = htmlspecialchars_decode($final_content, ENT_QUOTES);
                $final_content = str_replace('</ ', '</', $final_content);
                $final_content = str_replace(' />', '/>', $final_content);
                $final_content = str_replace('< br/>', '<br/>', $final_content);
                $final_content = str_replace('< / ', '</', $final_content);
                $final_content = str_replace(' / >', '/>', $final_content);
                $final_content = preg_replace('/[\x00-\x1F\x7F\xA0]/u', '', $final_content);
                $post_title = htmlspecialchars_decode($post_title, ENT_QUOTES);
                $post_title = str_replace('</ ', '</', $post_title);
                $post_title = str_replace(' />', '/>', $post_title);
                $post_title = preg_replace('/[\x00-\x1F\x7F\xA0]/u', '', $post_title);
            } else {
                if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                    amazomatic_log_to_file('Translation failed - malformed data!');
                }
            }
        } else {
            if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                amazomatic_log_to_file('Translation Failed - returned false!');
            }
        }
    }
    return array(
        $post_title,
        $final_content
    );
}

function amazomatic_translate($title, $content, $from, $to)
{
    $ch                     = FALSE;
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    try {
        if($from == 'disabled')
        {
            $from = 'en';
        }
        if($from != 'en' && $from == $to)
        {
            $from = 'en';
        }
        elseif($from == 'en' && $from == $to)
        {
            return false;
        }
        require_once(dirname(__FILE__) . "/res/amazomatic-translator.php");
        $ch = curl_init();
        if ($ch === FALSE) {
            if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
                amazomatic_log_to_file('Failed to init cURL in translator!');
            }
            return false;
        }
        $GoogleTranslator = new GoogleTranslator($ch);
        $translated = '';
        $translated_title = '';
        if($content != '')
        {
            if(strlen($content) > 30000)
            {
                while($content != '')
                {
                    $first30k = substr($content, 0, 30000);
                    $content = substr($content, 30000);
                    $translated_temp       = $GoogleTranslator->translateText($first30k, $from, $to);
                    if (strpos($translated, '<h2>The page you have attempted to translate is already in ') !== false) {
                        throw new Exception('Page content already in ' . $to);
                    }
                    if (strpos($translated, 'Error 400 (Bad Request)!!1') !== false) {
                        throw new Exception('Unexpected error while translating page!');
                    }
                    if(substr_compare($translated_temp, '</pre>', -strlen('</pre>')) === 0){$translated_temp = substr_replace($translated_temp ,"", -6);}if(substr( $translated_temp, 0, 5 ) === "<pre>"){$translated_temp = substr($translated_temp, 5);}
                    $translated .= ' ' . $translated_temp;
                }
            }
            else
            {
                $translated       = $GoogleTranslator->translateText($content, $from, $to);
                if (strpos($translated, '<h2>The page you have attempted to translate is already in ') !== false) {
                    throw new Exception('Page content already in ' . $to);
                }
                if (strpos($translated, 'Error 400 (Bad Request)!!1') !== false) {
                    throw new Exception('Unexpected error while translating page!');
                }
            }
        }
        if($title != '')
        {
            $translated_title = $GoogleTranslator->translateText($title, $from, $to);
        }
        if (strpos($translated_title, '<h2>The page you have attempted to translate is already in ') !== false) {
            throw new Exception('Page title already in ' . $to);
        }
        if (strpos($translated_title, 'Error 400 (Bad Request)!!1') !== false) {
            throw new Exception('Unexpected error while translating page title!');
        }
        curl_close($ch);
    }
    catch (Exception $e) {
        curl_close($ch);
        if (isset($amazomatic_Main_Settings['enable_detailed_logging'])) {
            amazomatic_log_to_file('Exception thrown in GoogleTranslator ' . $e);
        }
        return false;
    }
    if(substr_compare($translated_title, '</pre>', -strlen('</pre>')) === 0){$title = substr_replace($translated_title ,"", -6);}else{$title = $translated_title;}if(substr( $title, 0, 5 ) === "<pre>"){$title = substr($title, 5);}
    if(substr_compare($translated, '</pre>', -strlen('</pre>')) === 0){$text = substr_replace($translated ,"", -6);}else{$text = $translated;}if(substr( $text, 0, 5 ) === "<pre>"){$text = substr($text, 5);}
    $text  = preg_replace('/' . preg_quote('html lang=') . '.*?' . preg_quote('>') . '/', '', $text);
    $text  = preg_replace('/' . preg_quote('!DOCTYPE') . '.*?' . preg_quote('<') . '/', '', $text);
    $text  = preg_replace('#https:\/\/translate\.google\.com\/translate\?hl=en&amp;prev=_t&amp;sl=en&amp;tl=pl&amp;u=([^><"\'\s\n]*)#i', urldecode('$1'), $text);
    return array(
        $title,
        $text
    );
}

function amazomatic_strip_html_tags($str)
{
    $str = html_entity_decode($str);
    $str = preg_replace('/(<|>)\1{2}/is', '', $str);
    $str = preg_replace(array(
        '@<head[^>]*?>.*?</head>@siu',
        '@<style[^>]*?>.*?</style>@siu',
        '@<script[^>]*?.*?</script>@siu',
        '@<noscript[^>]*?.*?</noscript>@siu'
    ), "", $str);
    $str = strip_tags($str);
    return $str;
}

function amazomatic_DOMinnerHTML(DOMNode $element)
{
    $innerHTML = "";
    $children  = $element->childNodes;
    
    foreach ($children as $child) {
        $innerHTML .= $element->ownerDocument->saveHTML($child);
    }
    
    return $innerHTML;
}

function amazomatic_url_exists($url)
{
    stream_context_set_default( [
        'ssl' => [
            'verify_peer' => false,
            'verify_peer_name' => false,
        ],
    ]);
    $headers = get_headers($url);
    if (!isset($headers[0]) || strpos($headers[0], '200') === false)
        return false;
    return true;
}

register_activation_hook(__FILE__, 'amazomatic_check_version');
function amazomatic_check_version()
{
    if (!function_exists('curl_init')) {
        echo '<h3>'.esc_html__('Please enable curl PHP extension. Please contact your hosting provider\'s support to help you in this matter.', 'amazomatic-amazon-post-generator').'</h3>';
        die;
    }
    global $wp_version;
    if (!current_user_can('activate_plugins')) {
        echo '<p>' . sprintf(esc_html__('You are not allowed to activate plugins!', 'amazomatic-amazon-post-generator'), $php_version_required) . '</p>';
        die;
    }
    $php_version_required = '5.0';
    $wp_version_required  = '2.7';
    
    if (version_compare(PHP_VERSION, $php_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a PHP version greater than %1$s. Please update your PHP version before you activate it.', 'amazomatic-amazon-post-generator'), $php_version_required) . '</p>';
        die;
    }
    
    if (version_compare($wp_version, $wp_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a WordPress version greater than %1$s. Please go to Dashboard -> Updates to get the latest version of WordPress.', 'amazomatic-amazon-post-generator'), $wp_version_required) . '</p>';
        die;
    }
}

add_action('admin_init', 'amazomatic_register_mysettings');
function amazomatic_register_mysettings()
{
    amazomatic_cron_schedule();
    register_setting('amazomatic_option_group', 'amazomatic_Main_Settings');
    if (is_multisite()) {
        if (!get_option('amazomatic_Main_Settings')) {
            amazomatic_activation_callback(TRUE);
        }
    }
}

function amazomatic_get_plugin_url()
{
    return plugins_url('', __FILE__);
}

function amazomatic_get_file_url($url)
{
    return esc_url(amazomatic_get_plugin_url() . '/' . $url);
}

function amazomatic_admin_load_files()
{
    wp_register_style('amazomatic-browser-style', plugins_url('styles/amazomatic-browser.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('amazomatic-browser-style');
    wp_register_style('amazomatic-custom-style', plugins_url('styles/coderevolution-style.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('amazomatic-custom-style');
    wp_enqueue_script('jquery');
    wp_enqueue_script('media-upload');
    wp_enqueue_script('thickbox');
    wp_enqueue_style('thickbox');
}

add_action('wp_enqueue_scripts', 'amazomatic_wp_load_files');
function amazomatic_wp_load_files()
{
    wp_enqueue_style('coderevolution-front-css', plugins_url('styles/coderevolution-front.css', __FILE__));
    wp_enqueue_style('amazomatic-thumbnail-css', plugins_url('styles/amazomatic-thumbnail.css', __FILE__));
}

function amazomatic_random_sentence_generator($first = true)
{
    $amazomatic_Main_Settings = get_option('amazomatic_Main_Settings', false);
    if ($first == false) {
        $r_sentences = $amazomatic_Main_Settings['sentence_list2'];
    } else {
        $r_sentences = $amazomatic_Main_Settings['sentence_list'];
    }
    $r_variables = $amazomatic_Main_Settings['variable_list'];
    $r_sentences = trim($r_sentences);
    $r_variables = trim($r_variables, ';');
    $r_variables = trim($r_variables);
    $r_sentences = str_replace("\r\n", "\n", $r_sentences);
    $r_sentences = str_replace("\r", "\n", $r_sentences);
    $r_sentences = explode("\n", $r_sentences);
    $r_variables = str_replace("\r\n", "\n", $r_variables);
    $r_variables = str_replace("\r", "\n", $r_variables);
    $r_variables = explode("\n", $r_variables);
    $r_vars      = array();
    for ($x = 0; $x < count($r_variables); $x++) {
        $var = explode("=>", trim($r_variables[$x]));
        if (isset($var[1])) {
            $key          = strtolower(trim($var[0]));
            $words        = explode(";", trim($var[1]));
            $r_vars[$key] = $words;
        }
    }
    $max_s    = count($r_sentences) - 1;
    $rand_s   = rand(0, $max_s);
    $sentence = $r_sentences[$rand_s];
    $sentence = str_replace(' ,', ',', ucfirst(amazomatic_replace_words($sentence, $r_vars)));
    $sentence = str_replace(' .', '.', $sentence);
    $sentence = str_replace(' !', '!', $sentence);
    $sentence = str_replace(' ?', '?', $sentence);
    $sentence = trim($sentence);
    return $sentence;
}

function amazomatic_get_word($key, $r_vars)
{
    if (isset($r_vars[$key])) {
        
        $words  = $r_vars[$key];
        $w_max  = count($words) - 1;
        $w_rand = rand(0, $w_max);
        return amazomatic_replace_words(trim($words[$w_rand]), $r_vars);
    } else {
        return "";
    }
    
}

function amazomatic_replace_words($sentence, $r_vars)
{
    
    if (str_replace('%', '', $sentence) == $sentence)
        return $sentence;
    
    $words = explode(" ", $sentence);
    
    $new_sentence = array();
    for ($w = 0; $w < count($words); $w++) {
        
        $word = trim($words[$w]);
        
        if ($word != '') {
            if (preg_match('/^%([^%\n]*)$/', $word, $m)) {
                $varkey         = trim($m[1]);
                $new_sentence[] = amazomatic_get_word($varkey, $r_vars);
            } else {
                $new_sentence[] = $word;
            }
        }
    }
    return implode(" ", $new_sentence);
}

function amazomatic_fb_locales()
{
    return array(
        'af_ZA', // Afrikaans
        'ak_GH', // Akan
        'am_ET', // Amharic
        'ar_AR', // Arabic
        'as_IN', // Assamese
        'ay_BO', // Aymara
        'az_AZ', // Azerbaijani
        'be_BY', // Belarusian
        'bg_BG', // Bulgarian
        'bn_IN', // Bengali
        'br_FR', // Breton
        'bs_BA', // Bosnian
        'ca_ES', // Catalan
        'cb_IQ', // Sorani Kurdish
        'ck_US', // Cherokee
        'co_FR', // Corsican
        'cs_CZ', // Czech
        'cx_PH', // Cebuano
        'cy_GB', // Welsh
        'da_DK', // Danish
        'de_DE', // German
        'el_GR', // Greek
        'en_GB', // English (UK)
        'en_IN', // English (India)
        'en_PI', // English (Pirate)
        'en_UD', // English (Upside Down)
        'en_US', // English (US)
        'eo_EO', // Esperanto
        'es_CL', // Spanish (Chile)
        'es_CO', // Spanish (Colombia)
        'es_ES', // Spanish (Spain)
        'es_LA', // Spanish
        'es_MX', // Spanish (Mexico)
        'es_VE', // Spanish (Venezuela)
        'et_EE', // Estonian
        'eu_ES', // Basque
        'fa_IR', // Persian
        'fb_LT', // Leet Speak
        'ff_NG', // Fulah
        'fi_FI', // Finnish
        'fo_FO', // Faroese
        'fr_CA', // French (Canada)
        'fr_FR', // French (France)
        'fy_NL', // Frisian
        'ga_IE', // Irish
        'gl_ES', // Galician
        'gn_PY', // Guarani
        'gu_IN', // Gujarati
        'gx_GR', // Classical Greek
        'ha_NG', // Hausa
        'he_IL', // Hebrew
        'hi_IN', // Hindi
        'hr_HR', // Croatian
        'hu_HU', // Hungarian
        'hy_AM', // Armenian
        'id_ID', // Indonesian
        'ig_NG', // Igbo
        'is_IS', // Icelandic
        'it_IT', // Italian
        'ja_JP', // Japanese
        'ja_KS', // Japanese (Kansai)
        'jv_ID', // Javanese
        'ka_GE', // Georgian
        'kk_KZ', // Kazakh
        'km_KH', // Khmer
        'kn_IN', // Kannada
        'ko_KR', // Korean
        'ku_TR', // Kurdish (Kurmanji)
        'ky_KG', // Kyrgyz
        'la_VA', // Latin
        'lg_UG', // Ganda
        'li_NL', // Limburgish
        'ln_CD', // Lingala
        'lo_LA', // Lao
        'lt_LT', // Lithuanian
        'lv_LV', // Latvian
        'mg_MG', // Malagasy
        'mi_NZ', // Maori
        'mk_MK', // Macedonian
        'ml_IN', // Malayalam
        'mn_MN', // Mongolian
        'mr_IN', // Marathi
        'ms_MY', // Malay
        'mt_MT', // Maltese
        'my_MM', // Burmese
        'nb_NO', // Norwegian (bokmal)
        'nd_ZW', // Ndebele
        'ne_NP', // Nepali
        'nl_BE', // Dutch (Belgi??)
        'nl_NL', // Dutch
        'nn_NO', // Norwegian (nynorsk)
        'ny_MW', // Chewa
        'or_IN', // Oriya
        'pa_IN', // Punjabi
        'pl_PL', // Polish
        'ps_AF', // Pashto
        'pt_BR', // Portuguese (Brazil)
        'pt_PT', // Portuguese (Portugal)
        'qu_PE', // Quechua
        'rm_CH', // Romansh
        'ro_RO', // Romanian
        'ru_RU', // Russian
        'rw_RW', // Kinyarwanda
        'sa_IN', // Sanskrit
        'sc_IT', // Sardinian
        'se_NO', // Northern S??mi
        'si_LK', // Sinhala
        'sk_SK', // Slovak
        'sl_SI', // Slovenian
        'sn_ZW', // Shona
        'so_SO', // Somali
        'sq_AL', // Albanian
        'sr_RS', // Serbian
        'sv_SE', // Swedish
        'sy_SY', // Swahili
        'sw_KE', // Syriac
        'sz_PL', // Silesian
        'ta_IN', // Tamil
        'te_IN', // Telugu
        'tg_TJ', // Tajik
        'th_TH', // Thai
        'tk_TM', // Turkmen
        'tl_PH', // Filipino
        'tl_ST', // Klingon
        'tr_TR', // Turkish
        'tt_RU', // Tatar
        'tz_MA', // Tamazight
        'uk_UA', // Ukrainian
        'ur_PK', // Urdu
        'uz_UZ', // Uzbek
        'vi_VN', // Vietnamese
        'wo_SN', // Wolof
        'xh_ZA', // Xhosa
        'yi_DE', // Yiddish
        'yo_NG', // Yoruba
        'zh_CN', // Simplified Chinese (China)
        'zh_HK', // Traditional Chinese (Hong Kong)
        'zh_TW', // Traditional Chinese (Taiwan)
        'zu_ZA', // Zulu
        'zz_TR' // Zazaki
    );
}
function amazomatic_language_keys()
{
    return array(
        'af', // Afrikaans
        'ak', // Akan
        'am', // Amharic
        'ar', // Arabic
        'as', // Assamese
        'ay', // Aymara
        'az', // Azerbaijani
        'be', // Belarusian
        'bg', // Bulgarian
        'bn', // Bengali
        'br', // Breton
        'bs', // Bosnian
        'ca', // Catalan
        'cb', // Sorani Kurdish
        'ck', // Cherokee
        'co', // Corsican
        'cs', // Czech
        'cx', // Cebuano
        'cy', // Welsh
        'da', // Danish
        'de', // German
        'el', // Greek
        'en', // English (UK)
        'en', // English (India)
        'en', // English (Pirate)
        'en', // English (Upside Down)
        'en', // English (US)
        'eo', // Esperanto
        'es', // Spanish (Chile)
        'es', // Spanish (Colombia)
        'es', // Spanish (Spain)
        'es', // Spanish
        'es', // Spanish (Mexico)
        'es', // Spanish (Venezuela)
        'et', // Estonian
        'eu', // Basque
        'fa', // Persian
        'fb', // Leet Speak
        'ff', // Fulah
        'fi', // Finnish
        'fo', // Faroese
        'fr', // French (Canada)
        'fr', // French (France)
        'fy', // Frisian
        'ga', // Irish
        'gl', // Galician
        'gn', // Guarani
        'gu', // Gujarati
        'gx', // Classical Greek
        'ha', // Hausa
        'he', // Hebrew
        'hi', // Hindi
        'hr', // Croatian
        'hu', // Hungarian
        'hy', // Armenian
        'id', // Indonesian
        'ig', // Igbo
        'is', // Icelandic
        'it', // Italian
        'ja', // Japanese
        'ja', // Japanese (Kansai)
        'jv', // Javanese
        'ka', // Georgian
        'kk', // Kazakh
        'km', // Khmer
        'kn', // Kannada
        'ko', // Korean
        'ku', // Kurdish (Kurmanji)
        'ky', // Kyrgyz
        'la', // Latin
        'lg', // Ganda
        'li', // Limburgish
        'ln', // Lingala
        'lo', // Lao
        'lt', // Lithuanian
        'lv', // Latvian
        'mg', // Malagasy
        'mi', // Maori
        'mk', // Macedonian
        'ml', // Malayalam
        'mn', // Mongolian
        'mr', // Marathi
        'ms', // Malay
        'mt', // Maltese
        'my', // Burmese
        'nb', // Norwegian (bokmal)
        'nd', // Ndebele
        'ne', // Nepali
        'nl', // Dutch (Belgi??)
        'nl', // Dutch
        'nn', // Norwegian (nynorsk)
        'ny', // Chewa
        'or', // Oriya
        'pa', // Punjabi
        'pl', // Polish
        'ps', // Pashto
        'pt', // Portuguese (Brazil)
        'pt', // Portuguese (Portugal)
        'qu', // Quechua
        'rm', // Romansh
        'ro', // Romanian
        'ru', // Russian
        'rw', // Kinyarwanda
        'sa', // Sanskrit
        'sc', // Sardinian
        'se', // Northern S??mi
        'si', // Sinhala
        'sk', // Slovak
        'sl', // Slovenian
        'sn', // Shona
        'so', // Somali
        'sq', // Albanian
        'sr', // Serbian
        'sv', // Swedish
        'sy', // Swahili
        'sw', // Syriac
        'sz', // Silesian
        'ta', // Tamil
        'te', // Telugu
        'tg', // Tajik
        'th', // Thai
        'tk', // Turkmen
        'tl', // Filipino
        'tl', // Klingon
        'tr', // Turkish
        'tt', // Tatar
        'tz', // Tamazight
        'uk', // Ukrainian
        'ur', // Urdu
        'uz', // Uzbek
        'vi', // Vietnamese
        'wo', // Wolof
        'xh', // Xhosa
        'yi', // Yiddish
        'yo', // Yoruba
        'zh', // Simplified Chinese (China)
        'zh', // Traditional Chinese (Hong Kong)
        'zh', // Traditional Chinese (Taiwan)
        'zu', // Zulu
        'zz' // Zazaki
    );
    
}

require(dirname(__FILE__) . "/res/amazomatic-main.php");
require(dirname(__FILE__) . "/res/amazomatic-rules-list.php");
require(dirname(__FILE__) . "/res/amazomatic-item-list.php");
require(dirname(__FILE__) . "/res/amazomatic-lookup-list.php");
require(dirname(__FILE__) . "/res/amazomatic-help.php");
require(dirname(__FILE__) . "/res/amazomatic-logs.php");
?>